2013-06-14 10:18  castaglia

	* contrib/dist/rpm/proftpd.spec:
	  Updating .spec file for release of 1.3.4d.

2013-06-14 10:01  castaglia

	* RELEASE_NOTES:
	  Updating release notes for 1.3.4d.

2013-06-14 09:56  castaglia

	* RELEASE_NOTES:
	  Fleshed out release notes for 1.3.5rc3.

2013-06-14 09:54  castaglia

	* doc/howto/SQL.html:
	  Adding section on using the SQL PrimaryKey directives to the
	  howto.

2013-06-14 09:21  castaglia

	* doc/contrib/mod_sql.html:
	  Add descriptions for the SQLUserPrimaryKey, SQLGroupPrimaryKey
	  directives added for Bug#3864.

2013-06-10 10:13  castaglia

	* doc/contrib/mod_sql_passwd.html:
	  Update SQLPasswordPBKDF2 docs to mention use of non-SHA1 digests
	  requires OpenSSL-1.0.0c and later.

2013-06-10 10:12  castaglia

	* contrib/mod_sql_passwd.c:
	  Allow use of PBKDF2 passwords in mod_sql_passwd for OpenSSL
	  versions older than 1.0.0c, as long as the configured PBKDF2
	  digest algorithm is SHA1.

2013-06-10 09:06  castaglia

	* doc/modules/mod_rlimit.html:
	  Removed docs for now-obsolete RLimitProcesses directive.

2013-06-10 09:05  castaglia

	* NEWS, modules/mod_rlimit.c:
	  Bug#3941 - RLimitProcesses causes problems with setuid/setreuid.

	  Remove the RLimitProcesses and setrlimit(RLIMIT_NPROC) code; it
	  was causing more problems (due to setuid(2) tricks) than it
	  solved.

2013-06-07 14:57  castaglia

	* RELEASE_NOTES, doc/contrib/mod_sql_passwd.html:
	  Add documentation for the new PBKDF2 support.

2013-06-07 14:41  castaglia

	* NEWS, contrib/mod_sql_passwd.c,
	  tests/t/lib/ProFTPD/Tests/Modules/mod_sql_passwd.pm:
	  Bug#3943 - Support for PBKDF2 passwords in mod_sql_passwd.

2013-06-06 16:55  castaglia

	* NEWS, contrib/mod_sftp_sql.c:
	  Bug#3942 - mod_sftp_sql should support multiple keys concatenated
	  together in a single column.

2013-06-06 16:52  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_sftp_sql.pm:
	  Adding regression test for Bug#3942.

2013-06-06 16:39  castaglia

	* doc/contrib/mod_sftp.html:
	  Adding another mod_sftp FAQ.

2013-06-06 16:18  castaglia

	* contrib/: mod_load/Makefile.in, mod_sftp/Makefile.in,
	  mod_wrap2/Makefile.in:
	  Updating several contrib module Makefiles to clean up properly
	  after themselves when doing a 'make clean'.

2013-06-06 13:26  castaglia

	* src/rlimit.c:
	  If both current and max are NULL pointers, then return EINVAL; no
	  need to proceed further.

2013-06-06 09:45  castaglia

	* contrib/mod_sftp/rfc4716.c:
	  Comment nit; no functional change.

2013-06-05 20:30  castaglia

	* contrib/mod_load/Makefile.in:
	  Try to bring the mod_load Makefile back up to spec, to properly
	  clean out the .la, .lo files, and libs/ directory.

2013-06-05 09:02  castaglia

	* modules/mod_dso.c:
	  Handle a LoadModule module name with ".cpp" extension, in
	  addition to ".c", for loading e.g. C++ modules.

2013-06-03 11:07  castaglia

	* contrib/mod_sftp/umac.c:
	  Bug#3940 - Compiler warnings in mod_sftp.

	  Fixed -Wstrict-aliasing warnings in umac.c.

2013-05-31 14:44  castaglia

	* RELEASE_NOTES:
	  Working on fleshing out release notes; still need to do more.

2013-05-28 14:04  castaglia

	* NEWS, modules/mod_ctrls.c, src/ctrls.c:
	  Backport of fix for Bug#3939 to 1.3.4 branch.

2013-05-28 14:02  castaglia

	* NEWS, modules/mod_ctrls.c, src/ctrls.c:
	  Bug#3939 - Disable Controls for "ServerType inetd" servers.

2013-05-23 08:43  castaglia

	* doc/howto/Limit.html:
	  Add section about using multiple <Limit LOGIN> sections to the
	  Limit howto.

2013-05-23 08:36  castaglia

	* tests/t/lib/ProFTPD/Tests/Config/Limit/LOGIN.pm:
	  Adding <Limit LOGIN> test showing what happens when multiple such
	  sections appear in the same vhost config (answer: last one wins).

2013-05-17 10:16  castaglia

	* doc/howto/SQL.html:
	  Add SQLNamedConnectInfo recipe to SQL howto.

2013-05-17 08:04  castaglia

	* doc/modules/: mod_ctrls.html:
	  Copy-pasto.

2013-05-16 11:33  castaglia

	* tests/t/lib/ProFTPD/Tests/Commands/LIST.pm:
	  Adding regression test for LIST for relative symlinks where
	  target path contains double-slashes (regression caused by fix for
	  Bug#3719).

2013-05-16 10:07  castaglia

	* NEWS, RELEASE_NOTES:
	  Mention addition of mod_snmp in release docs.

2013-05-15 08:27  castaglia

	* tests/: tests.pl, t/lib/ProFTPD/Tests/Modules/mod_snmp.pm,
	  t/modules/mod_snmp.t:
	  Adding the mod_snmp testsuite.

2013-05-15 08:21  castaglia

	* doc/contrib/: index.html, mod_snmp.html:
	  Adding mod_snmp documentation.

2013-05-15 08:01  castaglia

	* .cvsignore:
	  Ignore any .git/ directories and .gitignore files which may show
	  up.

2013-05-14 09:41  castaglia

	* src/auth.c:
	  When caching the UID based on a name, use the name that's been
	  retrieved from the source, rather than the lookup key name.  In
	  the case of e.g.  SQL table lookups, the lookup key might be
	  different from the returned official name.  We need to use the
	  official name, since that is what would be used later for
	  name-to-ID lookups.

2013-05-12 16:13  castaglia

	* doc/contrib/mod_wrap2_sql.html:
	  Include indexes (for performance) in the example schema.

2013-05-08 22:28  castaglia

	* doc/howto/Memcache.html:
	  Adding another memcache-related FAQ.

2013-05-08 22:21  castaglia

	* doc/howto/: Memcache.html, index.html:
	  Adding a howto for Memcache support in proftpd.

2013-05-08 21:19  castaglia

	* doc/howto/Logging.html:
	  Add a wtmp log-related FAQ to the Logging howto.

2013-05-08 21:09  castaglia

	* doc/howto/Logging.html:
	  No need to direct SystemLog to /dev/null to disable logging;
	  simply setting "SystemLog none" is enough.

2013-05-08 20:58  castaglia

	* doc/modules/mod_dso.html:
	  Adding mod_dso FAQ encountered on the proftp-user mailing list
	  today.

2013-05-08 14:43  castaglia

	* NEWS, contrib/mod_ldap.c:
	  Backport of fix for Bug#3937 to 1.3.4 branch.

2013-05-08 14:43  castaglia

	* NEWS, contrib/mod_ldap.c:
	  Bug#3937 - Segfault when retrieving SSH public key from LDAP
	  directory.

2013-05-06 22:11  castaglia

	* doc/modules/mod_memcache.html:
	  Mention that the MemcacheServers directive handles Unix domain
	  socket paths as well (per Bug#3931).

2013-05-06 21:53  castaglia

	* contrib/mod_ban.c:
	  Typo which broke the BanCache directive's memcache functionality.

2013-05-06 15:11  castaglia

	* NEWS, modules/mod_ctrls.c:
	  Backport of fix for Bug#3927 to 1.3.4 branch.

2013-05-06 15:11  castaglia

	* NEWS, modules/mod_ctrls.c:
	  Bug#3927 - Default ControlsSocket created despite custom
	  ControlsSocket path.

2013-05-06 09:22  castaglia

	* contrib/mod_sftp/: scp.c:
	  Fix comment from bad patching.

2013-05-06 09:19  castaglia

	* NEWS, contrib/mod_sftp/scp.c:
	  Backport of fix for Bug#3935 to 1.3.4 branch.

2013-05-06 09:18  castaglia

	* NEWS, contrib/mod_sftp/scp.c:
	  Bug#3935 - scp download of nonexistent file results in client
	  hang.

2013-05-06 09:16  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_sftp.pm:
	  Adding regression test for Bug#3935, or at least one of its
	  manifestations.  Also cleaned up some minor styling.

2013-05-03 09:32  castaglia

	* NEWS, modules/mod_core.c, src/dirtree.c:
	  Bug#3934 - HideUser/HideGroup do not work as expected for virtual
	  users.

2013-05-03 09:31  castaglia

	* tests/t/lib/ProFTPD/Tests/Config/: HideGroup.pm, HideUser.pm:
	  Adding regression tests for Bug#3934 (HideUser/HideGroup not
	  working for virtual users).

2013-04-30 10:04  castaglia

	* configure:
	  Updated configure.

2013-04-30 10:01  castaglia

	* config.h.in, configure.in:
	  As part of fixing Bug#3932, we need to backport some of the
	  autoconf checks for MySQL's "scrambled password" APIs to the
	  1.3.4 branch.

2013-04-30 09:10  castaglia

	* NEWS, contrib/mod_sql_mysql.c:
	  Backport of fix for Bug#3932 to 1.3.4 branch.

2013-04-30 09:09  castaglia

	* NEWS, contrib/mod_sql_mysql.c:
	  Bug#3932 - SQLAuthType Backend returns "password mismatch" for
	  MySQL PASSWORD().

2013-04-30 09:00  castaglia

	* NEWS, modules/mod_auth_pam.c:
	  Backported fix for Bug#3929 to 1.3.4 branch.

2013-04-30 09:00  castaglia

	* NEWS, modules/mod_auth_pam.c:
	  Bug#3929 - pam_session_close() requires root privs on some
	  platforms.

2013-04-23 16:25  castaglia

	* contrib/: ftpasswd, ftpquota:
	  Use env in the shebang line, rather than assuming the location of
	  perl to use.

2013-04-23 16:14  castaglia

	* src/proftpd.8.in:
	  Incorporating doc patch from FreeBSD ports tree.

2013-04-23 16:12  castaglia

	* src/wtmp.c:
	  Incorporating patch from FreeBSD ports tree.

2013-04-23 15:37  castaglia

	* src/auth.c:
	  Typo.

2013-04-23 08:20  castaglia

	* src/var.c:
	  Backported typecast changes/fixes from trunk.

2013-04-23 08:20  castaglia

	* src/var.c:
	  Removed unnecessary typecast.

2013-04-23 08:18  castaglia

	* src/auth.c:
	  Backported compiler warning fixes from trunk.

2013-04-23 08:18  castaglia

	* src/auth.c:
	  Quell compiler warnings on some platforms/compilers about
	  signature mismatches via typecasting.

2013-04-23 08:14  castaglia

	* modules/mod_delay.c, src/inet.c:
	  Forgot to update copyright years.

2013-04-23 08:13  castaglia

	* modules/mod_delay.c, src/inet.c, src/netaddr.c:
	  Better handling of getnameinfo(3) errors, early during a
	  connection lifetime.

2013-04-16 12:58  castaglia

	* modules/mod_delay.c, src/inet.c, src/netaddr.c:
	  If getaddrinfo(3) fails for a new connection, make sure the
	  connection fails quickly, rather than proceeding further (and
	  getting into a state where it is never terminated).

2013-04-16 09:37  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_sftp.pm:
	  SFTP regression test for HideFiles and symlinks (Bug#3924).

2013-04-16 09:35  castaglia

	* src/dirtree.c:
	  Minor tweak to dir_hide_file(), needed for Bug#3924 (and SFTP
	  directory listings, specifically).

2013-04-16 09:04  castaglia

	* NEWS, modules/mod_facts.c, modules/mod_ls.c, src/dirtree.c:
	  Bug#3924 - HideFiles does not filter symlinks.

2013-04-16 09:03  castaglia

	* tests/t/lib/ProFTPD/Tests/Config/HideFiles.pm:
	  Adding regression tests for Bug#3924.

2013-04-15 09:14  castaglia

	* contrib/mod_sftp/fxp.h:
	  Missing checkin for Bug#3926; this fixes the CVS build.

2013-04-12 07:13  castaglia

	* doc/contrib/mod_sftp.html:
	  Fix up the SFTPAuthorizedUserKeys directive description.

2013-04-11 11:35  castaglia

	* doc/contrib/mod_sftp.html:
	  Adding FAQ to mod_sftp docs about localised directory listings,
	  from Bug#3925.

2013-04-11 11:29  castaglia

	* NEWS, modules/mod_core.c:
	  Backporting fix for Bug#3925 to 1.3.4 branch.

2013-04-11 11:28  castaglia

	* NEWS, modules/mod_core.c:
	  Bug#3925 - SFTP directory listings are sensitive to locale
	  environment variables.

2013-04-10 21:39  castaglia

	* RELEASE_NOTES, doc/contrib/mod_sftp.html:
	  Update mod_sftp docs with mention of support for the fsync
	  extension.

2013-04-10 21:37  castaglia

	* NEWS, contrib/mod_sftp/fxp.c, contrib/mod_sftp/mod_sftp.c:
	  Bug#3926 - Support OpenSSH fsync SFTP extension.

2013-04-09 22:28  castaglia

	* contrib/mod_sftp/fxp.c:
	  Fix the length of the strings compared for the OpenSSH extensions
	  in SFTP EXTENDED requests.

2013-04-05 11:41  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_sql_sqlite.pm:
	  Collect all the common code for building the SQLite db into a
	  function.  Add test showing that just changing the table name for
	  SQLUserInfo/SQLGroupInfo directives works as expected.

2013-04-03 09:49  castaglia

	* modules/mod_rlimit.c:
	  Correct the bug number in the comment.

2013-04-03 09:48  castaglia

	* modules/mod_cap.c:
	  Slightly better error message when setreuid(2) fails.

2013-04-03 09:47  castaglia

	* NEWS, modules/mod_rlimit.c:
	  Bug#3923 - mod_cap does not revoke root privileges properly for
	  SFTP connections.

2013-04-03 09:46  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_cap.pm:
	  Adding regression test for Bug#3923.

2013-03-29 13:47  castaglia

	* tests/t/lib/ProFTPD/Tests/Config/Directory/Limits.pm:
	  Adding more regression tests for <Directory> + <Limit> configs.

2013-03-29 10:25  castaglia

	* configure:
	  Updated configure.

2013-03-29 10:19  castaglia

	* config.h.in, configure.in, contrib/mod_sql_mysql.c:
	  Improve on the detection of MySQL's "scrambled password" API (for
	  implementing the "Backend" SQLAuthType for MySQL servers), based
	  on a patch from Bernd Lommerzheim.

2013-03-29 09:29  castaglia

	* contrib/mod_sftp/auth-kbdint.c:
	  Include explanatory comment about the errno value and Bug#3921.

2013-03-28 16:02  castaglia

	* NEWS, contrib/mod_sftp/auth-kbdint.c:
	  Bug#3921 - Single failed keyboard-interactive login attempt
	  causes SSH connection to close prematurely.

2013-03-28 16:01  castaglia

	* tests/: tests.pl, t/lib/ProFTPD/Tests/Modules/mod_sftp_pam.pm,
	  t/modules/mod_sftp_pam.t:
	  Start working on regression tests for the mod_sftp_pam module, in
	  light of Bug#3921.

2013-03-28 13:56  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_sftp.pm:
	  Adding regression test for the umac-64@openssh.com support added
	  for Bug#3920.

2013-03-28 13:31  castaglia

	* contrib/mod_sftp/mac.c:
	  Typo.  Sigh.

2013-03-28 13:29  castaglia

	* contrib/mod_sftp/mac.c:
	  Properly free up the allocated UMAC context objects when e.g.
	  unloading mod_sftp (part of Bug#3920).

2013-03-28 13:01  castaglia

	* contrib/mod_sftp/mod_sftp.c:
	  Need to include the mac.h header now, to avoid compiler warnings
	  about unknown functions.

2013-03-28 12:56  castaglia

	* contrib/mod_sftp/: msg.c, msg.h:
	  Forgot to commit these changes for Bug#3920.

2013-03-28 11:50  castaglia

	* doc/contrib/mod_sftp.html:
	  Update the mod_sftp docs to reflect supporting
	  umac-64@openssh.com.

2013-03-28 11:48  castaglia

	* NEWS, contrib/mod_sftp/Makefile.in, contrib/mod_sftp/crypto.c,
	  contrib/mod_sftp/fxp.c, contrib/mod_sftp/mac.c,
	  contrib/mod_sftp/mac.h, contrib/mod_sftp/mod_sftp.c,
	  contrib/mod_sftp/umac.c, contrib/mod_sftp/umac.h:
	  Bug#3920 - Support umac-64@openssh.com digest for mod_sftp.

2013-03-21 15:38  castaglia

	* tests/t/lib/ProFTPD/Tests/Config/Limit/LOGIN.pm:
	  Adding regression test showing that proftpd correctly handles
	  group names that contain backslashes in them.

2013-03-20 11:24  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_sql_sqlite.pm:
	  Clean up the SQLite script once we're done with it.

2013-03-15 21:47  castaglia

	* doc/modules/mod_log.html:
	  Bug#3864 added support for (among other things) a %g LogFormat
	  variable; updated the LogFormat docs accordingly.

2013-03-15 21:46  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_sql_sqlite.pm:
	  Adding regression tests for the SQL PrimaryKey directives added
	  for Bug#3864.

2013-03-15 21:45  castaglia

	* NEWS, RELEASE_NOTES, contrib/mod_sql.c, modules/mod_log.c:
	  Bug#3864 - Support SQL query to lookup/use primary key for
	  logged-in user/group.

2013-03-14 19:35  castaglia

	* contrib/mod_sftp/crypto.c:
	  Quell compiler warnings (Bug#3919) caused by changes in callback
	  signatures between OpenSSL-0.9.x and OpenSSL-1.0.x.  Since the
	  latter now has ABI compatibility rules, it will become more
	  widespread, and thus we will change our callbacks to match the
	  newer signatures.  This will cause compiler warnings about
	  mismatched signatures for older OpenSSL installations, but that
	  is the price of keeping up to date.

2013-03-14 17:05  castaglia

	* doc/howto/KeepAlives.html:
	  Minor grammar fixes.

2013-03-14 14:59  castaglia

	* contrib/mod_sftp/keys.c:
	  Make the SFTPLog a little less spammy by moving some of the
	  logged messages (e.g. about which paths are used as host keys)
	  into trace logging.

2013-03-14 14:51  castaglia

	* NEWS, contrib/mod_sftp/interop.c, contrib/mod_sftp/mod_sftp.c,
	  src/regexp.c:
	  Backport of fix for Bug#3918 to 1.3.4 branch.

2013-03-14 14:49  castaglia

	* NEWS, contrib/mod_sftp/interop.c, contrib/mod_sftp/mod_sftp.c,
	  src/regexp.c:
	  Bug#3918 - mod_sftp segfault after SIGHUP when evaluating client
	  banner.

2013-03-14 14:47  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_sftp.pm:
	  Adding regression test for Bug#3918.

2013-03-13 11:08  castaglia

	* doc/modules/mod_xfer.html:
	  Updating DeleteAbortedStores doc per Bug#3917.

2013-03-13 11:05  castaglia

	* NEWS, contrib/mod_sftp/fxp.c, modules/mod_xfer.c:
	  Bug#3917 - Make DeleteAbortedStores on by default when
	  HiddenStores enabled.

2013-03-13 10:57  castaglia

	* tests/t/lib/ProFTPD/Tests/Config/DeleteAbortedStores.pm:
	  Adding regression test for Bug#3917.

2013-03-13 10:18  castaglia

	* tests/t/lib/ProFTPD/Tests/Config/Directory/Limits.pm:
	  Adding another regression test for Bug#3915.

2013-03-11 18:45  castaglia

	* doc/howto/TLS.html:
	  Include the error message frequently seen on the client end of
	  things in the FAQ about NoSessionReuseRequired.

2013-03-11 18:42  castaglia

	* doc/howto/TLS.html:
	  Add TLS FAQ about data transfers and the NoSessionReuseRequired
	  TLSOption.

2013-03-08 16:43  castaglia

	* tests/t/lib/ProFTPD/Tests/Config/Directory/Limits.pm:
	  Adding regression test for Bug#3915.

2013-03-08 11:45  castaglia

	* NEWS, src/fsio.c:
	  Bug#3914 - 1.3.5rc2 fails to build on Solaris 10.

2013-03-08 10:21  castaglia

	* contrib/mod_sftp/msg.c:
	  Quell compiler (and static code analysi) warnings (Bu#3912).

2013-03-08 08:32  castaglia

	* modules/mod_auth_unix.c:
	  Handle potential NULL return value from getpwnam(3) better.
	  Stylistic nits.

2013-03-08 08:25  castaglia

	* utils/ftptop.c:
	  Replace strcat(3) with snprintf(3).  Not as much of a concern for
	  overflows given that ftptop is not a setuid process, but still,
	  it's a good habit to get into.

2013-03-08 08:22  castaglia

	* contrib/mod_sftp/packet.c:
	  Don't fire the 'ssh2.netio-write' event until after we've
	  determined that the socket is writable.  And if the socket is NOT
	  writable, then clear the iovec array before returning.

2013-03-07 16:12  castaglia

	* contrib/mod_sql_mysql.c:
	  Add comment about known compiler warning about "implicit function
	  declaration" (Bug#3908).

2013-03-07 16:00  castaglia

	* NEWS, modules/mod_auth.c:
	  Bug#3910 - Clang's scan-build warns on set[u][g]id unchecked
	  return value.

2013-03-07 09:19  castaglia

	* configure:
	  Updated configure.

2013-03-07 09:15  castaglia

	* configure.in:
	  Enable a few more gcc warning flags, if supported, when
	  --enable-devel is used.

2013-03-07 09:03  castaglia

	* NEWS, src/netaddr.c:
	  Bug#3909 - Build fails with --disable-ipv6.

2013-03-07 07:04  castaglia

	* contrib/mod_log_forensic.c:
	  Quell more compiler warnings (Bug#3908).

2013-03-06 16:54  castaglia

	* contrib/mod_sql_mysql.c:
	  Trying to quell compiler warnings (Bug#3908).

2013-03-06 16:50  castaglia

	* contrib/mod_log_forensic.c:
	  Quell compiler warnings (Bug#3908).

2013-03-06 16:46  castaglia

	* src/fsio.c:
	  Quell compiler warnings (Bug#3908).

2013-03-06 12:02  castaglia

	* include/version.h:
	  Bump version for CVS.

2013-03-06 12:01  castaglia

	* include/version.h:
	  Bump version for next maint release.

2013-03-06 11:06  castaglia

	* ChangeLog:
	  Updated ChangeLog.

2013-03-06 11:05  castaglia

	* locale/files.txt:
	  Updated list of files for localization.

2013-03-06 11:04  castaglia

	* NEWS:
	  Update NEWS with release date.

2013-03-06 11:03  castaglia

	* contrib/dist/rpm/proftpd.spec, include/version.h:
	  Preparing for release of proftpd-1.3.5rc2.

2013-03-06 11:00  castaglia

	* contrib/mod_log_forensic.c:
	  Quell compiler warning.

2013-03-06 10:16  castaglia

	* ChangeLog:
	  Updated ChangeLog.

2013-03-06 10:02  castaglia

	* NEWS:
	  Updating NEWS with release date.

2013-03-06 10:01  castaglia

	* contrib/dist/rpm/proftpd.spec:
	  Updating specfile version for proftpd-1.3.4c release.

2013-03-06 09:55  castaglia

	* RELEASE_NOTES:
	  Updating release notes for proftpd-1.3.5rc2.

2013-03-06 09:45  castaglia

	* doc/contrib/mod_tls.html:
	  Adding description of the new TLSUserName directive to the
	  mod_tls docs.

2013-03-06 09:33  castaglia

	* doc/contrib/mod_tls.html:
	  Document that TLSSessionCache can be configured with a parameter
	  of "off".

2013-03-06 09:30  castaglia

	* doc/modules/mod_xfer.html:
	  Mention the optional suffix parameter in the HiddenStores
	  synopsis.

2013-03-06 09:26  castaglia

	* doc/modules/mod_auth_file.html:
	  Adding discussion of the stricter permission checks now done by
	  mod_auth_file.

2013-03-06 09:07  castaglia

	* RELEASE_NOTES:
	  Updated release notes for proftpd-1.3.4c.

2013-03-05 23:34  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_lang.pm:
	  Adding regression test showing conversion from ISO-8859-1
	  client-side charset to UTF-8 server-side charset.

2013-03-01 12:06  castaglia

	* RELEASE_NOTES, doc/contrib/mod_ban.html:
	  Updating docs for new TLSHandshake BanOnEvent rule.

2013-03-01 11:57  castaglia

	* NEWS, RELEASE_NOTES, contrib/mod_ban.c, contrib/mod_tls.c:
	  Bug#3906 - Support ban rule for clients which perform SSL/TLS
	  handshakes too frequently.

2013-03-01 11:43  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_ban.pm:
	  Adding regression test for the new BanOnEvent TLSHandshake rule
	  (Bug#3906).

2013-03-01 07:41  castaglia

	* contrib/mod_log_forensic.c:
	  Print out mod_unique_id's UNIQUE_ID value, if present, in the
	  ForensicLogFile.

2013-02-27 17:20  castaglia

	* NEWS, contrib/mod_sftp/fxp.c:
	  Bug#3900 - ProFTPD terminating (signal 11) on some sftp
	  connections.

2013-02-27 14:50  castaglia

	* src/mkhome.c:
	  And, for site which really need it, generate before/after events
	  for when a skeleton directory is configured for CreateHome.

2013-02-27 14:22  castaglia

	* src/mkhome.c:
	  Only fire the 'core.created-home' event IFF the home directory
	  was actually created (versus already existing).

2013-02-27 09:38  castaglia

	* contrib/mod_sftp/scp.c:
	  Backporting the proper patch/fix for Bug#3904 to 1.3.4 branch.

2013-02-27 09:32  castaglia

	* src/fsio.c:
	  Slight performance in statcache check by checking path lengths
	  first, before calling strncmp(3).

2013-02-27 09:29  castaglia

	* RELEASE_NOTES:
	  Adding more release notes to myself, to flesh out today/tomorrow.

2013-02-27 09:26  castaglia

	* contrib/mod_sftp/scp.c:
	  Checking in the proper patch/fix for Bug#3904.

2013-02-27 09:10  castaglia

	* NEWS, contrib/mod_sftp/scp.c:
	  Backport of fix for Bug#3904 to 1.3.4 branch.

2013-02-27 09:10  castaglia

	* NEWS, contrib/mod_sftp/scp.c:
	  Bug#3904 - scp downloads using glob pattern sometimes fails.

2013-02-26 21:40  castaglia

	* doc/contrib/ftpmail.html:
	  Updated ftpmail docs, per Bug#3709.

2013-02-26 21:35  castaglia

	* NEWS, contrib/ftpmail:
	  Bug#3709 - Support download-triggered emails in the ftpmail
	  script.

2013-02-26 21:09  castaglia

	* contrib/mod_log_forensic.c:
	  Rather than using sstrncpy() (which can examine every byte
	  looking for NUL), use memcpy(3), since we already know how long
	  the buffer to be copied is.  Hopefully this is faster, and
	  reduces CPU load on logging-busy servers (e.g. lots of TraceLog
	  messages being generated/copied by mod_log_forensic).

2013-02-26 16:50  castaglia

	* src/mkhome.c:
	  Don't generate the 'core.created-home' event until after any
	  possible CreateHome skeleton directory has been copied.

2013-02-26 15:30  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_sftp.pm:
	  Typo.

2013-02-26 15:16  castaglia

	* doc/contrib/: mod_sftp_pam.html:
	  Document the new SFTPPAMOptions value, per Bug#3905.

2013-02-26 15:14  castaglia

	* NEWS, contrib/mod_sftp_pam.c, modules/mod_auth_pam.c:
	  Backport of fix for Bug#3905 to 1.3.4 branch.

2013-02-26 15:12  castaglia

	* NEWS, contrib/mod_sftp_pam.c, modules/mod_auth_pam.c:
	  Bug#3905 - Handle the Linux-specific PAM_RADIO_TYPE message
	  properly.

2013-02-26 10:09  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_sftp.pm:
	  Fix the handling of exit status values from external commands
	  (e.g. scp).

2013-02-25 12:31  castaglia

	* contrib/mod_log_forensic.c:
	  Deal with Bug#3903 in mod_log_forensic by have a separate pool
	  for each log message object in the ring (and thus each message
	  string is allocated out of its own pool).

2013-02-25 12:29  castaglia

	* contrib/mod_sftp/packet.c:
	  Use a more conservative approach, and use memmove(3) instead of
	  memcpy(3).

2013-02-25 12:27  castaglia

	* src/log.c:
	  Better handling of return value from pr_log_event_listening().

2013-02-25 11:40  castaglia

	* src/trace.c:
	  Avoid calling strlen(3) unnecessarily on TraceLog messages.

2013-02-24 09:10  jwm

	* contrib/mod_ldap.c: git 07dd890968: release mod_ldap 2.9.3

2013-02-24 09:10  jwm

	* contrib/mod_ldap.c: git 577776b579: don't emit the bind DN
	  password in debug output on successful bind (Bug #3885)

2013-02-24 09:09  jwm

	* contrib/mod_ldap.c: git b77b43e314: fail when someone's left the
	  on/off flags when moving to LDAP{Users,Groups}

2013-02-24 08:46  castaglia

	* NEWS, include/log.h, src/event.c, src/log.c:
	  Bug#3903 - With mod_log_forensic enabled, SSH connections fail
	  randomly.

2013-02-24 08:42  castaglia

	* modules/mod_auth_file.c,
	  tests/t/lib/ProFTPD/Tests/Modules/mod_auth_file.pm:
	  Per Bug#3892, have mod_auth_file check for symlinks; if the
	  configured Auth file path is a symlink, make sure that the parent
	  directory of the symlink is not world-writable, as well as the
	  parent directory of the target path not being world-writable.

2013-02-24 08:35  castaglia

	* tests/t/lib/ProFTPD/TestSuite/Utils.pm:
	  Give the server time to start up, and write out the PidFile,
	  before checking for the PidFile.

2013-02-22 11:52  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_sftp.pm:
	  Adding more different configurations/environments to the
	  regression tests for Bug#3904.

2013-02-22 08:47  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_sftp.pm:
	  Adding regression test using scp(1) to download a glob pattern.

2013-02-21 23:20  castaglia

	* src/trace.c:
	  Avoid needless (and wasteful) strlen(3) calls by tracking the
	  length ourselves.

2013-02-21 23:06  castaglia

	* modules/mod_facts.c:
	  Attempt to address Bug#3900 by having the mod_facts module's
	  handling of a LOG_CMD_ERR MLSD command be ignored for SFTP
	  connections.

2013-02-21 19:21  castaglia

	* src/trace.c:
	  Backport of fix for Bug#3902 to 1.3.4 branch.

2013-02-21 19:21  castaglia

	* src/trace.c:
	  Bug#3902 - mod_log_forensic seems to send trace channels to trace
	  log even if level is 0.

2013-02-21 18:02  castaglia

	* contrib/mod_sftp/fxp.c:
	  Populate the cmd_class member for the fake cmd_recs generated
	  when aborting unclosed handles in mod_sftp.

2013-02-21 17:47  castaglia

	* contrib/mod_sftp/fxp.c:
	  Do not re-allocate a new tmp_pool for the internal cmd_recs in
	  mod_sftp; a tmp_pool is already allocated by pr_cmd_alloc().

2013-02-21 14:20  castaglia

	* doc/contrib/mod_log_forensic.html:
	  Document the additional ForensicLogFile metadata headers.

2013-02-21 14:19  castaglia

	* contrib/mod_log_forensic.c:
	  Add an "Elapsed:" header to the metadata, containing the elapsed
	  session time (in millisecs).	Also fixes up a few other nits
	  (like correctly setting the engine variable to 'false' when we
	  need to disable the module due to bad config).

2013-02-21 13:02  castaglia

	* doc/modules/mod_rlimit.html:
	  Fleshing out the rest of the mod_rlimit documentation.

2013-02-21 11:56  castaglia

	* doc/modules/: index.html, mod_rlimit.html:
	  Adding documentation for the new mod_rlimit module.

2013-02-21 11:21  castaglia

	* modules/mod_rlimit.c:
	  Adding an RLimitProcesses directive, to disable the NPROC limit
	  if needed.

2013-02-21 10:08  castaglia

	* contrib/mod_sftp/fxp.c:
	  I suspect that this is the cause of Bug#3900.  We were allocating
	  a buffer for the generated handle which was too short (8 bytes),
	  and then proceeding to write into the buffer as if it was the
	  larger size that we expected (16 bytes).

2013-02-20 22:10  castaglia

	* contrib/mod_log_forensic.c:
	  Fixing the generation of ForensicLogFile data in the face of
	  unclean closes, e.g. when dealing with segfaults.

2013-02-20 17:04  castaglia

	* tests/t/lib/ProFTPD/TestSuite/Utils.pm:
	  Tweak to make use of AuthUserFiles in the testsuite work as
	  expected.

2013-02-20 15:28  castaglia

	* NEWS, RELEASE_NOTES, contrib/mod_tls.c:
	  Bug#3899 - Support authentication of users based on SSL/TLS
	  client certificate.

2013-02-20 15:26  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_tls.pm:
	  Adding regression test for Bug#3899 (TLSUserName directive).

2013-02-20 09:26  castaglia

	* contrib/mod_ifsession.c:
	  Typo in comment; no functional change.

2013-02-20 09:25  castaglia

	* contrib/mod_ifsession.c:
	  More fun with deferred <Directory> path resolution in
	  mod_ifsession, for Bug#3881.

2013-02-20 08:48  castaglia

	* contrib/mod_ifsession.c:
	  More work (and hopefully progress) on Bug#3881.  Now the
	  complications on the user's site seem to be related to the use of
	  symlinks.

2013-02-19 22:53  castaglia

	* NEWS, src/parser.c:
	  Bug#3896 - Warn when world-writable config files are used.

2013-02-19 17:34  castaglia

	* src/dirtree.c:
	  Re-enable the clearing of the CF_DEFER flag, to prevent
	  repetitive needless processing of <Directory> paths.

2013-02-19 17:09  castaglia

	* src/parser.c:
	  Avoid unnecessary strlen(3) calls when parsing configuration.

2013-02-19 17:04  castaglia

	* src/fsio.c:
	  Stylistic nits; no functional change.

2013-02-19 16:43  castaglia

	* contrib/mod_ifsession.c:
	  More tweaks needed for Bug#3881.

2013-02-19 15:13  castaglia

	* src/dirtree.c:
	  Do NOT clear the CF_DEFER flag from <Directory> sections; we may
	  need to re-try resolution later (e.g. for <Directory> sections
	  added via mod_ifsession).

2013-02-19 14:23  castaglia

	* src/dirtree.c:
	  Add some trace logging into the resolution of deferred-path
	  <Directory> sections.

2013-02-19 13:24  castaglia

	* NEWS, contrib/mod_sftp/fxp.c:
	  Bug#3897 - mod_sftp does not handle a REALPATH request properly
	  for SFTP protocol version 6.

2013-02-19 08:24  castaglia

	* contrib/mod_ifsession.c:
	  Check that the configured DisplayLogin file is not a directory in
	  mod_ifsession, too.

2013-02-19 07:49  castaglia

	* tests/api/pool.c:
	  Adding pool API test, commented out for now.	There is an issue
	  with regard to pool size with larger-than-pool-size allocations
	  out of the pool, it seems.

2013-02-17 15:49  jwm

	* doc/: Configuration.html, Configuration.pdf, Configuration.sgml:
	  whee up-to-date configuration docs for the first time since 2007

2013-02-17 10:12  jwm

	* tests/tests.pl: fix syntax error

2013-02-15 17:03  castaglia

	* src/dirtree.c:
	  One more tiny tweak; might help Bug#3881.

2013-02-15 14:50  castaglia

	* modules/: mod_core.c, mod_ident.c, mod_ls.c, mod_xfer.c:
	  Switch the core modules to start using the new PR_IS*() character
	  type detection macros.

2013-02-15 14:46  castaglia

	* contrib/: mod_ctrls_admin.c, mod_exec.c, mod_ifversion.c,
	  mod_radius.c, mod_rewrite.c, mod_sql.c, mod_tls.c,
	  mod_sftp/interop.c, mod_sftp/packet.c, mod_sftp/scp.c,
	  mod_wrap2/mod_wrap2.c:
	  Start using the new PR_IS*() macros to guard the ctype(3)
	  character detection checks.

2013-02-15 14:39  castaglia

	* src/auth.c, src/ctrls.c, src/fsio.c, src/main.c, src/netacl.c,
	  src/netaddr.c, src/parser.c, src/str.c, src/support.c,
	  src/xferlog.c, utils/ftpshut.c, utils/misc.c:
	  Start using the new PR_IS*() macros for character type
	  detection/checking.

2013-02-15 14:33  castaglia

	* include/ascii.h, include/conf.h, utils/utils.h:
	  Define PR_IS* macro wrappers around the ctype(3) checks, so that
	  isascii(3) is always checked first, before using the other
	  ctype(3) check on the given character.

2013-02-15 11:27  castaglia

	* contrib/mod_ifsession.c:
	  Fix compiler warning (and logged message).

2013-02-15 10:33  castaglia

	* contrib/mod_ifsession.c, include/dirtree.h, modules/mod_core.c,
	  src/dirtree.c:
	  The previous change (additional work for Bug#3881) changed the
	  signature of the add_config() and add_config_set() functions.  To
	  avoid possible API breakage, this change creates new
	  pr_config_add() and pr_config_add_set() functions (which take the
	  new flags argument), and provides backward-compatible
	  add_config() and add_config_set() wrappers.

2013-02-15 10:19  castaglia

	* contrib/mod_ifsession.c, include/dirtree.h, modules/mod_core.c,
	  src/dirtree.c:
	  Additional work needed for Bug#3881.	Specifically, when merging
	  <Directory> sections in, mod_ifsession needs to add the
	  <Directory> config_rec to the *head* of the set, rather than the
	  *tail*.  When parsing the config file without mod_ifsession,
	  <Directory> sections are added to the set head (i.e. last
	  <Directory> parsed appears first in the set).

	  With this, mod_ifsession's merging in of <Directory> sections now
	  more closely matches the parser behavior/ordering.

2013-02-14 16:21  castaglia

	* src/dirtree.c:
	  Stylistic cleanup.

2013-02-14 16:06  castaglia

	* modules/mod_ls.c, src/netaddr.c:
	  Use the isascii(3) test prior to checking with isalnum(3), to
	  ensure that the isalnum(3) input really is an ASCII character.

2013-02-14 16:03  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_quotatab_file.pm:
	  Adding regression test for mod_quotatab_file, using quotatab
	  files created via ftpquota, and using zero-byte download limits.

2013-02-14 15:44  castaglia

	* modules/mod_xfer.c:
	  Removing now-unnecessary trace logging; I think the fix for
	  Bug#3874 has been verified.

2013-02-14 14:54  castaglia

	* modules/mod_xfer.c:
	  More trace logging for investigating Bug#3874.

2013-02-14 14:34  castaglia

	* modules/mod_xfer.c:
	  More debug trace logging, trying to determine why the fix for
	  Bug#3874 isn't working as expected.

2013-02-14 14:28  castaglia

	* modules/mod_xfer.c:
	  Log if there's an error adding the HiddenStores-path-is-on-NFS
	  node.

2013-02-14 13:48  castaglia

	* contrib/: mod_ban.c, mod_rewrite.c, mod_shaper.c,
	  mod_tls_shmcache.c, mod_wrap.c, mod_wrap2_file.c:
	  Catch more cases where the expected paths to files might
	  inadvertently be paths to directories.

2013-02-14 11:44  castaglia

	* modules/mod_core.c:
	  Check for a directory when opening a configured DisplayQuit file.

2013-02-14 11:38  castaglia

	* modules/: mod_auth.c, mod_delay.c, mod_xfer.c:
	  Adding more checks for directories in places where we expect to
	  find files.

2013-02-14 11:29  castaglia

	* contrib/mod_sftp/: auth.c, rfc4716.c:
	  Handle cases in mod_sftp where the files to be opened might
	  inadvertently be directories.

2013-02-14 11:22  castaglia

	* src/display.c:
	  Make sure that we don't open Display files that are directories.

2013-02-14 11:21  castaglia

	* src/parser.c:
	  Don't forget to close the file handle.

2013-02-14 11:18  castaglia

	* modules/mod_auth_file.c:
	  Make sure that the configure AuthUserFile/AuthGroupFile paths are
	  not directories.

2013-02-14 11:14  castaglia

	* src/parser.c:
	  Check whether the given config file is a directory; if so, error
	  out.

2013-02-14 10:33  castaglia

	* modules/mod_auth_file.c:
	  Set the close-on-exec flag for the AuthUserFile/AuthGroupFile
	  fds.

2013-02-14 09:29  castaglia

	* doc/contrib/mod_quotatab_file.html:
	  Mention the fact that <= 0 values for files/bytes limits/tallies
	  are handled as "unlimited" in the mod_quotatab_file docs.

2013-02-14 09:22  castaglia

	* contrib/ftpquota:
	  If users specify zero (or less) values for any bytes/files value,
	  ftpquota now emits a notice message indicating that such values
	  mean "unlimited".

2013-02-13 16:26  castaglia

	* contrib/ftpquota:
	  Make sure that ftpquota shows "unlimited" for values set to zero
	  (or lower).

2013-02-13 09:48  castaglia

	* NEWS, modules/mod_xfer.c:
	  Backport of fix for Bug#3895 to 1.3.4 branch.

2013-02-13 09:48  castaglia

	* NEWS, modules/mod_xfer.c:
	  Bug#3895 - Missing TransferLog entry under some out-of-space
	  conditions.

2013-02-13 09:47  castaglia

	* tests/t/lib/ProFTPD/Tests/Logging/TransferLog.pm:
	  Regression test for Bug#3895; requires the mod_enospc module.

2013-02-12 14:56  castaglia

	* tests/t/lib/ProFTPD/Tests/Commands/MKD.pm:
	  Adding regression test for MKD, making sure that SGID bits are
	  propagated properly for newly-created directories (see Bug#3841).

2013-02-12 14:49  castaglia

	* src/fsio.c:
	  Additional fix for Bug#3841: make sure the pr_fsio_smkdir()
	  function correctly propagates the SUID/SGID bits from the parent
	  directory to the created directory.

2013-02-12 14:49  castaglia

	* src/fsio.c:
	  Additional fix for Bug#3841: make sure the pr_fsio_smkdir()
	  function correctly propagates SUID/SGID bits from the parent
	  directory to the created directory.

2013-02-12 13:39  castaglia

	* contrib/mod_sftp/packet.c:
	  When we try to reset the TimeoutIdle timer, the timers may be in
	  the process of being handled.  Thus we need to handle the EINTR
	  properly.

2013-02-12 10:30  castaglia

	* tests/t/lib/ProFTPD/Tests/Logging/TransferLog.pm:
	  Add another TransferLog regression test, based on uploading to
	  /dev/full and making sure that a TransferLog entry for the
	  aborted upload is recorded.

2013-02-07 23:50  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_exec.pm:
	  Fix one mod_exec test such that, if the expected file is not
	  present, we properly capture the exception thrown in the
	  testcase-specific log.

2013-02-07 23:43  castaglia

	* contrib/mod_exec.c:
	  Use an int, rather than an unsigned char, for the ExecEngine
	  value.  It's easier that way, and it's becoming the convention
	  for all *Engine values.

2013-02-07 23:38  castaglia

	* modules/mod_rlimit.c:
	  Make sure that mod_rlimit does not set RLIMIT_NPROC if the
	  mod_exec module is loaded and enabled for this <VirtualHost>.

2013-02-07 23:34  castaglia

	* configure:
	  Used wrong version of autoconf to generate previous configure
	  script.

2013-02-07 23:25  castaglia

	* configure:
	  Updated configure.

2013-02-07 23:25  castaglia

	* RELEASE_NOTES:
	  Mention the appearance of mod_rlimit in the release notes.

2013-02-07 23:19  castaglia

	* configure.in, modules/mod_core.c, modules/mod_rlimit.c,
	  src/main.c:
	  Refactor the RLimit* code out of mod_core.c, and out of
	  src/main.c, into its own module: mod_rlimit.	This module will be
	  compiled in by default, and will try to set sensible resource
	  limits for new sessions (e.g. RLIMIT_NPROC).

2013-02-07 23:15  castaglia

	* src/dirtree.c:
	  Add some trace logging for when we check AllowFilter/DenyFilter
	  against the arguments for specific commands.

2013-02-07 23:14  castaglia

	* tests/t/lib/ProFTPD/Tests/Config/AllowFilter.pm:
	  Explicitly specify the Order directive, to ensure that the
	  <Limit> sections are handled as expected.

2013-02-07 22:18  castaglia

	* tests/t/lib/ProFTPD/Tests/Config/RLimitOpenFiles.pm:
	  More tests for minimal RLimitOpenFiles settings.

2013-02-07 21:38  castaglia

	* tests/t/lib/ProFTPD/Tests/Config/RLimitCPU.pm:
	  Adding more RLimitCPU tests, ensuring the configured CPU resource
	  limits are being enforced.

2013-02-07 20:54  castaglia

	* src/trace.c:
	  Faster way to check for an empty string, without calling
	  strlen(3).

2013-02-07 19:21  castaglia

	* modules/mod_core.c, src/trace.c:
	  Better handling of typo'd Trace directive values (e.g.
	  "directory:", with no level number).

2013-02-07 07:44  castaglia

	* include/inet.h, src/inet.c, contrib/mod_tls.c:
	  For control connections, TCP_NODELAY is enabled by default.  For
	  data connections, TCP_NODELAY is *disabled* by default (since we
	  want to optimize for full packets for data transmission).
	  However, disabling TCP_NODELAY may hurt TLS handshakes, which are
	  full of many small packets going back and forth.

	  With this tweak, then, Nagling is turned off (i.e. TCP_NODELAY is
	  enabled) for performing a TLS handshake for a data connection,
	  for the duration of the handshake.

2013-02-06 22:37  castaglia

	* include/options.h:
	  Tune the default listen(2) backlog higher.

2013-02-06 09:05  castaglia

	* NEWS, utils/ftptop.c:
	  Backport of fix for Bug#3894 to 1.3.4 branch.

2013-02-06 09:04  castaglia

	* NEWS, utils/ftptop.c:
	  Bug#3894 - ftptop doesn't work with --enable-nls.

2013-02-06 09:03  castaglia

	* tests/: tests.pl, t/config/rlimitcpu.t,
	  t/config/rlimitopenfiles.t,
	  t/lib/ProFTPD/Tests/Config/RLimitCPU.pm,
	  t/lib/ProFTPD/Tests/Config/RLimitOpenFiles.pm:
	  Adding regression tests for the RLimitCPU and RLimitOpenFiles
	  directives.

2013-02-06 09:02  castaglia

	* tests/t/lib/ProFTPD/Tests/Config/RLimitMemory.pm:
	  Update RLimitMemory tests to use testcase-specific logging.
	  Added test for using the 'daemon' setting.

2013-02-05 23:34  castaglia

	* include/rlimit.h, modules/mod_core.c, src/main.c, src/rlimit.c:
	  Next part of the resource limit refactoring: update the code to
	  use the new pr_rlimit_* functions.

2013-02-05 23:14  castaglia

	* include/conf.h:
	  Pull in the new rlimit.h header.

2013-02-05 22:55  castaglia

	* include/rlimit.h, src/rlimit.c:
	  Make sure we don't lose functionality by omitting use of
	  RLIMIT_VMEM (if possible) as a fallback for memory resource
	  limits.

2013-02-05 22:51  castaglia

	* Make.rules.in, include/rlimit.h, src/rlimit.c:
	  Refactoring the resource limit code into a separate API, so that
	  it can be easily called/used by other portions of the code (e.g.
	  other modules).

2013-02-05 21:37  castaglia

	* contrib/ftpasswd:
	  Update the ftpasswd script so that it sets permissions on the
	  created AuthUserFile/AuthGroupFile such that mod_auth_file, in
	  light of the more strict checks added for Bug#3892, will still
	  accept the ftpasswd-generated files.

2013-02-05 16:32  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_sql_sqlite.pm:
	  Properly delete log from successful SQLLogOnEvent test.

2013-02-05 16:19  castaglia

	* NEWS, RELEASE_NOTES, contrib/mod_sql.c:
	  Bug#3893 - Add SQLLogOnEvent directive, for performing SQL query
	  on configurable event.

2013-02-05 16:16  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_sql_sqlite.pm:
	  Checking in test for new SQLLogOnEvent functionality (Bug#3893).

2013-02-05 09:24  castaglia

	* doc/modules/mod_auth_file.html:
	  Mention the new strict permission checks on the AuthUserFile and
	  AuthGroupFile in the mod_auth_file docs.

2013-02-05 09:04  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_auth_file.pm:
	  Adding regression tests for Bug#3892.

2013-02-05 09:03  castaglia

	* NEWS, RELEASE_NOTES, modules/mod_auth_file.c:
	  Bug#3892 - mod_auth_file should have strict permission checks of
	  configured files.

2013-02-04 13:15  castaglia

	* doc/howto/Logging.html:
	  Add logging FAQ for how to disable all logging for proftpd.

2013-02-04 07:43  castaglia

	* src/ctrls.c:
	  Skip any zero-length control request arguments.

2013-02-03 23:14  castaglia

	* tests/t/lib/ProFTPD/TestSuite/Utils.pm:
	  When generating AuthUserFile and AuthGroupFiles for the unit
	  tests, make sure the generated files have stricter permissions on
	  them.

2013-02-03 22:46  castaglia

	* include/ctrls.h, src/ctrls.c:
	  Avoid non-printable characters in ftpdctl requests.

2013-02-03 21:58  castaglia

	* src/ctrls.c:
	  Add max length limit to control action request argument.  Fix
	  caching/propagating of errno value.  Fix stylistic nits.

2013-02-03 21:48  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_sftp.pm:
	  Various tests for configurations related to Bug#3753.

2013-02-03 21:39  castaglia

	* doc/contrib/mod_sftp.html:
	  Updating some of the mapping between FTP command and SFTP
	  request, with regard to <Limit> sections, per Bug#3753.

2013-02-03 21:35  castaglia

	* NEWS, contrib/mod_sftp/fxp.c:
	  Bug#3753 - Support SFTP request names in <Limit> sections better.

2013-02-03 13:46  castaglia

	* src/dirtree.c:
	  Stylistic nit; no functional change.

2013-02-03 13:27  castaglia

	* doc/contrib/mod_sftp.html:
	  Add mention of <Limit WRITE> applying to WRITE SFTP request (of
	  course).

2013-02-02 18:11  castaglia

	* doc/contrib/mod_tls.html:
	  Update mod_tls docs in light of TLSProtocol changes for Bug#3891.

2013-02-02 18:09  castaglia

	* NEWS, RELEASE_NOTES, contrib/mod_tls.c:
	  Bug#3891 - Allow TLSProtocol directive in <VirtualHost> and
	  <Global> sections.

2013-02-02 17:04  castaglia

	* src/scoreboard.c:
	  Fix up the trace-level log messages related to scoreboard
	  locking.

2013-02-01 22:24  castaglia

	* src/log.c:
	  Fix compiler error (i.e. programmer error).

2013-02-01 22:06  castaglia

	* modules/mod_facts.c, modules/mod_ls.c, src/data.c:
	  Backporting additional Bug#3819 fixes from trunk to 1.3.4 branch.

2013-02-01 22:04  castaglia

	* modules/mod_facts.c, modules/mod_ls.c, src/data.c:
	  Additional tweaks needed for Bug#3819 (and for cleaning out
	  development logging).

2013-01-31 15:51  castaglia

	* RELEASE_NOTES:
	  Document the log format change in the release notes.

2013-01-31 15:44  castaglia

	* src/log.c:
	  Now SystemLog (console and file), and all *Log files (via
	  pr_log_writefile()) use ISO-8601 timestamp format.

2013-01-31 12:35  castaglia

	* include/trace.h, src/trace.c:
	  Switch TraceLog to use ISO-8601 timestamps.  Other logs soon to
	  follow suit.

2013-01-31 11:40  castaglia

	* src/dirtree.c:
	  Minor bugfixes when resolving deferred directories: handle cases
	  where a leading '~' means just that, and clear the CF_DEFER flag
	  once we're done resolving that directory.

2013-01-31 09:47  castaglia

	* doc/modules/mod_log.html:
	  Updating LogFormat docs with descriptions of new %{iso8601},
	  %{microsecs}, and %{millisecs} variables.

2013-01-31 09:38  castaglia

	* NEWS, RELEASE_NOTES, contrib/mod_sql.c, modules/mod_log.c:
	  Bug#3889 - Support millisecond timestamp LogFormat variable.

2013-01-31 08:37  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_sql_sqlite.pm:
	  Adding regression tests for the SQLLog handling of the
	  timestamp-related LogFormat variables added for Bug#3889.

2013-01-31 07:49  castaglia

	* tests/t/lib/ProFTPD/Tests/Logging/ExtendedLog.pm:
	  Add regression test for %{microsecs} LogFormat variable, for
	  Bug#3889, too.

2013-01-30 20:20  castaglia

	* tests/t/lib/ProFTPD/Tests/Logging/ExtendedLog.pm:
	  Adding regression tests for the LogFormat variables added for
	  Bug#3889.

2013-01-30 18:18  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_ifsession.pm:
	  Additional reproduction recipes for Bug#3881.

2013-01-30 14:39  castaglia

	* NEWS, include/data.h, modules/mod_facts.c, modules/mod_ls.c,
	  src/data.c, src/pool.c:
	  Backport of fix for Bug#3819 to 1.3.4 branch.

2013-01-30 14:37  castaglia

	* NEWS, include/data.h, modules/mod_facts.c, modules/mod_ls.c,
	  src/data.c, src/pool.c:
	  Bug#3819 - Second and subsequent LIST of directory with many
	  files is very slow.

2013-01-29 17:24  castaglia

	* modules/mod_xfer.c:
	  More tweaks on the path to verification/resolution for Bug#3874.

2013-01-29 16:49  castaglia

	* src/fsio.c:
	  Since we are not including <linux/magic.h>, the NFS_SUPER_MAGIC
	  value was not defined.  So define it manually, for now.

2013-01-29 15:38  castaglia

	* src/fsio.c:
	  Try to be more informative about NFS-related 'fsio' trace
	  logging.

2013-01-29 14:42  castaglia

	* modules/mod_xfer.c:
	  Temporary trace logging to help debug Bug#3874.

2013-01-29 14:18  castaglia

	* src/fsio.c:
	  Slightly better formatting for NFS-related trace message.

2013-01-29 13:58  castaglia

	* modules/mod_xfer.c, src/fsio.c:
	  When checking whether a HiddenStores path will be on an NFS
	  filesystem, we need to use a path which *does* exist -- not the
	  path that WILL exist, but does not exist yet (Bug#3874).

2013-01-28 23:40  castaglia

	* contrib/mod_sftp/mac.c:
	  Remove unnecessary (and misleading) typecasts.

2013-01-28 23:29  castaglia

	* contrib/mod_sftp/: cipher.c, cipher.h, packet.c:
	  Use unsigned char buffers in more places in the mod_sftp code,
	  especially when reading in the bytes for incoming packets.  This
	  MAY help alleviate some of those "too long" packet warnings.

2013-01-28 23:08  castaglia

	* contrib/mod_sftp/ssh2.h:
	  For (hopefully) better interoperability, use the same max packet
	  size as OpenSSH does.

2013-01-28 22:57  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_lang.pm:
	  Add a mod_lang/UseEncoding test showing conversion from
	  ISO-8859-1 characters to a UTF8 path locally.

2013-01-28 22:51  castaglia

	* contrib/mod_sftp/utf8.c, src/fsio.c:
	  Further refinements of the trace logging of failed
	  encoding/decoding.

2013-01-28 16:57  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_tls.pm:
	  Remove development cruft.

2013-01-28 16:48  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_tls.pm:
	  Adding regression test for Bug#3887.

2013-01-28 16:47  castaglia

	* NEWS, src/dirtree.c:
	  Backport of fix for Bug#3887 to 1.3.4 branch.

2013-01-28 16:47  castaglia

	* NEWS, src/dirtree.c:
	  Bug#3887 - <Limit ALL> erroneously blocks the PROT command used
	  for FTPS.

2013-01-28 16:21  castaglia

	* contrib/mod_sftp/utf8.c, src/fsio.c:
	  If we fail to encode/decode a string, AND the TraceLog level is
	  set high enough, then log the bytes of the string in hex, for
	  better analysis.

2013-01-27 17:21  castaglia

	* src/memcache.c:
	  Bug#3886 - Calling pr_memcache_conn_set_namespace() crashes on
	  buffer overflow.

2013-01-27 17:20  castaglia

	* contrib/mod_tls_memcache.c:
	  Clean up logging/comments in mod_tls_shmcache; no functional
	  change.

2013-01-25 14:29  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_ifsession.pm:
	  Tweak the regression test for Bug#3881 to match the reported use
	  case better.

2013-01-25 14:07  castaglia

	* src/dirtree.c:
	  When resolving deferred paths, make sure to handle tilde
	  interpolation as well.

2013-01-25 13:03  castaglia

	* contrib/mod_ifsession.c:
	  Make the lookup for the primary group name NOT be a requirement.
	  If we find it, great.  Otherwise, look up the supplemental
	  groups, and move on.

2013-01-25 12:58  castaglia

	* contrib/mod_ifsession.c:
	  Fix call to pr_auth_getgroups() to use user name, not group name,
	  for the lookup.  Sigh.

2013-01-25 12:24  castaglia

	* contrib/mod_ifsession.c:
	  Additional tweak related to Bug#3882.  Turns out that some
	  modules (e.g.  mod_ldap) are particular about the
	  pr_auth_getgroups() call.  In particular, some functions REQUIRE
	  that array_headers be provided for GIDS and group names, not just
	  one or the other.

2013-01-25 11:51  castaglia

	* contrib/mod_sftp/fxp.c:
	  Add better trace logging of the v5/v6 BITS attribute.

2013-01-25 09:11  castaglia

	* contrib/mod_sftp/display.c, include/fsio.h, src/display.c,
	  src/fsio.c:
	  Provide a pr_fsio_fgetsize() function which gets the filesystem
	  size given an fd, rather than a path.  Then use this new function
	  when handling Display files which are displayed AFTER a chroot(2)
	  has occurred -- for in those cases, using fstatfs(2) et al works
	  better than statfs(3).

2013-01-25 08:15  castaglia

	* contrib/mod_ifsession.c:
	  More cleanup/polish for Bug#3882, removing misleading
	  DisplayLogin related log messages.

2013-01-25 07:16  castaglia

	* configure:
	  Updated configure.

2013-01-25 07:10  castaglia

	* NEWS, configure.in:
	  Backport of fix for Bug#3884 to 1.3.4 branch.

2013-01-25 07:10  castaglia

	* NEWS, configure.in:
	  Bug#3884 - Configure script not detecting MySQL
	  make_scrambled_password functions.

2013-01-24 18:39  castaglia

	* contrib/mod_ifsession.c:
	  Fix logging of mod_ifsession's lookup of a DisplayLogin file (to
	  differentiate it from the logging done by mod_auth).

2013-01-24 18:08  castaglia

	* src/fsio.c:
	  Typo.

2013-01-24 18:04  castaglia

	* contrib/mod_tls.c:
	  If a data transfer command is rejected due to the lack of
	  SSL/TLS, use the more proper 522 response code, rather than 550.

2013-01-24 17:31  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_ifsession.pm:
	  Adding regression test for Bug#3881.

2013-01-24 17:30  castaglia

	* NEWS, contrib/mod_ifsession.c:
	  Bug#3881 - <Directory> sections within <IfGroup> sections not
	  applied as expected.

2013-01-24 16:05  castaglia

	* tests/: tests.pl,
	  t/lib/ProFTPD/Tests/Modules/mod_log_forensic.pm,
	  t/modules/mod_log_forensic.t:
	  Adding in the regression tests for the new mod_log_forensic
	  module.

2013-01-24 16:04  castaglia

	* NEWS, README.modules, RELEASE_NOTES, contrib/mod_log_forensic.c,
	  doc/contrib/index.html, doc/contrib/mod_log_forensic.html:
	  Adding the mod_log_forensic module to the source distribution.

2013-01-24 14:45  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_sftp.pm:
	  Adding regression test for a bug where mod_sftp would
	  occasionally lose track of file/directory handles, due to use of
	  wrong memory pool.

2013-01-24 14:32  castaglia

	* NEWS, contrib/mod_ifsession.c:
	  Bug#3882 - DisplayLogin with an absolute path does not work
	  properly within an <IfGroup> section.

2013-01-24 14:30  castaglia

	* contrib/mod_sftp/fxp.c:
	  Fix a bug in mod_sftp where file/directory handles could become
	  "lost", leading to "Invalid handle" SFTP responses, due to use of
	  wrong memory pool.

2013-01-24 14:21  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_ifsession.pm:
	  Adding regression test for Bug#3882.

2013-01-24 11:22  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_ifsession.pm:
	  Make the mod_ifsession tests pass properly on MacOSX.

2013-01-24 10:47  castaglia

	* src/fsio.c:
	  Add trace logging for the pr_fsio_is_nfs() function, for easier
	  analysis.

2013-01-22 23:22  castaglia

	* contrib/mod_sftp/fxp.c:
	  Use trace logging to log the error when we fail to find the
	  handle given a name from the client.

2013-01-22 07:20  castaglia

	* contrib/mod_sftp/fxp.c:
	  Increase subpool size for SFTP packets to 128 bytes.

2013-01-21 22:46  castaglia

	* contrib/mod_sftp/fxp.c:
	  Backporting support for reading various v5/v6 attributes from
	  trunk.

2013-01-21 22:44  castaglia

	* contrib/mod_sftp/fxp.c:
	  Fleshing out the support for various v5/v6-specific attributes.

2013-01-21 17:12  castaglia

	* contrib/mod_sftp/msg.c:
	  Log the errno value from backtrace(3), if we fail to get a
	  backtrace from it.

2013-01-21 17:10  castaglia

	* src/main.c:
	  Wrong datatype for backtrace(3) return value.

2013-01-21 17:05  castaglia

	* src/main.c:
	  Log the errors we get from backtrace(3) and backtrace_symbols(3),
	  if any.

2013-01-21 14:05  castaglia

	* modules/mod_xfer.c:
	  Reduce unnecessary logging of EEXIST cases when adding command
	  notes.

2013-01-21 12:00  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_quotatab_sql.pm:
	  Adding regression test for Bug#3879.

2013-01-21 11:59  castaglia

	* NEWS, contrib/mod_quotatab_sql.c:
	  Bug#3879 - Allow additional columns in SQLNamedQuery queries used
	  for quota limits and tallies.

2013-01-21 10:28  castaglia

	* contrib/mod_sftp/fxp.c:
	  Wrong cmd_rec in fix for Bug#3874.

2013-01-20 22:44  castaglia

	* NEWS, contrib/mod_quotatab.c:
	  Backport of fix for Bug#3878 to 1.3.4 branch.

2013-01-20 22:43  castaglia

	* NEWS, contrib/mod_quotatab.c:
	  Bug#3878 - QuotaExcludeFilter not honored for uploads when 'hard'
	  limits are used.

2013-01-20 22:41  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_quotatab_sql.pm:
	  Adding regression test for Bug#3878.

2013-01-19 10:20  castaglia

	* contrib/mod_geoip.c:
	  Bug#3877 - Fix GeoIPPolicy logging by making it a trace log
	  message.

2013-01-18 17:08  castaglia

	* src/parser.c:
	  Backported parser segfault fix from trunk.

2013-01-18 17:07  castaglia

	* src/parser.c:
	  Fix possible segfault due to null pointer dereference.

2013-01-18 16:25  castaglia

	* configure:
	  Updated configure.

2013-01-18 16:21  castaglia

	* NEWS, config.h.in, configure.in, contrib/mod_sftp/fxp.c,
	  include/fsio.h, modules/mod_xfer.c, src/fsio.c:
	  Bug#3874 - Use of O_EXCL flag on HiddenStores files might break
	  for NFS filesystems.

2013-01-18 15:35  castaglia

	* src/mkhome.c:
	  Rather than generating a single event prior to actually creating
	  the CreateHome directory, we now generate two events:
	  'core.creating-home' for before home creation, and
	  'core.created-home' for after.

2013-01-18 12:30  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_tls.pm:
	  Adding regression test for Bug#3869 using "TLSSessionCache off".

2013-01-18 12:29  castaglia

	* NEWS, RELEASE_NOTES, contrib/mod_tls.c:
	  Bug#3869 - Use longer SSL session cache expiration by default.

2013-01-16 13:50  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_sftp.pm:
	  Adding regression test for Bug#3873.

2013-01-16 13:50  castaglia

	* NEWS, contrib/mod_sftp/fxp.c:
	  Bug#3873 - Provide FTP response code in ExtendedLog for failed
	  SFTP REMOVE request.

2013-01-16 09:25  castaglia

	* doc/modules/mod_xfer.html:
	  Updated HiddenStores docs per changes for Bug#3872.

2013-01-16 09:12  castaglia

	* NEWS, RELEASE_NOTES, modules/mod_xfer.c:
	  Bug#3872 - Use HiddenStores directive to customise suffix.

2013-01-15 23:52  castaglia

	* tests/t/lib/ProFTPD/Tests/Config/HiddenStores.pm:
	  Adding unit test for HiddenStores suffix feature (Bug#3872).
	  Also used assert_transfer_ok() function in the tests here.

2013-01-15 23:30  castaglia

	* tests/t/lib/ProFTPD/Tests/Config/HiddenStores.pm:
	  Updated the HiddenStores tests to use testcase-specific logging.

2013-01-15 23:20  castaglia

	* doc/modules/mod_xfer.html:
	  Fleshing out more directive descriptions in the mod_xfer docs.

2013-01-15 14:25  castaglia

	* contrib/: mod_tls.c:
	  Remove duplicate setting of SSL session context ID.

2013-01-15 14:22  castaglia

	* contrib/mod_tls.c:
	  Logging nits and tweaks to the SSL session context ID used.
	  (Removed some duplicate code that had snuck in, too.)

2013-01-15 13:57  castaglia

	* contrib/mod_tls_shmcache.c:
	  Minor logging nits/cleanup for the mod_tls_shmcache module.

2013-01-15 13:04  castaglia

	* contrib/: mod_tls.c:
	  Guard against NULL pointer dereference if the TLSRenegotiate
	  timer fires when the SSL session on the control connection is
	  being torn down.

2013-01-15 12:48  castaglia

	* contrib/mod_tls.c:
	  Fix incorrect format string.

2013-01-15 11:55  castaglia

	* contrib/mod_sftp/fxp.c:
	  Revert the REALPATH request to be in the INFO logging class, not
	  DIRS; REALPATH can be used on files and symlinks as well as on
	  directories.	Changed for fix for Bug#3871.

2013-01-15 11:55  castaglia

	* contrib/mod_sftp/fxp.c:
	  Revert the REALPATH request to be in the INFO logging class, not
	  DIRS; REALPATH can be used on files and symlinks as well as on
	  directories.

2013-01-15 11:51  castaglia

	* NEWS, contrib/mod_sftp/fxp.c:
	  Backport of fix for Bug#3871 to 1.3.4 branch.

2013-01-15 11:50  castaglia

	* NEWS, contrib/mod_sftp/fxp.c:
	  Bug#3871 - REALPATH SFTP request not properly handled by <Limit
	  DIRS> configuration.

2013-01-15 11:21  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_sftp.pm:
	  Adding regression/reproduction test for Bug#3871.

2013-01-15 11:04  castaglia

	* modules/mod_core.c:
	  Use the proper C_ macros, rather than hardcoded strings, in more
	  places.

2013-01-15 11:03  castaglia

	* contrib/mod_tls.c:
	  Use a better variable name here.

2013-01-15 07:57  castaglia

	* src/fsio.c:
	  Add trace logging of the arguments to the pr_fsio_smkdir()
	  function, for future debugging/analysis.

2013-01-14 22:16  castaglia

	* contrib/mod_tls.c:
	  Make sure that we can properly handle a SubjAltName iPAddress
	  value that contains an IPv6 address, for comparing with our
	  address.

2013-01-14 22:14  castaglia

	* tests/t/: etc/modules/mod_tls/ipv6-ca.pem,
	  etc/modules/mod_tls/ipv6-client-cert2.pem,
	  etc/modules/mod_tls/ipv6-server-cert2.pem,
	  lib/ProFTPD/Tests/Modules/mod_tls.pm:
	  Adding regression test for handling of IPv6 iPAddress SubjAltName
	  values in client certs.

2013-01-14 14:19  castaglia

	* NEWS, contrib/mod_tls.c, contrib/mod_sftp/dhparams.pem:
	  Bug#3779 - Generate new DH parameters for mod_tls and mod_sftp.

2013-01-14 12:44  castaglia

	* NEWS, modules/mod_core.c:
	  Backport of fix for Bug#3870 to 1.3.4 branch.

2013-01-14 12:43  castaglia

	* NEWS, modules/mod_core.c:
	  Bug#3870 - Handling of OPTS command can lead to crash.

2013-01-14 12:33  castaglia

	* tests/: tests.pl, t/commands/opts.t,
	  t/lib/ProFTPD/Tests/Commands/OPTS.pm:
	  Add regression tests for the OPTS command (including test for
	  Bug#3870).

2013-01-14 08:52  castaglia

	* src/fsio.c:
	  Remove redundant strlen(3).

2013-01-14 08:51  castaglia

	* src/fsio.c:
	  Remove erroneous errno assignment.

2013-01-13 21:57  castaglia

	* contrib/mod_tls.c:
	  Always set the socket to non-blocking before calling
	  SSL_accept(), even on retries.  This latter condition was not
	  happening.

2013-01-13 21:39  castaglia

	* contrib/mod_tls.c:
	  Fix minor nits in comments; no functional change.

2013-01-13 21:15  castaglia

	* contrib/mod_tls.c:
	  Backported another tweak/part of Bug#3868, to avoid null pointer
	  dereference.

2013-01-13 21:14  castaglia

	* contrib/mod_tls.c:
	  Additional tweak (to avoid null pointer dereference) for
	  Bug#3868.

2013-01-13 17:12  castaglia

	* contrib/mod_tls.c:
	  Typo.

2013-01-13 16:40  castaglia

	* include/fsio.h, src/fsio.c:
	  Backporting more of the pr_fsio_smkdir() tweaks from trunk to the
	  1.3.4 branch.

2013-01-13 16:38  castaglia

	* src/fsio.c:
	  Make sure that if mkdtemp(3) is not available for any reason, we
	  do not fail with a linker error.

2013-01-13 16:33  castaglia

	* include/fsio.h, src/fsio.c:
	  Rather than having pr_fsio_smkdir() use mkdtemp(3) if available,
	  now the use of mkdtemp(3) can be enabled/disabled at runtime.
	  This is necessary e.g. to have mod_vroot function as expected.
	  (Which is OK; the race condition against which pr_fsio_smkdir()
	  guards mostly pertains to root privileges, and mod_vroot is for
	  cases where root privs are NOT wanted.)

2013-01-13 13:39  castaglia

	* doc/contrib/mod_tls.html:
	  Improvide the TLSDHParamFile documentation, in light of Bug#3868.

2013-01-13 13:25  castaglia

	* tests/t/: etc/modules/mod_tls/dh1024.pem,
	  lib/ProFTPD/Tests/Modules/mod_tls.pm:
	  Adding regression tests for Bug#3868.

2013-01-13 13:21  castaglia

	* NEWS, contrib/mod_tls.c:
	  Backport of fix for Bug#3868 to 1.3.4 branch.

2013-01-13 13:19  castaglia

	* NEWS, contrib/mod_tls.c:
	  Bug#3868 - Only first DH param in TLSDHParamFile is used,
	  regardless of requested keylength.

2013-01-13 13:06  castaglia

	* NEWS, contrib/ftpasswd:
	  Backport of fix for Bug#3867 to 1.3.4 branch.

2013-01-13 13:05  castaglia

	* NEWS, contrib/ftpasswd:
	  Bug#3867 - ftpasswd fails with "Permission denied" when adding
	  subsequent passwd/group entries.

2013-01-11 19:03  castaglia

	* tests/t/lib/ProFTPD/Tests/Utils/: ftpcount.pm, ftpwho.pm:
	  Make these utils tests pass again (just needed correct path to
	  the executables).

2013-01-11 11:32  castaglia

	* contrib/ftpasswd:
	  Bump the ftpasswd version, given the addition of support for
	  other password hash types.

2013-01-11 10:33  castaglia

	* NEWS, contrib/mod_ban.c:
	  Backport of fix for Bug#3866 to 1.3.4 branch.

2013-01-11 10:33  castaglia

	* NEWS, contrib/mod_ban.c:
	  Bug#3866 - Issuing invalid 'ftpdctl ban' request causes segfault.

2013-01-11 09:35  castaglia

	* NEWS, contrib/mod_ban.c:
	  Backport of fix for Bug#3865 to 1.3.4 branch.

2013-01-11 09:35  castaglia

	* NEWS, contrib/mod_ban.c:
	  Bug#3865 - BanEngine not set in "server config" results in
	  "mod_ban not enabled" ftpdctl error.

2013-01-10 16:57  castaglia

	* modules/mod_core.c:
	  Stylistic nits; no functional change.

2013-01-10 14:51  castaglia

	* tests/t/lib/ProFTPD/Tests/Config/UserOwner.pm:
	  Adding another regression test using a config based on issues
	  reported for Bug#3841, involving <Anonymous> logins and
	  UserOwner.

2013-01-10 14:48  castaglia

	* src/fsio.c:
	  Backporting more pr_fsio_smkdir() fixes from trunk, for fixing
	  regressions caused by Bug#3841.

2013-01-10 14:47  castaglia

	* src/fsio.c:
	  Log a warning if we can't rename the directory in
	  pr_fsio_smkdir(), too.

2013-01-10 14:44  castaglia

	* src/fsio.c:
	  Fix another regression caused by Bug#3841: we might need root
	  privs when setting the permissions on the created directory, as
	  well as when possibly setting the ownership.

2013-01-10 12:10  castaglia

	* src/event.c:
	  Backport another fix, regarding event notification subscription,
	  from trunk.

2013-01-10 12:07  castaglia

	* src/fsio.c:
	  Backporting fix for MKD regression (due to Bug#3841) to 1.3.4
	  branch.

2013-01-10 12:07  castaglia

	* src/fsio.c:
	  Fix regression with MKD commands (due to Bug#3841).

2013-01-10 12:06  castaglia

	* tests/t/lib/ProFTPD/Tests/Commands/MKD.pm:
	  Added needed regression test for sending MKD for a chrooted
	  session.

2013-01-10 11:46  castaglia

	* contrib/mod_tls.c:
	  Generate an event whenever mod_tls is verifying a client
	  certificate; the event fired will indicate whether the
	  verification succeeded or failed.

2013-01-10 10:52  castaglia

	* contrib/mod_tls.c:
	  Stylistic nits.

	  Moved checking for peer cert earlier in the tls_dotlogin_allow()
	  function; if the client doesn't present a certificate, then don't
	  try to do any of the other work there, as a minor optimization.

	  No functional changes.

2013-01-09 18:06  castaglia

	* NEWS, contrib/mod_sftp/auth.c:
	  Backported fix for Bug#3863 to 1.3.4 branch.

2013-01-09 18:06  castaglia

	* NEWS, contrib/mod_sftp/auth.c:
	  Bug#3863 - mod_sftp does not handle MaxLoginAttempts properly.

	  Make sure that we increment the auth_attempts counter whenever
	  the auth method request does not explicitly succeed.

2013-01-09 18:03  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_sftp/ban.pm:
	  Updating mod_sftp+mod_ban MaxLoginAttempts regression test for
	  Bug#3863.

2013-01-09 16:43  castaglia

	* doc/contrib/mod_tls.html:
	  Adding description of TLSMasqueradeAddress directive to mod_tls
	  docs.

2013-01-09 16:21  castaglia

	* doc/modules/mod_core.html:
	  Typo.

2013-01-09 15:53  castaglia

	* NEWS, RELEASE_NOTES, contrib/mod_tls.c, modules/mod_core.c:
	  Bug#3862 - Support for FTPS-specific MasqueradeAddress
	  functionality.

2013-01-09 15:52  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_tls.pm:
	  Adding regression test for TLSMasqueradeAddress directive; see
	  Bug#3862.

2013-01-09 15:19  castaglia

	* tests/: tests.pl, t/config/masqueradeaddress.t,
	  t/lib/ProFTPD/Tests/Config/MasqueradeAddress.pm:
	  Adding unit tests for the MaqueradeAddress directive.

2013-01-09 14:53  castaglia

	* contrib/mod_ban.c:
	  Provide more information for the 'mod_ban.ban.expired' event.

2013-01-09 12:53  castaglia

	* doc/howto/Controls.html:
	  Fix typo.

2013-01-08 23:48  castaglia

	* contrib/mod_sftp/fxp.c:
	  Aborting an SFTP directory listing is always an error.

2013-01-08 16:32  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_sftp.pm:
	  Adding an ExtendedLog/LogFormat %f test for SFTP transfers in a
	  chrooted session.

2013-01-08 14:23  castaglia

	* contrib/mod_tls.c:
	  Fix erroneous "renegotiation accepted" TLSLog messages for data
	  transfers.

2013-01-08 13:03  castaglia

	* contrib/mod_sftp/fxp.c:
	  Make sure that we dispatch a MLSD command for aborted SFTP
	  directory listings.

2013-01-08 12:29  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_ban.pm:
	  Give the server a little time to start up, and make this mod_ban
	  test a little more robust.

2013-01-07 23:01  castaglia

	* contrib/mod_ban.c:
	  Backporting minor memory leak fix from trunk.

2013-01-07 22:59  castaglia

	* contrib/mod_ban.c:
	  Generate an event whenever mod_ban disconnects a client, with a
	  descriptive string about why the client was disconnected (i.e.
	  including ban type, and reason if known).

2013-01-07 22:56  castaglia

	* src/inet.c:
	  Quell compiler warning about unused variable on platforms which
	  do not support the TCP keepalive macros (e.g. Mac OSX).

2013-01-07 16:20  castaglia

	* doc/howto/Rewrite.html:
	  Another time-related mod_rewrite config/trick.

2013-01-07 16:10  castaglia

	* doc/howto/Rewrite.html:
	  Start adding some time-related mod_rewrite examples, now that
	  mod_rewrite supports time variables.

2013-01-07 15:59  castaglia

	* contrib/mod_ban.c:
	  Have mod_ban generate an event when it removes a ban due to
	  expiry, for the benefit of logging modules like mod_snmp.

2013-01-07 15:00  castaglia

	* doc/contrib/mod_geoip.html:
	  Added description of the GeoIPPolicy directive to the mod_geoip
	  docs.

2013-01-07 14:55  castaglia

	* NEWS, RELEASE_NOTES, contrib/mod_geoip.c:
	  Bug#3860 - Add a default deny option for mod_geoip.

2013-01-07 14:42  castaglia

	* doc/modules/mod_core.html:
	  Adding descriptions for the Port and <VirtualHost> directives to
	  the mod_core docs.

2013-01-07 13:33  castaglia

	* doc/modules/mod_core.html:
	  Add description for DefaultAddress to the mod_core docs.

2013-01-07 13:26  castaglia

	* doc/contrib/mod_geoip.html:
	  Cut-n-pasto.

2013-01-07 13:25  castaglia

	* doc/contrib/mod_geoip.html:
	  Include links to some of the MaxMind documentation on e.g.
	  country codes and continents.

2013-01-07 13:08  castaglia

	* doc/modules/mod_core.html:
	  Add the MasqueradeAddress description to the mod_core docs.

2013-01-07 12:31  castaglia

	* modules/mod_facts.c:
	  Backporting additional fix for Bug#3859 from trunk to 1.3.4
	  branch.

2013-01-07 12:30  castaglia

	* modules/mod_facts.c:
	  Additional fix for Bug#3859.

2013-01-07 11:45  castaglia

	* tests/t/lib/ProFTPD/Tests/Commands/MLSD.pm:
	  Another regression test for Bug#3859, this time using
	  "ShowSymlinks off".

2013-01-07 10:52  castaglia

	* NEWS, modules/mod_facts.c:
	  Backport of fix for Bug#3859 to 1.3.4 branch.

2013-01-07 10:52  castaglia

	* NEWS, modules/mod_facts.c:
	  Bug#3859 - MLSD fails to show symlinks when ShowSymlinks is not
	  configured.

2013-01-07 10:26  castaglia

	* tests/t/lib/ProFTPD/Tests/Commands/MLSD.pm:
	  Adding regression test for Bug#3859.

2013-01-07 09:43  castaglia

	* modules/mod_lang.c,
	  tests/t/lib/ProFTPD/Tests/Modules/mod_lang.pm:
	  If the admin configures a strict UseEncoding, AND that
	  UseEncoding specifies UTF8 as the client charset, then DO list
	  UTF8 in the FEAT output.

2013-01-06 08:20  castaglia

	* modules/Makefile.in:
	  Backporting build fix from trunk.

2013-01-06 08:18  castaglia

	* modules/Makefile.in:
	  As part of work on Bug#3725, make sure that the mod_dso-specific
	  rules are invoked when mod_dso.c is modified, AND that the more
	  general .c.o rule is NOT used for mod_dso; mod_dso requires some
	  additional -I flags.

2013-01-05 17:48  castaglia

	* modules/mod_lang.c,
	  tests/t/lib/ProFTPD/Tests/Modules/mod_lang.pm:
	  Refinement for Bug#3737: when the UseEncoding "strict" keyword is
	  used, then UTF8 should not appear in the FEAT listing.

2013-01-05 16:13  castaglia

	* contrib/mod_sftp/fxp.c:
	  Map the OPENDIR/CLOSE SFTP requests to the MLSD FTP command, for
	  better interaction with the configuration (and with other modules
	  such as mod_snmp).

2013-01-05 14:49  castaglia

	* contrib/mod_sftp/fxp.c:
	  Remove spurious/unnecessary event generation (this particular
	  event is generated elsewhere); bad patch application?

2013-01-05 08:30  castaglia

	* src/pool.c:
	  Bug#3857 - ProFTPD 1.3.5rc1 API test suite fails.

2013-01-04 19:36  castaglia

	* src/event.c, src/netaddr.c, tests/api/event.c,
	  tests/api/netaddr.c, tests/api/scoreboard.c, tests/api/stubs.c:
	  Bug#3856 - Linking ProFTPD 1.3.5rc1 API test suite fails.

	  This will teach me to actually run the API tests before
	  releasing.  Sigh.

2013-01-04 16:30  castaglia

	* src/dirtree.c:
	  Slightly better approach (avoids having root privs while writing
	  out a log; that's not needed).

2013-01-04 16:26  castaglia

	* src/: dirtree.c, parser.c:
	  Bug#3855 was a pain to track down because we don't report any
	  parsing errors encountered for Include'd files.  Now fixed.

2013-01-04 15:07  castaglia

	* doc/howto/Scoreboard.html:
	  One more tool affected by disabling of scoreboarding.

2013-01-04 15:03  castaglia

	* include/version.h:
	  Bumped version for the next RC.

2013-01-04 14:18  castaglia

	* ChangeLog:
	  Updated ChangeLog.

2013-01-04 14:17  castaglia

	* locale/files.txt:
	  Updates files.txt, for localization efforts.

2013-01-04 14:16  castaglia

	* NEWS, contrib/dist/rpm/proftpd.spec, include/version.h:
	  Updating versions, dates, getting ready to release 1.3.5rc1.

2013-01-04 13:47  castaglia

	* NEWS, src/dirtree.c:
	  Backport of fix for Bug#3855 to 1.3.4 branch.

2013-01-04 13:47  castaglia

	* NEWS, src/dirtree.c:
	  Bug#3855 - Restarting proftpd may cause Include files not to be
	  parsed.

2013-01-04 12:32  castaglia

	* doc/modules/mod_auth.html:
	  Add CreateHome description to the mod_auth docs.

2013-01-04 12:19  castaglia

	* tests/t/lib/ProFTPD/Tests/Signals/HUP.pm:
	  Minor nits, adding delays to avoid races to make the test more
	  robust.

2013-01-04 12:12  castaglia

	* modules/mod_core.c:
	  Use the PR_USE_HOST guard in more places.  Move the registration
	  of the restart event listener to a more appropriate/expected
	  location.

2013-01-04 11:34  castaglia

	* src/event.c:
	  Handle the case where the first event listener is for a core
	  callback, in which case where are no existing lists of listeners.

2013-01-04 07:34  castaglia

	* tests/t/lib/ProFTPD/Tests/Commands/STOR.pm:
	  Using assert_transfer_ok() in more tests.

2013-01-03 22:15  castaglia

	* tests/t/lib/ProFTPD/Tests/Commands/APPE.pm:
	  Using assert_transfer_ok() in more tests.

2013-01-03 22:10  castaglia

	* tests/t/lib/ProFTPD/Tests/Config/UseSendfile.pm:
	  Using assert_transfer_ok() in more tests.

2013-01-03 22:02  castaglia

	* tests/t/lib/ProFTPD/Tests/Commands/LIST.pm:
	  Using assert_transfer_ok() in more tests.

2013-01-03 21:16  castaglia

	* tests/t/lib/ProFTPD/Tests/Commands/ABOR.pm:
	  Start using the assert_transfer_ok() function in more tests.

2013-01-03 14:40  castaglia

	* tests/t/lib/ProFTPD/Tests/Logging/ExtendedLog.pm:
	  Make some of the ExtendedLog tests more robust.

2013-01-03 14:35  castaglia

	* modules/mod_core.c:
	  Guard the HOST implementation with #ifdefs, as it is not yet
	  ready for public use.

2013-01-03 14:29  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_sftp_sql.pm:
	  Fixed failing test, added new regression test.  Updated tests to
	  use testcase- specific logging.

2013-01-03 14:16  castaglia

	* contrib/mod_sql.c:
	  Don't log an error about having no SQLAuthTypes configured if
	  SQLAuthenticate has been explicitly configured to be 'off'.

2013-01-03 14:01  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_sftp/wrap2.pm:
	  Update tests to use testcase-specific logging.  Fix test code
	  issue (bad expectation).

2013-01-03 13:53  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_sftp/rewrite.pm:
	  Updated tests to use testcase-specific logging.

2013-01-03 13:51  castaglia

	* contrib/mod_sftp/: scp.c:
	  Remove debugging cruft.

2013-01-03 13:50  castaglia

	* contrib/mod_sftp/scp.c:
	  Backporting fix from trunk.

2013-01-03 13:49  castaglia

	* contrib/mod_sftp/scp.c:
	  Fix regression caught by testsuite.

2013-01-03 13:16  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_sftp.pm:
	  Update mod_sftp unit tests to weed out some known bad tests (bad
	  due to client issues), fix up others, etc.

2013-01-03 12:20  castaglia

	* contrib/mod_sql.c, contrib/mod_sftp/fxp.c, modules/mod_log.c:
	  Fix another regression caught by the testsuite, concerning the
	  handling of the %F LogFormat variable.

2013-01-03 11:12  castaglia

	* src/event.c:
	  Backporting fix for regression from trunk.

2013-01-03 11:12  castaglia

	* src/event.c:
	  Fix another regression caught by the testsuite, caused by the
	  change in ordering of event listener subscription.  This tweak
	  moves all core event listeners to the end of the list, to be
	  invoked last.

2013-01-03 10:12  castaglia

	* contrib/mod_sftp/fxp.c:
	  Backporting of regression fix from trunk.

2013-01-03 10:10  castaglia

	* contrib/mod_sftp/fxp.c:
	  Fixed regression caused by use of new pr_fsio_smkdir() function,
	  which expects the given path to be a canonical path.	Now SFTP
	  mkdir requests work again.

2013-01-03 10:08  castaglia

	* src/fsio.c:
	  Stylistic nit (extraneous whitespace); no functional change.

2013-01-03 09:22  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_quotatab/copy.pm:
	  Update the mod_quotatab+mod_copy tests to use testcase-specific
	  logging.  Fixed "broken" tests to work properly on different
	  platforms.

2013-01-03 09:04  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_delay.pm:
	  Allow more time for one of the mod_delay unit tests to run, and
	  mark it as a 'slow' test.

2013-01-02 17:17  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_quotatab_file.pm:
	  Update these tests to use testcase-specific logging.	Make them
	  more robust with data transfers by using the assert_transfer_ok()
	  function.

2013-01-02 17:13  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_quotatab_sql.pm:
	  Minor tweaks help this testcase to pass more often (timing issues
	  related to closing the data connection, it seems).

2013-01-02 16:44  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_wrap2_sql.pm:
	  Update the mod_wrap2_sql tests to pass.  Added checks for the
	  module load order; one of the tests is sensitive to this.

2013-01-02 16:43  castaglia

	* tests/t/lib/ProFTPD/TestSuite/Utils.pm:
	  Expose the utility function for obtaining the list of compiled-in
	  modules.

2013-01-02 16:21  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_wrap2_file.pm:
	  Fix test code issues so that all of the mod_wrap2_file tests
	  pass.

2013-01-02 16:14  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_tls_shmcache.pm:
	  Use testcase-specific logging.  Avoid verification errors by
	  providing the CA file to the openssl s_client command.

2013-01-02 15:50  castaglia

	* contrib/mod_tls.c:
	  Remove the SSL_COMP_add_compression_method() ifdef; it won't be
	  used.

2013-01-02 15:46  castaglia

	* RELEASE_NOTES:
	  Typo.

2013-01-02 15:45  castaglia

	* RELEASE_NOTES, contrib/mod_tls.c:
	  Update the release notes with the updated TLSCipherSuite
	  defaults, i.e.  no anonymous Diffie-Hellman key exchanges.

	  Disable SSL compression.

2013-01-02 15:02  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_sql_sqlite.pm:
	  Fix some failing mod_sql_sqlite tests by providing the necessary
	  custom SQLUserInfo queries.

2013-01-02 14:38  castaglia

	* contrib/mod_tls.c:
	  Testsuite caught a regression in the handling of the
	  TLSPKCS12File directive.

2013-01-02 14:24  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_rewrite.pm:
	  If the DateTime Perl module is not present, then do not try to
	  run some of the mod_rewrite unit tests which require it.  With
	  this tweak, at least some of the mod_rewrite unit tests run,
	  rather than having none of them run because Perl complains that
	  the DateTime module is not present.

2013-01-02 13:56  castaglia

	* src/scoreboard.c:
	  When opening an fd for the ScoreboardFile, make sure that we do
	  NOT use one of the Big Three fds (i.e. no 0, 1, or 2).

2013-01-02 13:50  castaglia

	* src/scoreboard.c:
	  Guard against "Illegal seek" lseek(2) error by detecting/catching
	  a call to pr_restore_scoreboard() before pr_rewind_scoreboard()
	  has been called.

2013-01-02 13:20  castaglia

	* tests/t/lib/ProFTPD/Tests/Config/FTPAccess/Empty.pm:
	  Updating .ftpaccess file tests to use testcase-specific logging.

2013-01-02 13:15  castaglia

	* tests/t/lib/ProFTPD/Tests/Config/DirFakeGroup.pm:
	  More fixes to the DirFakeGroup tests to make the tests pass
	  properly; these are issues with the testing code, not the core
	  proftpd code.

2013-01-02 13:08  castaglia

	* RELEASE_NOTES:
	  Updated the release notes, preparing for a release.

2013-01-02 11:06  castaglia

	* doc/contrib/mod_quotatab.html:
	  Adding description of QuotaDefault directive to mod_quotatab
	  docs.

2013-01-02 09:40  castaglia

	* contrib/mod_tls.c:
	  Fix compiler warning about unused variable.

2013-01-02 09:39  castaglia

	* tests/t/lib/ProFTPD/Tests/Config/Directory/Umask.pm:
	  Start using testcase-specific logging for these tests.

2013-01-02 09:38  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_exec.pm:
	  Fix some Perl warnings when running the mod_exec tests.

2012-12-28 18:49  castaglia

	* doc/contrib/mod_tls.html:
	  Typo.

2012-12-28 17:20  castaglia

	* tests/t/lib/ProFTPD/Tests/Logging/TransferLog.pm:
	  Updated/fixed tests.

2012-12-28 17:16  castaglia

	* tests/t/lib/ProFTPD/Tests/Logging/ExtendedLog.pm:
	  Use the assert_transfer_ok() function in a few more places.

2012-12-28 17:08  castaglia

	* tests/t/lib/ProFTPD/Tests/Config/Trace.pm:
	  Updated tests to deal with Trace logging changes.  Added
	  testcase-specific logging.

2012-12-28 16:57  castaglia

	* tests/t/lib/ProFTPD/Tests/Config/ShowSymlinks.pm:
	  Update tests to deal with different platforms' symlink permission
	  defaults.

2012-12-28 16:47  castaglia

	* tests/t/lib/ProFTPD/Tests/Config/HideNoAccess.pm:
	  Update tests to use testcase-specific logging, and the
	  assert_transfer_ok() function.

2012-12-28 16:45  castaglia

	* src/privs.c:
	  Testsuite caught another regression; now fixed.

2012-12-28 16:12  castaglia

	* tests/t/lib/ProFTPD/Tests/Config/FTPAccess/DELE.pm:
	  Updating test to use testcase-specific logging.

2012-12-28 16:11  castaglia

	* src/fsio.c:
	  Backporting fix from trunk.

2012-12-28 16:11  castaglia

	* src/fsio.c:
	  When safely creating directories, allow the parent directory path
	  to be a symlink.

2012-12-28 15:28  castaglia

	* tests/t/lib/ProFTPD/Tests/Config/DirFakeUser.pm:
	  Fixing up tests.

2012-12-28 15:20  castaglia

	* modules/mod_facts.c:
	  Regression for Bug#3715 now fixed.

2012-12-28 15:17  castaglia

	* modules/mod_facts.c:
	  Caching/preserving of errno values, some stylistic nits.

2012-12-28 14:40  castaglia

	* tests/t/lib/ProFTPD/Tests/Config/DirFakeGroup.pm:
	  Fix testware issue on Linux; update tests to use
	  assert_transfer_ok().

2012-12-28 14:31  castaglia

	* tests/t/lib/ProFTPD/Tests/Config/DirFakeGroup.pm:
	  Updating to use testcase-specific logging.

2012-12-28 14:22  castaglia

	* src/dirtree.c:
	  Testsuite caught a regression; now fixed.

2012-12-28 14:09  castaglia

	* src/dirtree.c:
	  Stylistic nits; no functional change.

2012-12-28 13:38  castaglia

	* doc/howto/Compiling.html:
	  Adding more compiling FAQs.

2012-12-28 12:55  castaglia

	* tests/t/lib/ProFTPD/Tests/Commands/PASS.pm:
	  Fill in the testcase for a password which contains spaces.

2012-12-28 12:52  castaglia

	* modules/mod_core.c:
	  Don't advertise support for the HOST command just yet, as it has
	  not been completely implemented as yet.

2012-12-28 11:54  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/: mod_tls.pm, mod_wrap2_sql.pm:

	  Fix re-declaration of variables.

2012-12-28 11:20  castaglia

	* tests/t/lib/ProFTPD/Tests/Config/ListOptions.pm:
	  Fix re-declaration of variable.

2012-12-28 11:19  castaglia

	* tests/t/lib/ProFTPD/Tests/Config/HideFiles.pm:
	  Quell compiler warning about use of uninitialized value.

2012-12-28 11:16  castaglia

	* tests/t/lib/ProFTPD/Tests/: Modules/mod_ban.pm, Signals/HUP.pm:
	  Now that server_restart() is provided by the Utils class, these
	  tests no longer need to provide their own implementations.

2012-12-28 09:40  castaglia

	* src/cmd.c:
	  Quell compiler warning.

2012-12-28 09:34  castaglia

	* modules/mod_core.c:
	  Remove unused variable, quelling compiler warning.

2012-12-28 09:33  castaglia

	* modules/mod_core.c:
	  Remove unused variable.

2012-12-27 18:56  castaglia

	* src/throttle.c:
	  Style nits.  Fix one minor edge case, where the signal mask would
	  not be restored properly if the transfer was aborted.

2012-12-27 18:37  castaglia

	* src/fsio.c:
	  Minor nits; no functional change.

2012-12-27 16:03  castaglia

	* NEWS, include/fsio.h, contrib/mod_sftp/fxp.c,
	  contrib/mod_sftp/scp.c, modules/mod_core.c, src/fsio.c:
	  Backport of fix for Bug#3841 to 1.3.4 branch.

2012-12-27 16:02  castaglia

	* NEWS, contrib/mod_sftp/fxp.c, contrib/mod_sftp/scp.c,
	  include/fsio.h, modules/mod_core.c, src/fsio.c:
	  Bug#3841 - Possible symlink race when applying UserOwner to newly
	  created directory.

2012-12-27 15:55  castaglia

	* tests/t/lib/ProFTPD/Tests/Commands/MKD.pm:
	  Some additional regression tests for MKD/XMKD commands.

2012-12-27 15:01  castaglia

	* doc/howto/FTP.html:
	  Provide links to the mod_tls docs where appropriate.

2012-12-27 14:46  castaglia

	* contrib/mod_sftp/fxp.c:
	  Remove duplicate event.

2012-12-27 14:37  castaglia

	* contrib/mod_sftp/fxp.c:
	  Update mod_sftp to use the pr_cmd_set_name() function as well.

2012-12-27 14:31  castaglia

	* contrib/mod_copy.c, contrib/mod_quotatab.c, modules/mod_core.c:
	  Start updating modules to use the new pr_cmd_set_name() function.

2012-12-27 14:30  castaglia

	* include/cmd.h, src/cmd.c:
	  Introduce new pr_cmd_set_name() function, for setting the cmd_rec
	  name AND for resetting the cmd_id properly (so that I don't
	  forget in the future).

2012-12-27 14:29  castaglia

	* contrib/mod_sftp/fxp.c:
	  Backporting fix from trunk: when changing the name of a cmd_rec,
	  make sure the cmd_id is also reset.

2012-12-27 11:15  castaglia

	* doc/howto/TLS.html:
	  Add another FileZilla-related mod_tls FAQ.

2012-12-27 10:59  castaglia

	* modules/: mod_core.c, mod_log.c:
	  Try to provide better error messages.

2012-12-27 10:50  castaglia

	* doc/howto/Logging.html:
	  Adding logging FAQ about FIFOs.

2012-12-27 10:29  castaglia

	* doc/howto/FTP.html:
	  Add FAQ to FTP howto, talking about renaming of directories
	  across mount points.

2012-12-26 16:38  castaglia

	* modules/: mod_core.c:
	  Updating mod_core to use the new pr_fsio_lchown() function.

2012-12-26 15:38  castaglia

	* modules/mod_log.c:
	  Backport of errno logging fix from trunk.

2012-12-26 15:37  castaglia

	* modules/mod_log.c:
	  Report the correct error reason if we can't open an ExtendedLog.

2012-12-26 15:33  castaglia

	* include/fsio.h, modules/mod_xfer.c, src/fsio.c:
	  Backport part of the fix for Bug#3841 from trunk (i.e. adding
	  pr_fsio_lchown()).

2012-12-26 15:18  castaglia

	* contrib/mod_sftp/misc.c, include/fsio.h, modules/mod_xfer.c,
	  src/fsio.c:
	  Implement part of the fix for Bug#3841 by providing a
	  pr_fsio_lchown() function.

2012-12-26 14:36  castaglia

	* modules/mod_log.c:
	  Fix handling of SIGHUP with regard to SystemLog.  The problem was
	  that we were re-opening the SystemLog file itself in the restart
	  event listener; after the restart event listeners are triggered,
	  init_log() is called which itself closes the SystemLog.  Oops.

2012-12-26 09:21  castaglia

	* doc/modules/mod_cap.html:
	  Adding description of the new CapabilitiesRootRevoke directive.

2012-12-24 14:52  castaglia

	* src/event.c:
	  Merging change from trunk which fixes ordering of event
	  notification subscriptions.

2012-12-24 14:51  castaglia

	* src/event.c:
	  Fix the handling of event notification subscription.
	  Specifically, modules that were loaded last would receive the
	  event notification last.

	  And if that notification were for the 'core.restart' event, AND
	  the subscribing module was built as a shared module, this would
	  mean that that module would NEVER be notified; the mod_dso
	  'core.restart' event handler would be notified first, and would
	  unload all shared modules.

	  The fix, then, is to have the modules loaded last have their
	  notifications be delivered first.  This was the intended ordering
	  in the first place.

2012-12-21 13:45  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_cap.pm:
	  Adding regression tests for Bug#3839.

2012-12-21 13:44  castaglia

	* configure:
	  Updated configure.

2012-12-21 13:18  castaglia

	* NEWS, RELEASE_NOTES, config.h.in, configure.in,
	  modules/mod_cap.c:
	  Bug#3839 - Enhance mod_cap to support dropping root privs
	  entirely.

2012-12-21 10:21  castaglia

	* RELEASE_NOTES, doc/modules/mod_auth.html:
	  Adding description of new AllowChrootSymlinks directive to
	  mod_auth docs.

2012-12-20 15:54  castaglia

	* NEWS, RELEASE_NOTES, modules/mod_auth.c:
	  Bug#3852 - Support directive for ignoring symlink DefaultRoot
	  directories.

2012-12-20 15:53  castaglia

	* tests/t/lib/ProFTPD/Tests/: Logins.pm, Config/DefaultRoot.pm:
	  Checking in the regression tests for the new AllowChrootSymlinks
	  directive, part of Bug#3852.

2012-12-18 14:03  castaglia

	* NEWS, contrib/mod_sftp/keys.c:
	  Backport of fix for Bug#3851 to 1.3.4 branch.

2012-12-18 14:03  castaglia

	* NEWS, contrib/mod_sftp/keys.c:
	  Bug#3851 - SFTPPassPhraseProvider fails due to incorrect pointer.

2012-12-18 14:01  castaglia

	* tests/t/: etc/modules/mod_sftp/passphrase_host_dsa_key,
	  etc/modules/mod_sftp/passphrase_host_dsa_key.pub,
	  etc/modules/mod_sftp/passphrase_host_rsa_key,
	  etc/modules/mod_sftp/passphrase_host_rsa_key.pub,
	  etc/modules/mod_sftp/sftp-get-passphrase.pl,
	  lib/ProFTPD/Tests/Modules/mod_sftp.pm:
	  Adding regression test for SFTPPassPhraseProvider (Bug#3851).

2012-12-13 16:16  castaglia

	* NEWS, RELEASE_NOTES, contrib/ftpasswd, doc/contrib/ftpasswd.html:

	  Bug#3850 - ftpasswd should support generating SHA-256, SHA-512
	  hashes where possible.

2012-12-13 15:56  castaglia

	* contrib/mod_sftp/: auth.c, compress.c, packet.c:
	  Forgot to update copyright dates in the modified files.

2012-12-13 15:05  castaglia

	* contrib/mod_sftp/: auth.c, compress.c, fxp.c, packet.c, scp.c:
	  Backport some of the mod_sftp event generation code from trunk.

2012-12-13 15:05  castaglia

	* contrib/mod_sftp/: auth.c, compress.c, fxp.c, packet.c, scp.c:
	  Instrument mod_sftp by generating events under certain
	  conditions, for the benefit of any other modules (e.g. mod_snmp)
	  who might be interested.

2012-12-13 06:50  castaglia

	* doc/howto/TLS.html:
	  Add missing closing font tag.

2012-12-11 11:41  castaglia

	* doc/utils/index.html:
	  Typo.

2012-12-10 16:14  castaglia

	* configure:
	  Updated configure.

2012-12-10 15:51  castaglia

	* config.h.in, configure.in, contrib/mod_sql_mysql.c:
	  Backporting changes from trunk, where we extend the check for
	  MySQL functions (see Bug#3669).

2012-12-10 15:01  castaglia

	* contrib/mod_sftp/crypto.c:
	  Fixed typo in comment.

2012-12-09 20:49  castaglia

	* modules/mod_auth.c:
	  Backporting fix from trunk: generate an event whenever we can't
	  find the requested user name during login.

2012-12-09 14:04  castaglia

	* contrib/mod_tls.c:
	  Use more stable pools for allocating environment variables (the
	  main_server pointer can change, e.g. due to the HOST command).

	  Generate events when our SSL/TLS handshake fails (both ctrl and
	  data conns).

2012-12-09 09:52  castaglia

	* modules/mod_auth.c:
	  Make sure that if we cannot find the requested USER name, we
	  still fire the "authentication-code" event, for any interested
	  listeners (e.g.  mod_snmp).

2012-12-06 19:21  castaglia

	* modules/mod_auth_file.c:
	  If an AuthUserFile happens to contain an empty password field,
	  make sure we handle such a file the same way on a Mac OSX
	  platform as on a Linux/BSD platform.	The difference is in how
	  the crypt(3) function handles the case of a salt argument that is
	  an empty string; the crypt(3) implementations differ in this
	  particular case, and so the mod_auth_file module does a runtime
	  check for this.

2012-12-06 19:18  castaglia

	* tests/: tests.pl, t/config/authuserfile.t,
	  t/lib/ProFTPD/Tests/Config/AuthUserFile.pm:
	  Adding AuthUserFile tests now.

2012-12-06 19:03  castaglia

	* tests/t/lib/ProFTPD/TestSuite/Utils.pm:
	  Allow for specifying empty password values for an AuthUserFile.

2012-12-06 18:59  castaglia

	* tests/t/lib/ProFTPD/Tests/Config/AuthGroupFile.pm:
	  Updated AuthGroupFile test to use testcase-specific logging.

2012-12-05 21:52  castaglia

	* configure:
	  Updated configure.

2012-12-05 21:48  castaglia

	* config.h.in, configure.in, contrib/mod_sql_mysql.c:
	  As part of Bug#3669, check for the RedHat distribution's changes
	  to MySQL, since they export the my_make_scrambled_password
	  symbol.

2012-12-05 15:12  castaglia

	* tests/t/lib/ProFTPD/TestSuite/Utils.pm:
	  Add utility server_restart() function for tests which need to HUP
	  the running daemon.

2012-12-05 13:18  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_sql_sqlite.pm:
	  Start creating indexes on the columns in the SQLite test cases.
	  This way, the tests can provide "best practice" SQL scripts.

2012-12-05 13:04  castaglia

	* doc/utils/index.html:
	  Add link to ftpshut docs.  Fix typo.

2012-12-05 07:37  castaglia

	* doc/contrib/mod_ban.html:
	  Bad grammar.

2012-12-04 11:59  castaglia

	* doc/utils/: ftpmail.html:
	  Typo.

2012-12-04 11:07  castaglia

	* NEWS, modules/mod_auth.c:
	  Bug#3846 - Avoid scanning ScoreboardFile needlessly on login if
	  limits are not configured.

2012-12-03 18:28  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_tls.pm:
	  Adding regression test for FTPS login using mod_tls and a DSA
	  server certificate.

2012-12-03 18:26  castaglia

	* tests/t/etc/modules/mod_tls/: NOTES, dsa-ca.pem,
	  dsa-server-cert.pem:
	  Adding DSA server cert, for DSA-specific testing.

2012-12-03 15:55  castaglia

	* contrib/mod_sql.c:
	  Debug logging of the number of fields/columns returned by the
	  custom SQLUserInfo, for triage.

2012-12-03 15:54  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_sql_sqlite.pm:
	  Adding testcase showing how SQLite and mod_sql can be used to
	  enforce a MaxHostsPerUser restriction in a much more efficient
	  manner than that used by the mod_auth module.

2012-12-03 15:11  castaglia

	* src/netio.c:
	  Remove unused variable.

2012-12-03 11:07  castaglia

	* NEWS, contrib/mod_sftp/auth.c:
	  Backport of fix for Bug#3845 to 1.3.4 branch.

2012-12-03 11:06  castaglia

	* NEWS, contrib/mod_sftp/auth.c:
	  Bug#3845 - mod_sftp does not provide response codes for %s
	  LogFormat variable for AUTH ExtendedLog.

2012-12-03 11:04  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_sftp.pm:
	  Adding regression test for Bug#3845.

2012-12-01 16:33  castaglia

	* doc/howto/ServerType.html:
	  Updating ServerType howto to use relative links.

2012-12-01 16:32  castaglia

	* doc/modules/mod_core.html:
	  Adding description of ServerType directive to mod_core docs.

2012-12-01 16:23  castaglia

	* doc/howto/Debugging.html:
	  Updating Debugging howto.

2012-12-01 10:40  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_sftp.pm:
	  Adding mod_sftp unit tests for the handling of %f and %r
	  LogFormat variables for SFTP WRITE requests.

2012-12-01 10:39  castaglia

	* contrib/mod_sftp/fxp.c:
	  Add more information to the cmd_rec logged for a WRITE request,
	  such that the %r LogFormat variable will also include the file
	  offset and chunk length fields from the WRITE request.

	  Make sure to reset the cmd_id member for cmd_recs when changing
	  the cmd_rec name; otherwise, the cmd_id value will not be reset,
	  and logging may not Do The Right Thing(tm) with that cmd_rec.
	  This was the cause of %f LogFormat variables not being
	  interpolated properly by mod_log for WRITE requests.

2012-11-30 20:57  castaglia

	* contrib/mod_sftp/fxp.c:
	  Fix log message typos/nits.

2012-11-27 15:13  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_radius.pm:
	  Added testcase demonstrating that use of "%u" for the home
	  attribute works as expected.

	  Updated testcases to use testcase-specific logging.

2012-11-27 09:27  castaglia

	* modules/mod_auth_unix.c:
	  Adding trace logging, for better analysis of shadow/autoshadow
	  user lookup issues.

2012-11-21 07:50  castaglia

	* modules/mod_auth_unix.c:
	  More debug logging for when user entry retrieval fails.

2012-11-19 20:02  castaglia

	* doc/contrib/mod_sql_passwd.html:
	  Fixed markup typo.

2012-11-19 15:42  castaglia

	* NEWS, modules/mod_dso.c:
	  Bug#3843 - ProFTPD should not fail when starting up due to
	  loading same module multiple times.

2012-11-19 13:31  castaglia

	* doc/modules/mod_dso.html:
	  Another DSO FAQ, about the "already loaded" error for
	  special-case modules like mod_ctrls.

2012-11-19 13:18  castaglia

	* doc/modules/mod_dso.html:
	  Adding FAQ about already loaded modules (will be fixed with
	  Bug#3843).

2012-11-16 09:38  castaglia

	* modules/: mod_auth_unix.c:
	  Log, at debug level 3, when getspnam(3) and getpwnam(3) fail (and
	  why).

2012-11-15 10:25  castaglia

	* contrib/mod_sftp/crypto.c:
	  Adding more substantial description of the situation which lead
	  to the preprocessor guards for AES-CTR modes in mod_sftp, for my
	  future self (and others).

2012-11-15 08:33  castaglia

	* contrib/mod_quotatab.c:
	  Use session.pool instead of main_server->pool; the latter can
	  change during the lifetime of a session, whereas the former does
	  not.

2012-11-14 14:13  castaglia

	* contrib/mod_sftp/: crypto.c:
	  For the AES-CTR implementation, only set the NID if we're working
	  with a FIPS-enabled OpenSSL library.

2012-11-14 10:28  castaglia

	* NEWS, contrib/mod_sftp/fxp.c:
	  Backport of fix for Bug#3842 to 1.3.4 branch.

2012-11-14 10:27  castaglia

	* NEWS, contrib/mod_sftp/fxp.c:
	  Bug#3842 - Incorrect handling of REALPATH requests for symlink
	  paths in mod_sftp.

2012-11-14 10:23  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_sftp.pm:
	  Finishing the SFTP REALPATH tests (per Bug#3842).

2012-11-13 17:47  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_sftp.pm:
	  Adding tests for mod_sftp's handling of REALPATH requests on
	  different types of paths: files, directories, symlinks, chrooted
	  or not, etc.

2012-11-13 17:37  castaglia

	* tests/t/lib/ProFTPD/Tests/Config/HideFiles.pm:
	  Adding testing of HideFiles/IgnoreHidden configuration on MLSD.

2012-11-13 14:09  castaglia

	* doc/modules/mod_facts.html:
	  Adding FAQ about dotfiles and MLSD.

2012-11-13 13:46  castaglia

	* NEWS, contrib/mod_sql.c, modules/mod_log.c:
	  Backport of fix for Bug#3822 to 1.3.4 branch.

2012-11-13 13:16  castaglia

	* tests/t/lib/ProFTPD/Tests/Config/HideFiles.pm:
	  Adding PCRE-based HideFiles test.

2012-11-11 17:39  castaglia

	* configure:
	  Updated configure.

2012-11-11 17:21  castaglia

	* config.h.in, configure.in:
	  Adding autoconf check for mkdtemp(3), as part of fix for
	  Bug#3841.

2012-11-08 11:18  castaglia

	* tests/t/lib/ProFTPD/Tests/Config/UserOwner.pm:
	  Updating UserOwner tests to use testcase-specific logging, and
	  added test for UserOwner+MKD.

2012-11-05 10:05  castaglia

	* doc/modules/mod_auth.html:
	  Add docs for the RewriteHome directive.

2012-10-29 15:51  castaglia

	* NEWS, contrib/mod_tls.c:
	  Backport of fix for Bug#3837 to 1.3.4 branch.

2012-10-29 15:50  castaglia

	* NEWS, contrib/mod_tls.c:
	  Bug#3837 - mod_tls unable to read certificate files after SIGHUP.

2012-10-24 14:27  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_sftp.pm:
	  Adding regression tests for SFTP uploads which demonstrate that
	  AllowFilter works as expected in a <Limit> STOR section.

2012-10-23 17:02  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_ratio.pm:
	  Adding mod_ratio regression test ensuring that the RatioFile is
	  updated as expected after session closure.

2012-10-21 17:55  castaglia

	* tests/: tests.pl, t/config/allowfilter.t,
	  t/lib/ProFTPD/Tests/Config/AllowFilter.pm:
	  Adding regression tests for the AllowFilter directive.

2012-10-13 21:11  castaglia

	* doc/howto/ConfigurationTricks.html:
	  Add another configuration trick (using env vars, -D, and
	  <IfDefine>) to the collection.

2012-10-13 20:55  castaglia

	* tests/t/lib/ProFTPD/Tests/Config/IfDefine.pm:
	  Now the <IfDefine> regression test for dealing with environment
	  variables work as I intended.

2012-10-13 20:52  castaglia

	* src/parser.c:
	  In fact, why not use one strlen(3) call instead of three in the
	  get_config_word() function.

2012-10-13 20:50  castaglia

	* src/parser.c:
	  Minor change: use a single strlen(3) call instead of two.

2012-10-11 19:51  castaglia

	* doc/howto/FTP.html:
	  Updating the stale list of supported commands.

2012-10-11 19:44  castaglia

	* modules/mod_xfer.c:
	  Stylistic cleanup of nits in the handling of the MODE command; no
	  functional change.

2012-10-11 19:21  castaglia

	* doc/howto/DSO.html:
	  Adding FAQ to DSO doc about adding modules to proftpd.

2012-10-10 23:12  castaglia

	* include/netio.h, src/netio.c:
	  Added a useful variant of pr_netio_printf(), allowing for a
	  va_list argument to be passed in (e.g. for use by functions which
	  themselves take variadic arguments).

2012-10-10 13:38  castaglia

	* tests/t/lib/ProFTPD/Tests/Commands/PWD.pm:
	  Adding regression test for PWD commands using the upload-only
	  directory config described in the Limit howto.

2012-10-10 13:27  castaglia

	* doc/howto/Limit.html:
	  Update upload-only directory example config to allow PWD.  Some
	  clients get cranky if PWD doesn't work.

2012-10-09 23:31  castaglia

	* src/dirtree.c:
	  When discovering the optimal TCP buffer sizes, set the discovered
	  sizes on our main_server rec as well.

2012-10-09 18:26  castaglia

	* doc/modules/mod_lang.html:
	  Update the mod_lang docs with a FAQ about the "not a supported
	  language" error.

2012-10-09 08:54  castaglia

	* locale/: es_ES.po:
	  Updated .po file from Bug#3834.

2012-10-05 13:52  castaglia

	* doc/modules/mod_lang.html:
	  Mention the new Spanish translation in the mod_lang docs.

2012-10-05 13:50  castaglia

	* RELEASE_NOTES, locale/Makefile.in, locale/es_ES.po:
	  Bug#3834 - Spanish translation.

2012-10-03 22:21  castaglia

	* doc/howto/Logging.html:
	  Add Logging FAQ, inspired by Bug#3832.

2012-10-03 22:17  castaglia

	* doc/howto/: KeepAlives.html, index.html:
	  Adding new KeepAlives howto.

2012-10-03 09:41  castaglia

	* modules/mod_core.c:
	  Slightly better error reporting for badly formed keepalive specs.

2012-10-03 09:36  castaglia

	* doc/modules/mod_core.html:
	  Adding docs for the new keepalive SocketOptions parameter.

2012-10-03 09:22  castaglia

	* NEWS, RELEASE_NOTES, include/dirtree.h, include/inet.h,
	  modules/mod_core.c, src/data.c, src/dirtree.c, src/inet.c,
	  src/parser.c:
	  Bug#3833 - Enable TCP keepalive by default, with configurable
	  SocketOption.

2012-10-02 22:24  castaglia

	* doc/modules/mod_core.html:
	  Add docs for the SocketOptions directive to the mod_core docs.

2012-10-02 14:49  castaglia

	* NEWS, src/data.c:
	  Backported fix for Bug#3831 to 1.3.4 branch.

2012-10-02 14:48  castaglia

	* NEWS, src/data.c:
	  Bug#3831 - Sporadic "451 Insufficient memory or file locked"
	  failure when downloading.

2012-10-02 12:49  castaglia

	* modules/mod_memcache.c:
	  Fix compilation errors in mod_memcache, when --enable-memcache is
	  used.

2012-10-02 10:10  castaglia

	* Makefile.in:
	  Fixed typo in Makefile rules, for Bug#3725.

2012-10-01 14:26  castaglia

	* tests/: Makefile.in, api/fsio.c, api/stubs.c, api/tests.c,
	  api/tests.h:
	  Start working on unit tests for the FSIO API functions:
	  pr_fs_clean_path() is the first victim.

2012-10-01 14:14  castaglia

	* modules/mod_ls.c:
	  Even more robust checking for complex possible symlink targets,
	  as part of hardening against Bug#3719.

2012-10-01 14:08  castaglia

	* tests/t/lib/ProFTPD/Tests/Commands/LIST.pm:
	  Another regression test for Bug#3719, showing a more complex
	  symlink that should be considered "unsafe".

2012-10-01 10:56  castaglia

	* modules/mod_ls.c:
	  An "unsafe" symlink path must be 2 characters or greater in
	  length.

2012-10-01 10:54  castaglia

	* modules/mod_ls.c:
	  Make the check for "unsafe" symlinks in recursive directory
	  listings a little more robust, for Bug#3719.

2012-10-01 10:31  castaglia

	* contrib/mod_sftp/scp.c:
	  Backport of fix for Bug#3792 to 1.3.4 branch.

2012-10-01 10:19  castaglia

	* NEWS, contrib/mod_sftp/scp.c:
	  Bug#3792 - Recursive SCP uploads using preserve-time (-p) option
	  may not work.

2012-09-30 11:01  castaglia

	* NEWS, modules/mod_ls.c:
	  Fixed regression in fix for Bug#3719.

2012-09-30 10:55  castaglia

	* modules/mod_ls.c:
	  Fix regression caused by fix for Bug#3719.

2012-09-30 10:44  castaglia

	* tests/t/lib/ProFTPD/Tests/Commands/LIST.pm:
	  Adding additional regression test for Bug#3719.

2012-09-28 17:06  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_sftp.pm:
	  Updating mod_sftp regression tests to use testcase-specific
	  logging across the board.

2012-09-28 15:23  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_sftp.pm:
	  Adding regression test for recursive SCP uploads which use the
	  preserve time/mode option, for Bug#3792.

2012-09-28 14:37  castaglia

	* contrib/mod_sftp/scp.c:
	  Quell comparing warning about signedness; it's a harmless cast in
	  this case.

2012-09-27 22:20  castaglia

	* configure:
	  Updated configure.

2012-09-27 22:16  castaglia

	* configure.in:
	  Some platforms (e.g. Mac OSX) require that the <sys/socket.h>
	  header be included before including <net/if.h>, otherwise
	  autoconf complains about seeing <net/if.h> but not being able to
	  use it.  Hopefully this doesn't break the check for the
	  <net/if.h> header on other platforms.

2012-09-27 21:52  castaglia

	* RELEASE_NOTES:
	  Adding reminder to release notes to mention SystemLog changes for
	  Bug#3832.

2012-09-27 21:51  castaglia

	* NEWS, modules/mod_log.c:
	  Bug#3832 - Support disabling of system logging on per-connection
	  basis.

2012-09-27 21:24  castaglia

	* tests/: tests.pl, t/lib/ProFTPD/Tests/Logging/ServerLog.pm,
	  t/lib/ProFTPD/Tests/Logging/SystemLog.pm, t/logging/serverlog.t:
	  Adding ServerLog tests for Bug#3832 as well, and updating the
	  SystemLog tests (which were pointed at the wrong log file).

2012-09-27 18:32  castaglia

	* tests/t/lib/ProFTPD/Tests/Logging/SystemLog.pm:
	  Updated tests for Bug#3832 so that they work properly.

2012-09-27 17:21  castaglia

	* tests/t/lib/ProFTPD/Tests/Logging/SystemLog.pm:
	  Adding unit tests for verifying the change/fix for Bug#3832.

2012-09-27 10:52  castaglia

	* doc/howto/Tracing.html:
	  Typo.

2012-09-26 09:40  castaglia

	* modules/mod_xfer.c:
	  Fix logging of spurious EEXIST error when adding a note to the
	  session notes.

2012-09-25 16:21  castaglia

	* doc/contrib/mod_sftp.html:
	  Document the network latency impact of the SFTPTrafficPolicy
	  behavior for CBC ciphers, and include a FAQ on the issue.

2012-09-25 13:28  castaglia

	* doc/howto/Tracing.html:
	  Update the Tracing howto with a section discussing runtime tuning
	  of the trace levels.

2012-09-25 09:28  castaglia

	* doc/howto/TLS.html:
	  Add a section on client auth to the TLS howto.

2012-09-22 19:10  castaglia

	* NEWS, modules/mod_core.c:
	  Backport of fix for Bug#3829 to 1.3.4 branch.

2012-09-22 19:10  castaglia

	* NEWS, modules/mod_core.c:
	  Bug#3829 - RNFR without following RNTO can lead to NULL pointer
	  dereference.

2012-09-22 19:04  castaglia

	* tests/t/lib/ProFTPD/Tests/Commands/RNFR.pm:
	  Updating regression test for Bug#3829.

2012-09-22 12:09  castaglia

	* NEWS, modules/mod_facts.c:
	  Backport of fix for Bug#3830 to 1.3.4 branch.

2012-09-22 12:08  castaglia

	* NEWS, modules/mod_facts.c:
	  Bug#3830 - MFF/MFMT command segfaults due to insufficient
	  parameter checks.

2012-09-22 12:07  castaglia

	* tests/t/lib/ProFTPD/Tests/Commands/MFF.pm:
	  Update of regression test for Bug#3830.

2012-09-22 11:54  castaglia

	* doc/modules/mod_facts.html:
	  Update link to somers Draft which defines the MFF and MFMT
	  commands.

2012-09-21 15:49  castaglia

	* tests/t/lib/ProFTPD/Tests/Commands/MFF.pm:
	  Checking in regression test for Bug#3830.

2012-09-21 15:41  castaglia

	* tests/t/lib/ProFTPD/Tests/Commands/RNFR.pm:
	  Checking in regression test for Bug#3829.

2012-09-21 15:15  castaglia

	* NEWS:
	  Typo.

2012-09-21 15:14  castaglia

	* NEWS, contrib/mod_deflate.c:
	  Backport of fix for Bug#3828 to 1.3.4 branch.

2012-09-21 15:13  castaglia

	* NEWS, contrib/mod_deflate.c,
	  tests/t/lib/ProFTPD/Tests/Modules/mod_deflate.pm:
	  Bug#3828 - Certain sequences of FTP data transfer commands lead
	  to NULL pointer deferences in mod_deflate.

2012-09-21 14:00  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_deflate.pm:
	  Updated the mod_deflate tests to use testcase-specific logging.

2012-09-19 15:32  castaglia

	* NEWS, contrib/mod_sftp/fxp.c:
	  Bug#3827 - Use non-filesystem based SFTP handle generator instead
	  of mktemp(3).

2012-09-18 17:11  castaglia

	* src/prxs.in:
	  Even if the installed `proftpd' executable supports DSOs, the
	  prxs script itself may have been generated by a configure script
	  that did not use the --enable-dso option -- and we need to error
	  out in that case, rather than trying to build a shared module
	  without the proper flags.

2012-09-11 18:24  castaglia

	* tests/api/netaddr.c:
	  Flesh out tests for the pr_netaddr_is_v4mappedv6() function.
	  Added tests for the new pr_netaddr_is_rfc1918() function
	  (Bug#3825).

2012-09-11 18:18  castaglia

	* src/netaddr.c:
	  Fix compilation error if --disable-ipv6 is used.  Set errno
	  appropriately when the pr_netaddr_is_v4mappedv6() comparison
	  (done by macros) returns false.

2012-09-11 18:15  castaglia

	* NEWS, RELEASE_NOTES, include/netaddr.h, modules/mod_core.c,
	  src/netaddr.c:
	  Bug#3825 - Handle RFC 1918 IP addresses in PORT/EPRT commands.

2012-09-11 16:11  castaglia

	* NEWS, src/data.c:
	  Bug#3824 - Use RFC compliant address/port for data transfer if
	  FTP client has not sent PORT/PASV/EPRT/EPSV commands.

2012-09-07 14:39  castaglia

	* doc/howto/TLS.html:
	  Try to tell admins how to configure mod_tls if they want to
	  support clients which send "PROT C".

2012-09-07 12:08  castaglia

	* tests/t/lib/ProFTPD/Tests/Commands/SITE/CHMOD.pm:
	  Adding regression test demonstrating that a SITE CHMOD command
	  can be properly blocked by a <Limit> in a .ftpaccess file.

2012-09-07 11:51  castaglia

	* tests/t/lib/ProFTPD/Tests/: Logging/ExtendedLog.pm,
	  Modules/mod_sql_sqlite.pm:
	  Regression tests for the logging changes made for Bug#3822.

2012-09-07 11:50  castaglia

	* NEWS, contrib/mod_sql.c, modules/mod_log.c:
	  Bug#3822 - Resolving %U/%u LogFormat variables inconsistent
	  between mod_log/mod_sql in certain cases.

2012-09-07 11:48  jwm

	* contrib/mod_ldap.c: git 3d541bc898: fix symbol copy pasta

2012-09-07 09:22  castaglia

	* src/netaddr.c:
	  Portability fix for Bug#3820: FreeBSD (and probably others) don't
	  define AF_PACKET.  Filter ifaddrs, then, based on
	  AF_INET/AF_INET6.

2012-09-06 11:32  castaglia

	* config.h.in:
	  Forgot to update config.h.in for the new header checks.

2012-09-06 10:52  castaglia

	* NEWS, RELEASE_NOTES, include/netaddr.h, modules/mod_core.c,
	  src/netaddr.c:
	  Bug#3820 - Support device/interface names in <VirtualHost>,
	  MasqueradeAddress, and DefaultAddress.

2012-09-06 10:15  castaglia

	* NEWS, src/netaddr.c:
	  Backport of fix for Bug#3806 to 1.3.4 branch.

2012-09-06 10:14  castaglia

	* NEWS, src/netaddr.c:
	  Bug#3806 - Support reverse DNS resolution for IPv6 addresses when
	  gethostbyname2(3) is not available.

2012-09-06 10:13  castaglia

	* src/auth.c:
	  Pass along the path to which a chroot() will happen, as part of
	  the 'core.chroot' event.

2012-09-05 10:49  castaglia

	* src/proftpd.8.in:
	  Mention the new proftpd.conf(5) man page in the proftpd(8) man
	  page.

2012-09-05 10:48  castaglia

	* configure:
	  Updated configure.

2012-09-05 10:45  castaglia

	* Makefile.in, configure.in, src/.cvsignore, src/proftpd.conf.5.in:

	  Bug#3805 - proftpd.conf could use a short manpage.

2012-09-05 10:30  castaglia

	* doc/howto/CreateHome.html:
	  Mention the new NoRootPrivs CreateHome parameter in the
	  CreateHome howto.

2012-09-05 09:41  castaglia

	* tests/t/lib/ProFTPD/Tests/Config/CreateHome.pm:
	  Tests for the CreateHome NoRootPrivs option added for Bug#3813.

2012-09-05 09:40  castaglia

	* NEWS, RELEASE_NOTES, include/mkhome.h, modules/mod_auth.c,
	  src/mkhome.c:
	  Bug#3813 - Ability to use CreateHome to create parent directories
	  as non-root user, for better interoperability with NFS.

2012-08-29 22:05  castaglia

	* configure:
	  Updated configure.

2012-08-29 21:42  castaglia

	* configure.in:
	  Starting work on Bug#3820.  To do so, we need to add autoconf
	  checks for the necessary headers (net/if.h, ifaddrs.h) and
	  functions (getifaddrs(3)).

2012-08-27 13:39  castaglia

	* doc/contrib/mod_sftp.html:
	  Missed a mention of hmac-sha2-256-96 and hmac-sha2-512-96.

2012-08-27 13:34  castaglia

	* contrib/mod_sftp/crypto.c, doc/contrib/mod_sftp.html:
	  Remove support for the hmac-sha2-256-96 and hmac-sha2-512-96
	  digests, since they were removed from the spec.

2012-08-23 00:19  castaglia

	* src/inet.c:
	  When toggling the blocking/nonblocking status of the connection,
	  make sure that we set the mode flag properly on the connection;
	  the blocking-changing functions rely on that mode flag.

2012-08-22 23:51  castaglia

	* src/inet.c:
	  Check the return value of pr_inet_set_nonblock(), so that we can
	  catch errors (e.g. EBADF) earlier.  This might also prevent
	  seeing EADDRINUSE spuriously.

2012-08-22 22:02  castaglia

	* modules/mod_xfer.c, src/netio.c:
	  Trying to avoid a "Insufficient memory or file locked" transfer
	  aborted message (probably caused by EAGAIN being returned
	  somewhere).

2012-08-22 16:52  castaglia

	* src/trace.c:
	  Avoid possible file descriptor leak in the just-added
	  pr_trace_use_stderr() function.

2012-08-22 16:46  castaglia

	* include/trace.h, src/trace.c:
	  Add some functions to the Trace API to cause its logging to be
	  written out to stderr.  Useful for development/debugging
	  utilities.

2012-08-22 14:41  castaglia

	* tests/api/netaddr.c:
	  Be prepared for a few other possibilities when resolving '::1' to
	  DNS names.

2012-08-22 12:53  castaglia

	* NEWS, contrib/Makefile.in:
	  Backport of fix for Bug#3816 to 1.3.4 branch.

2012-08-22 12:53  castaglia

	* NEWS, contrib/Makefile.in:
	  Bug#3816 - Installation of ftpasswd does not honor DESTDIR
	  environment variable.

2012-08-22 11:02  castaglia

	* tests/api/netaddr.c:
	  Start working on an API-level unit test for handling changes
	  related to Bug#3806 (i.e. making sure pr_netaddr_get_dnsstr()
	  works properly for IPv6 addresses on systems which don't have
	  gethostbyname2(3)).

2012-08-21 11:45  castaglia

	* NEWS:
	  Rejigger the NEWS file to mention that Bug#3795 regressed, and is
	  now (hopefully) fixed in the next 1.3.4 maint release.

2012-08-21 11:31  castaglia

	* configure:
	  Updated configure.

2012-08-21 11:26  castaglia

	* configure.in:
	  Re-fixing Bug#3795 in the 1.3.4 branch; the backport from trunk
	  was done incorrectly.

2012-08-20 11:27  castaglia

	* contrib/mod_sftp/mod_sftp.c:
	  Update mod_sftp to use the same OpenSSL version checking as is
	  done in mod_tls, i.e. don't log a header/library version mismatch
	  if the OpenSSL version is 1.0.0 or newer.

2012-08-15 18:25  castaglia

	* contrib/: mod_sftp_pam.c:
	  If the PAM conversation in mod_sftp_pam fails, log it to the
	  SFTPLog rather than to the TraceLog.	(Maybe this should be
	  logged to the normal debug logging as well?)

2012-08-15 15:05  castaglia

	* contrib/: mod_sftp_pam.c:
	  Filter out unhelpful error log messages.

2012-08-15 10:05  castaglia

	* NEWS, contrib/dist/rpm/proftpd.init.d:
	  Bug#3814 - Support "configtest" command for contrib init.d
	  script.

2012-08-15 09:49  castaglia

	* NEWS:
	  Correct a bug number.

2012-08-09 18:48  castaglia

	* configure:
	  Updated configure script for Bug#3725.

2012-08-09 17:23  castaglia

	* Makefile.in:
	  Substitute the proftpd_cvs_version_main value in the proftpd.spec
	  (part of Bug#3725).

2012-08-09 17:15  castaglia

	* Makefile.in:
	  More work on Bug#3725: separate out the handling of the .spec
	  file into its own target, for clarity.  This also starts work on
	  substituting some of the .spec file values for values obtained
	  during the build.

2012-08-09 17:08  castaglia

	* configure.in:
	  Make sure the version-parsing stuff in the configure script
	  correctly handles the case where there is no RC portion of the
	  version string.

2012-08-09 16:13  castaglia

	* configure.in, Make.rules.in, Makefile.in:
	  Start working on Bug#3725.  To do this, the configure/Make.rules
	  files need to parse out the following forms of the version: the
	  full version (i.e. BUILD_VERSION), the release version (e.g.
	  1.3.5 for the stable/production version of this development
	  cycle), and the RC version (for RCs only).

2012-08-09 15:50  castaglia

	* contrib/dist/rpm/proftpd.spec:
	  Merge in changes from Paul Howarth, packaging up the language
	  files when building an RPM with --enable-nls, and requiring the
	  gettext tools for building said language files.

2012-08-09 15:48  castaglia

	* contrib/dist/rpm/proftpd.spec:
	  Update the proftpd.spec file to have mod_wrap2 et al in the main
	  package, rather than in the wrap subpackage, since they do not
	  need tcpwrappers.

2012-08-08 17:25  castaglia

	* tests/: tests.pl, t/config/maxclientsperclass.t,
	  t/config/maxclientsperuser.t,
	  t/lib/ProFTPD/Tests/Config/MaxClientsPerClass.pm,
	  t/lib/ProFTPD/Tests/Config/MaxClientsPerUser.pm:
	  Adding missing regression tests for the MaxClientsPerClass and
	  MaxClientsPerUser directives.

2012-08-08 16:58  castaglia

	* tests/t/lib/ProFTPD/Tests/Logging/ExtendedLog.pm:
	  Regression tests for Bug#3811.

2012-08-08 16:58  castaglia

	* NEWS, modules/mod_auth.c:
	  Bug#3811 - ExtendedLog entries not written if MaxClients limit
	  reached.

2012-08-06 23:26  castaglia

	* include/netaddr.h, src/netaddr.c:
	  Add new pr_netaddr_set_port2() function, which automatically
	  handles conversion of the host byte order port number to network
	  byte order.  (Should have been done this way from the start.)

2012-08-06 16:05  castaglia

	* src/inet.c:
	  Make sure we always return the socket to blocking mode,
	  regardless of how we return from pr_inet_connect_nowait().

2012-08-05 20:24  castaglia

	* contrib/mod_tls.c:
	  Remove duplicate SSL_CTX_check_private_key() calls.

2012-08-05 20:19  castaglia

	* src/trace.c:
	  Always try to leave a terminating NUL, just in case.

2012-08-05 20:17  castaglia

	* src/support.c:
	  Stylistic nit; no functional change.

2012-08-05 20:06  castaglia

	* include/dirtree.h, src/dirtree.c, src/parser.c:
	  Add a pr_table_t to the server_rec, so that modules can associate
	  any data they wish with a given server_rec, for their (or other
	  modules') use later.

2012-08-05 13:52  castaglia

	* src/dirtree.c:
	  Fix possible off-by-one error.  Clean up stylistic nit.  Avoid
	  unnecessary config_rec lookup if there is no <Class> defined for
	  a connection.

2012-08-01 16:35  castaglia

	* contrib/mod_sql.c, modules/mod_log.c:
	  Fix the logging of the %f variable for uploads by looking for the
	  correct key in the cmd->notes table.	Prefer the cmd->notes table
	  over session.xfer for uploads.

2012-08-01 16:30  castaglia

	* tests/t/lib/ProFTPD/Tests/Commands/RETR.pm:
	  And a few more places to use assert_transfer_ok().

2012-08-01 16:26  castaglia

	* tests/t/lib/ProFTPD/Tests/Commands/RETR.pm:
	  Update tests to use assert_transfer_ok() in more places.

2012-08-01 15:06  castaglia

	* RELEASE_NOTES, doc/contrib/mod_sftp.html:
	  Update the docs showing that mod_sftp now supports
	  MaxStoreFileSize.

2012-08-01 15:05  castaglia

	* contrib/mod_sftp/scp.c:
	  Support MaxStoreFileSize for scp uploads now.  Populate the
	  various cmd->notes keys, as used by mod_xfer, for scp transfers.

2012-08-01 15:03  castaglia

	* contrib/mod_sftp/fxp.c:
	  Stylistic nit.

2012-08-01 14:58  castaglia

	* contrib/mod_sftp/fxp.c:
	  Off-by-one nit.

2012-08-01 14:42  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_sftp/sql.pm:
	  Additional tests for the %{transfer-status}, %{transfer-failure}
	  variables, as well as ensuring that %f is populated properly in
	  the various situations.

2012-08-01 14:40  castaglia

	* contrib/mod_sftp/fxp.c:
	  Support the MaxStoreFileSize directive for SFTP uploads.

	  Start stashing the same notes for file transfers as used by
	  mod_xfer; this is for the benefit of logging modules such as
	  mod_log and mod_sql.

2012-07-31 16:47  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_sql_sqlite.pm:
	  Updated/fixed mod_sql logging tests for the %{transfer-status}
	  variable, and added testing of the %f in those various transfer
	  cases, making sure the full path is extrapolated properly.

2012-07-31 15:30  castaglia

	* locale/Makefile.in:
	  When generating a new .pot file, delete the old version.

2012-07-31 13:31  castaglia

	* doc/modules/mod_facts.html:
	  Grammar fix.

2012-07-31 11:15  castaglia

	* include/version.h:
	  Bump version in CVS.

2012-07-31 11:02  castaglia

	* doc/modules/mod_facts.html:
	  Markup typo.

2012-07-31 10:15  castaglia

	* ChangeLog:
	  Updating ChangeLog for proftpd-1.3.4b release.

2012-07-31 10:14  castaglia

	* contrib/dist/rpm/proftpd.spec:
	  Preparing for proftpd-1.3.4b release.

2012-07-31 10:13  castaglia

	* NEWS, RELEASE_NOTES:
	  Preparing for release of proftpd-1.3.4b.

2012-07-31 09:59  castaglia

	* doc/modules/mod_facts.html:
	  Added docs for the FactsOptions directive, and added FAQ.

2012-07-30 14:47  castaglia

	* NEWS, contrib/mod_radius.c:
	  Backport of fix for Bug#3809 to 1.3.4 branch.

2012-07-30 14:47  castaglia

	* NEWS, contrib/mod_radius.c:
	  Bug#3809 - Segfaults in mod_radius when configured with
	  RadiusGroupInfo.

2012-07-30 08:36  castaglia

	* contrib/mod_radius.c:
	  Stylistic cleanup; no functional change.

2012-07-30 08:17  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_deflate.pm:
	  Remove duplicate variable.

2012-07-30 08:17  castaglia

	* doc/howto/DSO.html:
	  Minor update to DSO howto.

2012-07-29 19:19  castaglia

	* NEWS, contrib/mod_tls.c:
	  Backport of fix for Bug#3808 to 1.3.4 branch.

2012-07-29 19:19  castaglia

	* contrib/mod_tls.c:
	  Minor update/improvement to fix for Bug#3808.

2012-07-29 19:15  castaglia

	* NEWS, contrib/mod_tls.c:
	  Bug#3808 - Segfault in mod_tls when mod_tls_shmcache used.

2012-07-27 09:27  castaglia

	* NEWS, src/inet.c:
	  Backporting fix for Bug#3804 to 1.3.4 branch.

2012-07-27 09:27  castaglia

	* NEWS, src/inet.c:
	  Bug#3804 - ioctl(RPROTDIS) code no longer needed on Solaris 11.

2012-07-26 17:20  castaglia

	* RELEASE_NOTES, contrib/mod_tls.c, doc/contrib/mod_tls.html:
	  Change the default TLSCipherSuite from "ALL:!ADH" to
	  "DEFAULT:!EXPORT:!DES", to be more secure out-of-the-box.  This
	  disables weaker ciphersuites such as the export-grade ciphers,
	  and the DES ciphers.

2012-07-26 17:16  castaglia

	* doc/contrib/mod_tls.html:
	  Adding documentation for new TLSServerCipherPreference directive.

2012-07-26 17:12  castaglia

	* NEWS, RELEASE_NOTES, contrib/mod_tls.c:
	  Bug#3801 - mod_tls should have directive like Apache mod_ssl's
	  SSLHonorCipherOrder.

2012-07-26 15:40  castaglia

	* tests/api/: response.c:
	  Remove unused variable.

2012-07-26 15:36  castaglia

	* contrib/mod_sftp/: scp.c:
	  Quell compiler warning about signedness mismatch.

2012-07-26 12:40  castaglia

	* contrib/mod_sftp/packet.c:
	  Better handling of errno values for writev(2) errors.

2012-07-25 16:45  castaglia

	* NEWS, contrib/mod_exec.c, contrib/mod_quotatab.c,
	  contrib/mod_sftp_pam.c, contrib/mod_sql.c,
	  contrib/mod_sql_passwd.c, contrib/mod_tls.c,
	  contrib/mod_sftp/mod_sftp.c, contrib/mod_wrap2/mod_wrap2.c,
	  modules/mod_facts.c:
	  Bug#3800 - Multiple *Options directives should be handled
	  properly.

2012-07-25 16:15  castaglia

	* contrib/mod_sftp/fxp.c:
	  Quell compiler warning about possibly uninitialized
	  memory/variable.

2012-07-25 15:39  castaglia

	* contrib/mod_quotatab.c:
	  Minor style cleanup.	Better handling of errno values when
	  creating the QuotaLock file.

2012-07-25 15:30  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_tls.pm:
	  Regression test for TLSOptions handling change, per Bug#3800.

2012-07-25 14:26  castaglia

	* doc/modules/mod_facts.html:
	  Fix markup.

2012-07-20 13:41  castaglia

	* contrib/mod_sftp/: cipher.c, compress.c, mac.c, packet.c:
	  More careful use of errno value when writing out SSH2 packets.

2012-07-20 10:47  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_sftp.pm:
	  Adding regression test showing client-initiated rekeying.

2012-07-20 10:04  castaglia

	* NEWS, contrib/mod_sftp/scp.c:
	  Backport of fix for Bug#3798 to 1.3.4 branch.

2012-07-20 10:03  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_sftp.pm:
	  Adding regression tests for Bug#3798.

2012-07-20 10:02  castaglia

	* NEWS, contrib/mod_sftp/scp.c:
	  Bug#3798 - Downloading nonexistent file via SCP results in
	  timeout rather than error.

2012-07-13 11:22  castaglia

	* NEWS, modules/mod_facts.c:
	  Backport of fix for Bug#3790 to 1.3.4 branch.

2012-07-13 11:22  castaglia

	* NEWS, modules/mod_facts.c:
	  Bug#3790 - Logfile timestamps change to GMT after MFMT command.

2012-07-12 15:20  castaglia

	* contrib/mod_sftp/kex.c:
	  Increase the message buffer size for some KEX messages.  Fix some
	  unintialized variable compiler warnings.

2012-07-11 18:38  castaglia

	* configure:
	  Updated configure.

2012-07-11 18:37  castaglia

	* NEWS, configure.in:
	  Backport of fix for Bug#3795 to 1.3.4 branch.

2012-07-11 18:36  castaglia

	* NEWS, configure.in:
	  Bug#3795 - ProFTPD needs to use -pthread linker option if linking
	  against OpenSSL with thread support.

2012-07-11 18:29  castaglia

	* configure:
	  Updated configure.

2012-07-11 18:26  castaglia

	* configure.in:
	  Fix mistake in previous configure.in patch; we forgot to restore
	  the LIBS variable in the case where linking with OpenSSL succeeds
	  without needing to check for an -ldl linkage.

2012-07-11 07:28  castaglia

	* configure:
	  Updated configure.

2012-07-11 07:21  castaglia

	* configure.in:
	  Fix minor bug in autoconf check for successful linking with
	  OpenSSL; the LIBS variable still contained a reference to -lsupp
	  at that check, and the libsupp library hasn't been compiled at
	  that check.

2012-07-09 17:52  castaglia

	* contrib/mod_sftp/: auth-password.c, auth-publickey.c:
	  Be sure to set errno properly when indicating an authentication
	  has failed; the errno value is used when determining the list of
	  still-acceptable auth methods to report back to the client.

2012-06-26 12:56  jwm

	* contrib/mod_ldap.c: git 603e38269a: interpolate %u in the quota
	  base DN, too

2012-06-26 12:54  jwm

	* contrib/mod_ldap.c: git 53e5489e64: Fixed swapped DN/attr name in
	  'no attr for' error messages.

2012-06-18 09:49  castaglia

	* NEWS, lib/tpl.c:
	  Backport of fix for Bug#3794 to 1.3.4 branch.

2012-06-18 09:48  castaglia

	* NEWS, lib/tpl.c:
	  Bug#3794 - Cygwin build failure in lib/tpl.c due to wrong include
	  of mman.h.

2012-06-07 21:05  castaglia

	* NEWS, contrib/mod_sftp/scp.c:
	  Backport of fix for Bug#3791 to 1.3.4 branch.

2012-06-07 21:04  castaglia

	* NEWS, contrib/mod_sftp/scp.c:
	  Bug#3791 - Invalid handling of SCP control messages fragmented
	  over multiple SSH packets.

2012-06-06 11:18  castaglia

	* NEWS, src/main.c:
	  Backport of fix for Bug#3740 to 1.3.4 branch.

2012-06-06 11:18  castaglia

	* NEWS, src/main.c:
	  Bug#3740 - Overwrite permission denied when reloading multiple
	  times and multiple <VirtualHost> sections in proftpd.conf.

2012-06-06 10:56  castaglia

	* doc/howto/Timestamps.html:
	  Update the Timestamps howto in light of information learned from
	  Bug#3790.

2012-06-01 09:26  castaglia

	* doc/howto/Limit.html:
	  Try to make it clear that <Limit ALL> does not automatically
	  cover <Limit LOGIN> as well.

2012-05-31 09:29  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_tls.pm:
	  Added regression test for the AllowDotLogin TLSOption, spurred by
	  Bug#3788.

2012-05-31 09:15  castaglia

	* doc/modules/mod_core.html:
	  Add description for the AuthOrder directive to the mod_core docs.

2012-05-30 16:46  castaglia

	* src/prxs.in:
	  Update the prxs script to check for a module-specific configure
	  script; if found, refuse to build the module.  Otherwise, prxs
	  might successfully compile a module which doesn't work.

	  This will be the situation until Bug#3308 is fixed.

2012-05-30 15:56  castaglia

	* src/prxs.in:
	  Handle the case where prxs might be used like so:

	    $ prxs -c -i -d contrib/mod_sql_sqlite.c

	  i.e. from the top-level of the source directory.

2012-05-30 14:53  castaglia

	* tests/t/lib/ProFTPD/Tests/Logging/ExtendedLog.pm:
	  Adding regression test for logging of a failed transfer where the
	  control connection goes away first.

2012-05-30 14:52  castaglia

	* modules/mod_xfer.c:
	  If the control connection dies while we are in the middle of a
	  data transfer, dispatch a fake command for the aborted RETR/STOR,
	  so that logging is done properly for the failed data transfer
	  command.

2012-05-30 10:26  castaglia

	* contrib/mod_sftp/: fxp.c:
	  Additional fix to handling of OPEN attributes per spec, related
	  to Bug#3787.

2012-05-29 18:03  castaglia

	* tests/t/lib/ProFTPD/Tests/Logging/ExtendedLog.pm:
	  Adding regression test to work on population of the
	  %{transfer-status} and %{transfer-failure} logging variables.

2012-05-29 17:27  castaglia

	* tests/: tests.pl, t/lib/ProFTPD/Tests/Modules/mod_sftp/sql.pm,
	  t/modules/mod_sftp/sql.t:
	  Adding regression tests for the %{transfer-status},
	  %{transfer-failure} logging variables for SFTP sessions.

2012-05-29 15:42  castaglia

	* contrib/mod_sql.c, modules/mod_log.c:
	  Try a little harder to populate the %F/%f logging variables for
	  RETR/STOR in the cases where they might have been aborted.

2012-05-29 15:03  castaglia

	* contrib/mod_sftp/fxp.c:
	  Stash enough information in the command notes for supporting the
	  transfer logging variables properly for aborted SFTP transfers.

2012-05-29 14:59  castaglia

	* contrib/mod_sql.c, modules/mod_log.c:
	  Adding support for the %{transfer-status} and %{transfer-failure}
	  logging variables when dealing with SFTP/SCP sessions.

2012-05-29 13:21  castaglia

	* contrib/mod_sftp/fxp.c:
	  Make the trace message about read-only SFTP OPENs less verbose.

2012-05-29 13:09  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_sftp.pm:
	  Adding regression test for Bug#3787.

2012-05-29 13:08  castaglia

	* NEWS, contrib/mod_sftp/fxp.c:
	  Backport of fix for Bug#3787 to 1.3.4 branch.

2012-05-29 13:08  castaglia

	* NEWS, contrib/mod_sftp/fxp.c:
	  Bug#3787 - Read-only SFTP OPEN request permissions not properly
	  ignored.

2012-05-29 13:04  castaglia

	* contrib/mod_sql.c:
	  Use the proper format string for the data type being printed.

2012-05-25 09:46  castaglia

	* config.guess, config.sub, contrib/mod_load/config.guess,
	  contrib/mod_load/config.sub, contrib/mod_sftp/config.guess,
	  contrib/mod_sftp/config.sub, lib/libltdl/config/config.guess,
	  lib/libltdl/config/config.sub:
	  Updating the config.{guess,sub} files.

2012-05-24 22:35  castaglia

	* tests/t/lib/ProFTPD/Tests/Commands/CWD.pm:
	  Additional regression tests for Bug#3785.

2012-05-24 22:35  castaglia

	* src/fsio.c:
	  Additional fix needed for Bug#3785.

2012-05-24 16:46  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_auth_file.pm:
	  Update mod_auth_file tests to use testcase-specific logging.
	  Added a test showing that use of syntax such as 'user@domain.com'
	  works properly.

2012-05-24 16:17  castaglia

	* contrib/: mod_tls.c:
	  If mod_tls sees that the OpenSSL header version is 1.0.0 or
	  greater, then relax the header/library version check/warning a
	  little.

2012-05-24 15:43  castaglia

	* tests/t/lib/ProFTPD/Tests/Commands/CWD.pm:
	  Regression test for Bug#3785.

2012-05-24 15:42  castaglia

	* NEWS, src/fsio.c:
	  Bug#3785 - Support resolution of tilde (~) within a chrooted
	  session.

	  To implement this, in pr_fs_interpolate(), we check to see
	  whether we are chrooted or not.  If so, instead of interpolating
	  in the user's home directory, we simply interpolate in the string
	  "/".

2012-05-23 13:19  castaglia

	* tests/t/lib/ProFTPD/: TestSuite/FTP.pm, Tests/Commands/ABOR.pm:
	  Add regression test for a plain ABOR command, with no data
	  transfer involved.

2012-05-22 17:11  castaglia

	* contrib/mod_sql.c, modules/mod_log.c:
	  Slightly better handling of the ABOR command when it comes to
	  determining the value of the %{transfer-status} log variable.

2012-05-22 09:31  castaglia

	* doc/howto/NAT.html:
	  Added another NAT-related FAQ.

2012-05-21 22:25  castaglia

	* src/child.c:
	  Stylistic nits.

2012-05-21 22:22  castaglia

	* src/support.c:
	  Stylistic nits.

2012-05-21 22:18  castaglia

	* modules/mod_delay.c:
	  Stylistic cleanups.

2012-05-21 19:25  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_delay.pm:
	  Updated mod_delay tests in light of changed response code/message
	  for Bug#3736.

2012-05-21 19:25  castaglia

	* NEWS, modules/mod_auth.c:
	  Bug#3736 - Trying to re-authenticate an existing FTP connection
	  causes invalid 503 response.

2012-05-21 18:46  castaglia

	* contrib/mod_sftp/kex.c:
	  Typo in comment.

2012-05-20 13:38  castaglia

	* src/log.c:
	  Remove a few redundant strlen(3) calls in the "hot" paths of
	  logging.

2012-05-18 10:09  castaglia

	* contrib/mod_tls.c:
	  After loading a private key into an SSL_CTX object, use the
	  SSL_CTX_check_private_key() function to verify that it's a good
	  private key.

2012-05-16 11:02  castaglia

	* modules/mod_log.c:
	  Reduce the window of time where root privs are used when dealing
	  with any configured ServerLogs.  Log if we can't open a ServerLog
	  for some reason.

2012-05-15 14:44  castaglia

	* NEWS, src/inet.c:
	  Backported fix for Bug#3780 to 1.3.4 branch.

2012-05-15 14:43  castaglia

	* NEWS, src/inet.c:
	  Bug#3780 - AIX gives "error setting listen fd IP_TOS: Invalid
	  argument".

2012-05-14 13:23  castaglia

	* doc/contrib/index.html:
	  Adding entries for mod_deflate, mod_qos to the contrib module
	  docs.

2012-05-14 09:31  castaglia

	* modules/mod_dso.c:
	  Try to make mod_dso's error reporting better when it comes to
	  loading a module which is not where it is expected to be.

2012-05-14 09:20  castaglia

	* modules/Makefile.in:
	  If proftpd has been linked, and then the modules/mod_dso.c file
	  has been modified, make sure that `make' will recompile that
	  modified file (this was not happening as expected for mod_dso.c,
	  due to its special Makefile rule).

2012-05-09 21:00  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_sql_sqlite.pm:
	  Adding regression test for Bug#3782.

2012-05-09 20:59  castaglia

	* NEWS, contrib/mod_sql.c:
	  Bug#3782 - SQLShowInfo does not work properly for error
	  responses.

2012-05-09 20:01  castaglia

	* src/support.c:
	  Stylistic nits; no functional change.

2012-05-09 19:59  castaglia

	* src/pool.c:
	  The pool_release_free_block_list() function already
	  blocks/unblocks alarms.

2012-05-09 19:55  castaglia

	* src/pool.c:
	  Fix the pool_release_blocks_on_free_list() function so that it
	  properly calls free(3) on all malloc'd memory on the freelist;
	  the previous loop logic was quite wonky.

	  Made the block_freelist symbol have file scope only; there's
	  absolutely no reason why it should be visible outside of this
	  file.

	  Stylistic nits/cleanup.

2012-05-09 19:47  castaglia

	* src/parser.c:
	  Stylistic nits.

2012-05-09 19:46  castaglia

	* modules/mod_auth_file.c:
	  Add minor trace logging to the mod_auth_file module.	Stylistic
	  nits, better errno reporting.

2012-05-09 11:13  castaglia

	* contrib/mod_sftp/keys.c:
	  If we can't read the configured SFTPHostKey, provide a more
	  accurate/informative error message about why.

2012-05-08 11:37  castaglia

	* doc/modules/mod_core.html:
	  Updated mod_core docs to include DisplayChdir, DisplayConnect,
	  and DisplayQuit descriptions.

2012-05-08 09:51  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_sql_passwd.pm:
	  Update the mod_sql_passwd tests to use testcase-specific logging.
	  Added another config/recipe showing the SQLPasswordOptions.

2012-05-03 11:29  castaglia

	* doc/howto/DisplayFiles.html:
	  Fix typo, add another FAQ about the location of the Display file
	  having a bearing on the %F/%f values.

2012-05-02 20:20  castaglia

	* src/pool.c:
	  Add the address of the pool being dumped to the output.

2012-05-01 14:31  castaglia

	* contrib/mod_wrap2_sql.c:
	  Try to improve the logging of mod_wrap2 misconfigurations, to
	  make it clearer/easier for admins to diagnose the problem.

2012-04-28 15:26  castaglia

	* contrib/mod_sftp/mod_sftp.c:
	  Fix cut-n-pasto.

2012-04-27 15:01  castaglia

	* contrib/mod_tls.c:
	  Make the TLSLog a little quieter; stop spamming the log with
	  needless information.

2012-04-26 19:44  castaglia

	* contrib/mod_tls.c:
	  Backporting error reporting changes when dealing with certificate
	  key files from trunk.

2012-04-26 19:43  castaglia

	* contrib/mod_tls.c:
	  If we encounter an error reading the CertificateKeyFile because
	  of a badly formatted file, display a more informative error.

2012-04-24 16:27  castaglia

	* include/stash.h, src/stash.c:
	  Add a pr_stash_dump() function, for dumping out info about the
	  stash table.	This function is only implemented when the
	  --enable-devel configure option is used.

2012-04-24 14:50  castaglia

	* src/auth.c:
	  More trace logging of some edge cases when dispatching auth
	  commands.  Some stylistic cleanup.

2012-04-24 13:09  castaglia

	* contrib/mod_sftp/keys.c:
	  Backport mod_sftp excess fd usage fixes from trunk to 1.3.4
	  branch.

2012-04-24 13:08  castaglia

	* contrib/mod_sftp/keys.c:
	  Fix excess fd usage when loading passphrase-protected SSH host
	  keys.

2012-04-24 13:07  castaglia

	* contrib/mod_tls.c:
	  Turns out these explicit casts aren't needed; I just had an
	  unclean work area.

2012-04-24 12:59  castaglia

	* contrib/mod_tls.c:
	  Quell compiler warnings about mismatched pointers using an
	  explicit cast.

2012-04-24 12:57  castaglia

	* contrib/mod_tls.c:
	  Backporting fixes for excess fd usage in mod_tls.

2012-04-24 12:56  castaglia

	* contrib/mod_tls.c:
	  Fix an fd issue in mod_tls.  Not exactly an fd leak, per se (the
	  number of open fds does not keep increasing), but definitely an
	  excess number of fds issue.

2012-04-24 12:21  castaglia

	* lib/: pr_fnmatch.c, pr_fnmatch_loop.c:
	  Backport fix for Bug#3774 to 1.3.4 branch.

2012-04-24 12:19  castaglia

	* lib/: pr_fnmatch.c, pr_fnmatch_loop.c:
	  Bug#3774 - Linking libsupp.a fails (undefined reference to
	  `__alloca').

2012-04-23 14:10  castaglia

	* doc/howto/NAT.html:
	  Adding MasqueradeAddress FAQ.

2012-04-23 09:49  castaglia

	* doc/modules/: mod_auth_file.html, mod_auth_unix.html:
	  Add FAQs about the crypt(3) first 8 character limitation.

2012-04-20 21:11  castaglia

	* tests/t/lib/ProFTPD/Tests/Commands/PASS.pm:
	  Adding test proving that spaces in passwords are handled
	  properly.

2012-04-20 13:32  castaglia

	* contrib/mod_sftp/fxp.c:
	  Increase the amount of metadata allotted for each directory
	  entry.  Hopefully this will fix some issues for some directory
	  listings.

2012-04-19 09:13  castaglia

	* NEWS, lib/pr_fnmatch.c, lib/pr_fnmatch_loop.c:
	  Backport of fix for Bug#3732 to 1.3.4 branch.

2012-04-19 09:13  castaglia

	* NEWS, lib/pr_fnmatch.c, lib/pr_fnmatch_loop.c:
	  Bug#3732 - AIX build error: undefined symbol: .alloca.

2012-04-18 14:31  castaglia

	* configure:
	  Updated configure.

2012-04-18 14:23  castaglia

	* configure.in:
	  The --enable-devel flags/libs are typically not specific to gcc;
	  make sure that they are applied to non-gcc compiler builds, then.

2012-04-18 08:42  castaglia

	* tests/t/lib/ProFTPD/Tests/Config/ListOptions.pm:
	  Adding regression test for the ListOptions maxfiles parameter.

2012-04-16 08:48  castaglia

	* src/support.c:
	  Quell compiler warnings.

2012-04-16 08:45  castaglia

	* contrib/mod_sftp/: fxp.c, keys.c:
	  Quell compiler warnings (Bug#3773).

2012-04-16 08:39  castaglia

	* modules/mod_cap.c:
	  Fix compiler issue requiring forward reference/decclaration.

2012-04-15 12:10  castaglia

	* tests/t/lib/ProFTPD/Tests/Commands/HOST.pm:
	  Remove cruft from these tests.

2012-04-15 11:05  castaglia

	* RELEASE_NOTES:
	  Make sure to mention HOST support in the release notes.

2012-04-15 11:04  castaglia

	* contrib/mod_tls.c, include/bindings.h, include/modules.h,
	  include/proftpd.h, include/session.h, modules/mod_auth.c,
	  modules/mod_auth_file.c, modules/mod_auth_unix.c,
	  modules/mod_cap.c, modules/mod_core.c, modules/mod_delay.c,
	  modules/mod_facts.c, modules/mod_ident.c, modules/mod_log.c,
	  modules/mod_memcache.c, modules/mod_xfer.c, src/bindings.c,
	  src/cmd.c, src/dirtree.c, src/main.c, src/modules.c,
	  src/proctitle.c, src/session.c, src/trace.c,
	  tests/t/lib/ProFTPD/Tests/Commands/HOST.pm:
	  Major work done on support for the HOST command (Bug#3289), to
	  support name-based virtual hosting in proftpd.  There is still
	  more work needed to complete the feature, however.

2012-04-13 07:28  castaglia

	* src/fsio.c:
	  Fix possible issue with encoding, due to passing the terminating
	  NUL into the iconv functions (Bug#3769).

2012-04-12 08:37  castaglia

	* tests/t/lib/ProFTPD/Tests/Config/UserAlias.pm:
	  Add regression test demonstrating a UserAlias which uses the '@'
	  symbol.

2012-04-08 08:59  castaglia

	* include/netaddr.h, src/netaddr.c, tests/api/netaddr.c:
	  Add two new functions: pr_netaddr_is_v4() and pr_netaddr_is_v6().
	  These functions can be used to test whether a given name is an
	  IP address (or a DNS name).

2012-04-08 08:47  castaglia

	* include/conf.h, include/netaddr.h, src/netaddr.c,
	  tests/api/netaddr.c:
	  Back out the addition of the pr_netaddr_get_addr2() function;
	  I'll be using a different approach for determining when a
	  user-given string is an IP address or a DNS name.

2012-04-07 11:21  castaglia

	* tests/t/: lib/ProFTPD/Tests/Logging/SystemLog.pm,
	  logging/systemlog.t:
	  Adding regression tests for the SystemLog directive.

2012-04-06 09:59  castaglia

	* modules/Makefile.in:
	  Make sure that if a static module fails to build (e.g. mod_sftp),
	  the entire build is failed.

2012-04-06 09:53  castaglia

	* contrib/mod_sftp/agent.c:
	  It appears that Solaris 10 does not like the use of a variable
	  name 'sun'; it already has that name defined in some system
	  headers.  Silly.

2012-04-06 09:45  castaglia

	* NEWS, src/encode.c:
	  Backport of fix for Bug#3769 to 1.3.4 branch.

2012-04-06 09:44  castaglia

	* NEWS, src/encode.c:
	  Bug#3769 - Ensure that encoded strings are NUL-terminated.

2012-04-04 20:12  castaglia

	* tests/t/lib/ProFTPD/Tests/Config/HideFiles.pm:
	  Add regression tests showing that HideFiles properly hides files
	  from the MLSD and STAT commands.

2012-04-04 19:56  castaglia

	* tests/t/lib/ProFTPD/Tests/Config/HideFiles.pm:
	  Updating the HideFiles regression tests to use testcase-specific
	  logging.

2012-04-04 15:27  castaglia

	* contrib/: mod_tls.c:
	  When validating OCSP responses, make sure that we validate the
	  timestamps on the OCSP response as well.

2012-04-04 11:37  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_geoip.pm:
	  Removing mod_geoip tests; it's not that easy/expedient to have
	  them in the testsuite.

2012-04-04 11:17  castaglia

	* contrib/mod_geoip.c:
	  Add support for checking the GeoIP filters in PASS POST_CMD
	  handler, so that geoip restrictions can be enforced on a
	  per-user/group basis e.g. via mod_ifsession.

2012-04-04 08:27  castaglia

	* modules/mod_xfer.c, src/data.c:
	  Move the cleanup of aborted data connection stuff to a LOG_CMD
	  handler in mod_xfer, so that other modules (e.g. mod_sql,
	  mod_log) could log abort-related info first.	Do some stylistic
	  cleanups as well.

2012-04-04 08:21  castaglia

	* include/conf.h, include/netaddr.h, src/netaddr.c,
	  tests/api/netaddr.c:
	  Add a new pr_netaddr_get_addr2() function, which returns
	  additional information about a retrieved address.  Namely,
	  whether the given lookup name was an IPv4/6 address, or a DNS
	  name.  This information will be needed for handling HOST
	  parameters.

2012-04-03 23:10  castaglia

	* doc/modules/mod_log.html:
	  Document the new %{transfer-status}, %{transfer-failure}
	  LogFormat variables.

2012-04-03 23:05  castaglia

	* modules/mod_log.c:
	  Support the new %{transfer-status}, %{transfer-failure} LogFormat
	  variables.

2012-04-03 23:04  castaglia

	* tests/t/lib/ProFTPD/Tests/Logging/ExtendedLog.pm:
	  Added regression tests for the %{transfer-status},
	  %{transfer-failure} LogFormat variables in ExtendedLogs.

2012-04-03 21:51  castaglia

	* RELEASE_NOTES, contrib/mod_sql.c:
	  Support the new %{transfer-status}, %{transfer-failure} variables
	  in SQLLog directives.

2012-04-03 21:50  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_sql_sqlite.pm:
	  Adding tests for using the new %{transfer-status},
	  %{transfer-failure} variables in SQLLog directives.

2012-04-03 13:59  castaglia

	* tests/: tests.pl, t/lib/ProFTPD/Tests/Modules/mod_geoip.pm,
	  t/modules/mod_geoip.t:
	  Adding necessary files for writing regression tests for the
	  mod_geoip module.

2012-04-03 13:54  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_delay.pm:
	  Fix up the mod_delay tests to use testcase-specific logging.

2012-04-03 13:41  castaglia

	* README.modules, doc/contrib/mod_geoip.html:
	  Updating other docs related to mod_geoip.

2012-04-03 13:38  castaglia

	* NEWS, RELEASE_NOTES, contrib/mod_geoip.c,
	  doc/contrib/mod_geoip.html:
	  Adding mod_geoip to the list of contrib modules distributed with
	  ProFTPD.

2012-04-03 09:16  castaglia

	* NEWS, contrib/mod_exec.c:
	  Bug#3768 - ExecTimeout 0 (zero) not treated as infinite.

2012-04-03 09:03  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_rewrite.pm:
	  Adding regression test for Bug#3767.

2012-04-03 09:02  castaglia

	* NEWS, contrib/mod_rewrite.c:
	  Backport of fix for Bug#3767 to 1.3.4 branch.

2012-04-03 09:01  castaglia

	* NEWS, contrib/mod_rewrite.c:
	  Bug#3767 - mod_rewrite segfault when handling SITE CHGRP without
	  a parameter.

2012-03-30 22:52  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_sql_sqlite.pm:
	  Updating the mod_sql_sqlite tests to use testcase-specific
	  logging.

2012-03-30 17:35  castaglia

	* NEWS, RELEASE_NOTES, contrib/mod_quotatab.c,
	  contrib/mod_quotatab.h:
	  Bug#3766 - Support a QuotaDefault directive, for configuring
	  default limits.

2012-03-30 17:34  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_quotatab_sql.pm:
	  Adding regression tests for Bug#3766 functionality (QuotaDefault
	  directive).

2012-03-30 16:24  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_quotatab_sql.pm:
	  Updating the mod_quotatab_sql regression testcases to use
	  testcase-specific logging.

2012-03-30 16:23  castaglia

	* tests/t/lib/ProFTPD/TestSuite/Child.pm:
	  Since aborted transfers can result in a 226 response code but
	  different response text, the assert_transfer_ok() method should
	  allow callers to indicate whether the transfer was indeed aborted
	  or not, lest the assertion fail unexpectedly.

2012-03-30 14:08  castaglia

	* contrib/mod_sftp/: auth.c:
	  Make sure to set the session.hide_password field to 'TRUE' for
	  SSH2 logins.

2012-03-29 22:11  castaglia

	* include/version.h:
	  This should mention a version of "1.3.5rc1", not "1.3.5".

2012-03-29 20:28  castaglia

	* doc/modules/mod_auth_unix.html:
	  Add FAQ about PersistentPasswd and "caching" of system users.

2012-03-29 14:47  castaglia

	* src/data.c:
	  Remove duplicate pr_timer_reset() call, and fix coding style.

2012-03-27 23:15  castaglia

	* tests/tests.pl:
	  Run the HOST regression tests.

2012-03-27 23:14  castaglia

	* tests/t/lib/ProFTPD/Tests/Commands/HOST.pm:
	  Start building up the collection of HOST-related regression
	  tests.

2012-03-27 23:14  castaglia

	* modules/mod_core.c:
	  Start working towards supporting the HOST command (Bug#3289).

2012-03-27 22:13  castaglia

	* tests/t/lib/ProFTPD/Tests/Commands/: DELE.pm, RNTO.pm:
	  Adding regression tests for Bug#3754.

2012-03-27 22:13  castaglia

	* NEWS, modules/mod_core.c:
	  Bug#3754 - ProFTPD refuses to delete/rename a symlink pointing
	  outside a writable directory.

2012-03-26 23:32  castaglia

	* doc/contrib/mod_rewrite.html:
	  Document the new mod_rewrite date/time-related variables.

2012-03-26 23:19  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_rewrite.pm:
	  Adding regression tests for Bug#3673 functionality.

2012-03-26 23:18  castaglia

	* NEWS, RELEASE_NOTES, contrib/mod_rewrite.c:
	  Bug#3673 - Support date/timestamp variables in mod_rewrite.

2012-03-24 11:41  castaglia

	* doc/howto/Umask.html:
	  Adding more info to the Umask howto.

2012-03-24 10:06  castaglia

	* doc/modules/mod_core.html:
	  Adding Umask directive description to the mod_core doc.

2012-03-23 09:21  castaglia

	* tests/t/lib/ProFTPD/Tests/Logging/ExtendedLog.pm:
	  Update EXIT regression test to use the %L/%a LogFormat variables.

2012-03-23 09:20  castaglia

	* modules/mod_log.c:
	  Fix null pointer dereference when using the %L/%a variables in a
	  LogFormat for the EXIT ExtendedLog command class (merge from
	  trunk).

2012-03-23 09:20  castaglia

	* modules/mod_log.c:
	  Fix null pointer dereference when using the %L/%a variables in a
	  LogFormat for the EXIT ExtendedLog command class.

2012-03-22 22:49  castaglia

	* NEWS, src/fsio.c:
	  Bug#3626 - Display variable %f off by a factor of 1024 on 64-bit
	  platforms.

2012-03-22 22:37  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_sftp.pm:
	  Adding regression test for Bug#3765.

2012-03-22 22:35  castaglia

	* NEWS, contrib/mod_sftp/fxp.c, contrib/mod_sftp/misc.c,
	  contrib/mod_sftp/misc.h, contrib/mod_sftp/scp.c:
	  Bug#3765 - mod_sftp should honor the GroupOwner directive for
	  MKDIR requests.

2012-03-22 10:21  castaglia

	* doc/modules/mod_log.html:
	  Try to clarify that the ALL ExtendedLog command class does not
	  include the EXIT command class.

2012-03-22 09:19  castaglia

	* NEWS:
	  Fix wrong bug number in NEWS.

2012-03-18 17:16  castaglia

	* doc/modules/mod_log.html:
	  Add link to RFC 959 and mention the section which defines the FTP
	  response docs.  Add link to CLF, and explicitly mention that
	  LogFormat's default format produces CLF entries.

2012-03-18 16:41  castaglia

	* doc/howto/Logging.html:
	  Attempting to improve the Logging howto, in order to better
	  address Bug#3540.

2012-03-18 16:26  castaglia

	* doc/modules/mod_core.html:
	  By default, proftpd logs everything (in terms of SyslogLevel),
	  thus the default SyslogLevel setting is "debug", not "none".

2012-03-17 12:56  castaglia

	* doc/howto/Logging.html:
	  Updating Logging howto to point to local docs (now that we have
	  them).

2012-03-17 12:43  castaglia

	* doc/modules/mod_core.html:
	  For the SyslogFacility default, list "daemon" (although proftpd
	  also uses "auth" for authentication messages).

2012-03-17 12:39  castaglia

	* doc/modules/mod_core.html:
	  Add description of the DebugLevel directive to the mod_core
	  documentation.  Add links to the Logging howto in the
	  descriptions for DebugLevel, SyslogFacility, and SyslogLevel.

2012-03-17 12:23  castaglia

	* doc/modules/mod_core.html:
	  Adding descriptions of the SyslogFacility and SyslogLevel
	  directives to the mod_core documentation.

2012-03-14 15:15  castaglia

	* NEWS, contrib/mod_sftp/kex.c:
	  Bug#3746 - mod_sftp does not correctly handle a 'guess' KEX
	  message when the client guesses correctly.

2012-03-13 17:32  castaglia

	* tests/tests.pl:
	  Adding regression tests for mod_sql_passwd when it is using an
	  OpenSSL that is in FIPS mode.

2012-03-13 17:11  castaglia

	* src/log.c:
	  Merge changes from trunk regarding syslog socket fds and
	  restarts.

2012-03-13 17:11  castaglia

	* src/log.c:
	  Make sure that we get a usable syslog socket fd (read: not 0, 1,
	  or 2) after a restart.

2012-03-13 16:23  castaglia

	* contrib/mod_sql_passwd.c:
	  Now mod_sql_passwd properly checks the EVP_Digest* return values.
	  This makes it possible for mod_sql_passwd to Do The Right
	  Thing(tm) when the digest cannot be used, e.g. MD5 passwords and
	  OpenSSL that is in FIPS mode.

2012-03-13 15:36  castaglia

	* contrib/mod_sftp/kex.c:
	  Add more trace logging of the name lists that mod_sftp is sending
	  to the client.

2012-03-13 14:39  castaglia

	* contrib/mod_sftp/mod_sftp.h.in:
	  There will be enough new features in mod_sftp in this release to
	  warrant bumping the module version.

2012-03-13 13:15  castaglia

	* contrib/mod_sftp/: blacklist.c:
	  Fix compiler warning.

2012-03-13 12:05  castaglia

	* contrib/mod_sftp/: keys.c, keys.h:
	  Forgot to update the copyright years on these files.

2012-03-13 12:05  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_sftp/FIPS.pm:
	  Adding regression tests for key-based SSH2 auth when in FIPS
	  mode.

2012-03-13 12:02  castaglia

	* contrib/mod_sftp/: auth-hostbased.c, auth-publickey.c,
	  blacklist.c, keys.c, keys.h:
	  Merge the key fingerprinting changes, when in FIPS mode, from
	  trunk to the 1.3.4 branch.

2012-03-13 11:58  castaglia

	* contrib/mod_sftp/: auth-hostbased.c, auth-publickey.c,
	  blacklist.c, keys.c, keys.h:
	  Properly handle fingerprinting of keys when FIPS mode is enabled.
	  We used to always use MD5 fingerprints -- but that does not work
	  for FIPS.  (We also weren't checking for digest errors when
	  obtaining key fingerprints).	Now, when FIPS mode is enabled, we
	  use SHA1 fingerprints.

2012-03-13 09:53  castaglia

	* doc/contrib/mod_sftp.html:
	  Document the list of cipher/digest algorithms that are no longer
	  advertised by mod_sftp when FIPS mode is enabled.

2012-03-13 09:50  castaglia

	* contrib/mod_sftp/: crypto.c:
	  Allow the 3des-ctr cipher in FIPS mode (Bug#3763).

2012-03-12 17:23  castaglia

	* NEWS, contrib/mod_sftp/cipher.c, contrib/mod_sftp/crypto.c,
	  contrib/mod_sftp/mac.c, contrib/mod_sftp/mod_sftp.c:
	  Backport the fix for Bug#3763 to 1.3.4 branch.

2012-03-12 16:59  castaglia

	* tests/t/lib/ProFTPD/TestSuite/Utils.pm:
	  Support for a 'feat_openssl_fips' testcase class label.  (Needed
	  this to have the Bug#3763 regression tests executed but only when
	  mod_sftp was built against a FIPS-enabled OpenSSL.)

2012-03-12 16:52  castaglia

	* tests/: tests.pl, t/lib/ProFTPD/Tests/Modules/mod_sftp/FIPS.pm,
	  t/modules/mod_sftp/fips.t:
	  Adding regression tests for Bug#3763.

2012-03-12 16:28  castaglia

	* NEWS, RELEASE_NOTES, contrib/mod_sftp/cipher.c,
	  contrib/mod_sftp/crypto.c, contrib/mod_sftp/mac.c,
	  contrib/mod_sftp/mod_sftp.c:
	  Bug#3763 - Ensure that mod_sftp operates properly when OpenSSL
	  FIPS mode is enabled.

2012-03-12 15:44  castaglia

	* tests/t/lib/ProFTPD/Tests/Config/Include.pm:
	  Add regression test for an Include directive which uses a glob
	  pattern that results in no matches.

2012-03-12 15:28  castaglia

	* doc/modules/mod_core.html:
	  Make sure the Include directive docs mention how a glob pattern
	  with no matches is handled.

2012-03-12 11:41  castaglia

	* tests/t/lib/ProFTPD/TestSuite/Utils.pm:
	  Make sure the modified/new server_wait() still sets a default
	  timeout of 10 secs, even if a hashref of options has been
	  provided by the caller.

2012-03-11 15:32  castaglia

	* tests/t/lib/ProFTPD/Tests/Config/IfDefine.pm:
	  Fix these tests so that they actually stop the daemon processes
	  that they launch.

2012-03-11 12:30  castaglia

	* contrib/mod_sftp/packet.c:
	  Include the IP address of the client who sends us a DISCONNECT
	  SSH message.

2012-03-11 12:20  castaglia

	* tests/t/lib/ProFTPD/: TestSuite/Utils.pm,
	  Tests/Modules/mod_tls.pm:
	  Alter the server_wait() and server_start() Utils functions so
	  that test cases can specify environment variables, and -D
	  defines, to be used when starting proftpd.

2012-03-11 12:20  castaglia

	* tests/: tests.pl, t/config/ifdefine.t,
	  t/lib/ProFTPD/Tests/Config/IfDefine.pm:
	  Adding regression tests for the <IfDefine> directive.

2012-03-11 11:45  castaglia

	* NEWS, contrib/mod_sftp/kex.c, contrib/mod_sftp/packet.c,
	  contrib/mod_sftp/packet.h:
	  Backport of fix for Bug#3761 to 1.3.4 branch.

2012-03-11 11:44  castaglia

	* NEWS, contrib/mod_sftp/kex.c, contrib/mod_sftp/packet.c,
	  contrib/mod_sftp/packet.h:
	  Bug#3761 - SSH2 key exchange fails if client sends certain SSH
	  message before NEWKEYS.

2012-03-08 15:31  castaglia

	* contrib/mod_sftp/kex.c:
	  Fix a few places where compilation would fail with a non-ECC
	  capable OpenSSL version because I was missing some preprocessor
	  guards.

2012-03-07 16:06  castaglia

	* tests/: tests.pl, t/commands/site/chgrp.t,
	  t/lib/ProFTPD/Tests/Commands/SITE/CHGRP.pm:
	  Adding missing regression tests for the SITE CHGRP command.

2012-03-07 07:32  castaglia

	* src/main.c:
	  Backport the fix on handling of uname(3) return values to the
	  1.3.4 branch.

2012-03-07 07:29  castaglia

	* src/main.c:
	  On some platforms (e.g. Solaris), uname(3) returns a positive
	  number on success, and on other platforms, uname(3) returns zero
	  on success.  The only reliable check for success, then, is
	  whether the return value is less than zero on error -- all other
	  values indicate success.

2012-03-06 20:17  castaglia

	* doc/contrib/mod_sftp.html, NEWS, RELEASE_NOTES:
	  Mention the new support for loading host keys from an SSH agent
	  in the docs.

2012-03-06 18:14  castaglia

	* contrib/mod_sftp/: agent.c, keys.c, mod_sftp.c:
	  Put the finishing touches on support for loading SSH hostkeys
	  from an SSH agent.

2012-03-05 23:01  castaglia

	* contrib/mod_sftp/: agent.c, agent.h, keys.c, mod_sftp.c:
	  More work on getting mod_sftp ready to read hostkeys from an SSH
	  agent.

2012-03-05 17:29  castaglia

	* contrib/mod_sftp/agent.c:
	  Slightly better trace logging messages by including the Unix
	  domain socket path, e.g. where there are different SSH agents for
	  different vhosts.

2012-03-05 17:17  castaglia

	* contrib/mod_sftp/: Makefile.in, agent.c, agent.h, keys.c, keys.h,
	  mod_sftp.c:
	  Start working on support for obtaining hostkeys from an SSH
	  agent, rather than from files on disk.

2012-03-04 14:31  castaglia

	* RELEASE_NOTES:
	  Updating release notes.

2012-03-04 14:31  castaglia

	* contrib/mod_sftp/auth-hostbased.c:
	  Forgot to update the hostbased auth to use the key type enum, and
	  to support ECDSA keys for hostbased authentication as well.

2012-03-04 10:32  castaglia

	* doc/modules/mod_core.html:
	  Fixing markup.

2012-03-02 15:34  castaglia

	* RELEASE_NOTES:
	  Call out the ECC support for mod_sftp in the release notes.

2012-03-02 15:07  castaglia

	* contrib/mod_sftp/: auth-publickey.c, kex.c, keys.c, keys.h:
	  Support use of ECDSA public keys for user/host authentication, as
	  part of ECC support (Bug#3573).

2012-03-02 15:05  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_sftp.pm:
	  Adding regression tests to mod_sftp, verifying that user public
	  key authentication using ECDSA public keys works properly.  Part
	  of Bug#3573.

2012-03-02 15:04  castaglia

	* tests/t/etc/modules/mod_sftp/: authorized_ecdsa256_keys,
	  authorized_ecdsa384_keys, authorized_ecdsa521_keys,
	  test_ecdsa256_key, test_ecdsa256_key.pub, test_ecdsa384_key,
	  test_ecdsa384_key.pub, test_ecdsa521_key, test_ecdsa521_key.pub:
	  Adding ECDSA public keys, for use in verifying that ECDSA-based
	  public key user authentication works properly (part of Bug#3573).

2012-03-01 15:54  castaglia

	* src/support.c:
	  There's no reason for this memscrub_ctr variable symbol to be
	  visible outside of this file.

2012-03-01 15:51  castaglia

	* NEWS, modules/mod_auth.c:
	  Backported fix for Bug#3758 to 1.3.4 branch.

2012-03-01 15:51  castaglia

	* NEWS, modules/mod_auth.c:
	  Bug#3758 - ProFTPD crashes when handling mod_gss authentication
	  due to null pointer.

2012-03-01 15:17  castaglia

	* doc/contrib/mod_sftp.html:
	  Update the mod_sftp docs to mention the new key exchange
	  algorithms supported, as well as ECDSA hostkey support
	  (Bug#3573).

2012-03-01 15:12  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_sftp.pm:
	  Adding regression tests for the ECC support (hostkey algorithms,
	  key exchange algorithms) in mod_sftp.  Note that these tests rely
	  on an external sftp(1) program which has ECC support.

2012-03-01 15:10  castaglia

	* NEWS, contrib/mod_sftp/kex.c, contrib/mod_sftp/keys.c,
	  contrib/mod_sftp/keys.h, contrib/mod_sftp/mod_sftp.h.in,
	  contrib/mod_sftp/msg.c, contrib/mod_sftp/msg.h,
	  contrib/mod_sftp/ssh2.h:
	  Bug#3573 - Support Elliptic Curve Cryptography (ECC) in SSH.

2012-03-01 15:04  castaglia

	* tests/t/etc/modules/mod_sftp/: ssh_host_ecdsa256_key,
	  ssh_host_ecdsa256_key.pub, ssh_host_ecdsa384_key,
	  ssh_host_ecdsa384_key.pub, ssh_host_ecdsa521_key,
	  ssh_host_ecdsa521_key.pub:
	  Adding SSH ECDSA host keys for the regression tests for Bug#3573.

2012-02-28 15:14  castaglia

	* doc/contrib/mod_ctrls_admin.html:
	  Removed mention of the 'dump' ftpdctl action; it is no longer
	  supported by the mod_ctrls_admin module.

2012-02-28 10:14  castaglia

	* contrib/mod_ban.c:
	  Better handling of errno values in certain cases, so that the
	  return values (and log messages) reflect reality.

2012-02-27 14:48  castaglia

	* locale/proftpd.pot:
	  Updating POT file; most of the changes are of source code line
	  number changes, but there are a couple of different strings.

2012-02-27 13:42  castaglia

	* locale/files.txt:
	  Updated list of files containing strings that might need to be
	  localized.

2012-02-27 13:38  castaglia

	* modules/mod_xfer.c, tests/t/lib/ProFTPD/Tests/Commands/TYPE.pm:
	  Return a 504 response code for unsupported TYPE parameters,
	  rather than 500.

2012-02-27 09:26  castaglia

	* doc/modules/: mod_auth.html, mod_core.html, mod_xfer.html:
	  Document the maximum allowed timeout value, if any, for the
	  various Timeout directives.

2012-02-24 14:38  castaglia

	* doc/modules/mod_lang.html:
	  Updated mod_lang docs, per changes for Bug#3737.

2012-02-24 14:33  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_lang.pm:
	  Adding regression tests for the mod_lang changes from Bug#3737.

2012-02-24 14:32  castaglia

	* NEWS, RELEASE_NOTES, modules/mod_lang.c:
	  Bug#3737 - Allow UTF8 when UseEncoding is used.

2012-02-24 13:48  castaglia

	* src/encode.c:
	  Use syslogging, rather than trace logging, in encode_init(),
	  since encoding is initialized before the config file is parsed
	  (and thus before the TraceLog is opened).

2012-02-24 09:39  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_lang.pm:
	  Adding regression tests for the current mod_lang behavior with
	  regard to UseEncoding and OPTS UTF8 commands.

2012-02-24 08:57  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_lang.pm:
	  Updated the mod_lang tests to use testcase-specific logging.

2012-02-24 08:46  castaglia

	* src/netio.c:
	  Preserve the errno value, for the sake of the caller.

2012-02-23 23:23  castaglia

	* contrib/mod_sftp/mod_sftp.c, modules/mod_xfer.c:
	  Update mod_sftp and mod_xfer so that they use the new
	  pr_str_get_nbytes() function for parsing file sizes, e.g. from
	  directive parameters.

2012-02-23 23:08  castaglia

	* include/str.h, src/str.c, tests/api/str.c:
	  Refactor some common code (duplicated in mod_xfer and in
	  mod_sftp) used to parse a string of "bytes", including suffix,
	  into a numeric value, into a new String API pr_str_get_nbytes()
	  function.

2012-02-23 22:13  castaglia

	* doc/modules/mod_auth.html:
	  Document the new RootRevoke parameter, per Bug#3731.

2012-02-23 22:02  castaglia

	* NEWS, RELEASE_NOTES, modules/mod_auth.c, modules/mod_core.c,
	  src/data.c, src/inet.c,
	  tests/t/lib/ProFTPD/Tests/Config/RootRevoke.pm:
	  Bug#3731 - Support active data transfers while RootRevoke is in
	  effect.

2012-02-23 17:37  castaglia

	* src/table.c:
	  Since we're only reading from /dev/urandom, we don't really care
	  about any error value from fclose(3).

2012-02-23 17:36  castaglia

	* modules/mod_dso.c:
	  Quell valid compiler warning about shadowed variable.

2012-02-23 17:33  castaglia

	* contrib/mod_ban.c:
	  Quell compiler warning about unreachable code (but only
	  unreachable when memcache support is not enabled).

2012-02-23 17:29  castaglia

	* contrib/mod_sftp/rfc4716.c:
	  Quell compiler warning about a line of code which will never be
	  reached.

2012-02-23 17:22  castaglia

	* src/table.c:
	  Fix compiler warning about generating the per-table random seed,
	  when OpenSSL's RAND API is not available.

	  Also decided to simply add the per-table seed to the returned
	  hash value, rather than XOR the seed in.

2012-02-23 17:14  castaglia

	* src/: ctrls.c:
	  Fixed another place in the Controls API where we weren't using
	  the proper buffer length.

2012-02-23 16:31  castaglia

	* tests/t/lib/ProFTPD/Tests/Logging/ExtendedLog.pm:
	  Add regression test for LogFormat/ExtendedLog, to make sure that
	  an ABOR command is properly logged.

2012-02-23 14:25  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_ctrls.pm:
	  Adding regression test for Bug#3756.

2012-02-23 14:22  castaglia

	* NEWS, modules/mod_ctrls.c, src/ctrls.c:
	  Backport of fix for Bug#3756 to 1.3.4 branch.

2012-02-23 14:22  castaglia

	* NEWS, modules/mod_ctrls.c, src/ctrls.c:
	  Bug#3756 - mod_ctrls no longer listens on ControlsSocket after
	  restart.

2012-02-23 13:46  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_ban.pm:
	  Missing testcase tag.

2012-02-23 13:12  castaglia

	* doc/contrib/mod_sftp.html:
	  Added documentation for the new IgnoreSFTPSetOwners SFTPOption
	  (Bug#3757).

2012-02-23 13:10  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_sftp.pm:
	  Adding regression tests for Bug#3757.

2012-02-23 13:10  castaglia

	* NEWS, RELEASE_NOTES, contrib/mod_sftp/fxp.c,
	  contrib/mod_sftp/mod_sftp.c, contrib/mod_sftp/mod_sftp.h.in:
	  Bug#3757 - Support SFTPOption for ignoring requests to modify
	  file ownership.

2012-02-22 16:04  castaglia

	* modules/mod_dso.c:
	  Quell compiler warning about losing pointer qualifier.

2012-02-22 08:41  castaglia

	* tests/t/lib/ProFTPD/Tests/Commands/PASS.pm:
	  Add regression test showing that the PASS command works properly
	  with non-ASCII characters in the provided password.

2012-02-22 07:43  castaglia

	* tests/t/lib/ProFTPD/Tests/Commands/CWD.pm:
	  Adding reproduction recipe for Bug#3730; this test shows that the
	  reported behavior does not currently happen.	Still, useful to
	  have the recipe around for possible regressions.

2012-02-21 17:56  castaglia

	* contrib/mod_ban.c:
	  Backporting additional fix for Bug#3751 to 1.3.4 branch.

2012-02-21 17:56  castaglia

	* contrib/mod_ban.c:
	  Committing additional fix for Bug#3751, to make sure that the
	  BanTable fd, after a restart, is not one of stdin/stdout/stderr.

2012-02-21 13:59  castaglia

	* tests/: tests.pl, t/lib/ProFTPD/Tests/Config/EnvVars.pm,
	  t/config/envvars.t:
	  Adding regression tests for using environment variables in
	  proftpd.conf config files.

2012-02-21 11:11  castaglia

	* doc/utils/index.html:
	  Better description of the prxs docs in the index.

2012-02-20 10:56  castaglia

	* doc/utils/prxs.html:
	  Beginnings of a prxs doc.

2012-02-20 10:37  castaglia

	* doc/modules/mod_xfer.html:
	  Adding descriptions for the TimeoutNoTransfer, TimeoutStalled
	  directives to the bundled docs.

2012-02-20 10:28  castaglia

	* doc/modules/mod_core.html:
	  Adding descriptions for the MaxInstances, TimeoutIdle directives
	  to the bundled docs.

2012-02-20 10:14  castaglia

	* doc/modules/mod_auth.html:
	  Adding descriptions for the TimeoutLogin, TimeoutSession
	  directives to the bundled docs.

2012-02-19 13:37  castaglia

	* contrib/mod_sftp/fxp.c:
	  Refactor the code snippet for setting the 'sftp.file-handle' note
	  into a common function, and avoid the code duplication.

2012-02-19 11:58  castaglia

	* modules/mod_auth.c:
	  Removed unused variable which was leading to a compiler warning
	  noted in Bug#3755.

2012-02-18 19:02  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_sftp.pm:
	  Adding regression test for feature added for Bug#3707.

2012-02-18 18:56  castaglia

	* NEWS, contrib/mod_sftp/fxp.c:
	  Bug#3707 - Add request/transfer ID to the logging of the initial
	  and closing commands for SFTP file transfers.

	  This adds a "sftp.file-handle" note to the cmd->notes table for
	  SFTP transfer-related requests.  This note can then be logged in
	  a custom LogFormat using the new support for notes, e.g.
	  '%{note:sftp.file-handle}'.

	  Note that I also fixed the logging of %f LogFormat variables for
	  SFTP CLOSE requests; the session.xfer struct was being cleared by
	  the RETR/STOR handles to which the CLOSE request handler
	  dispatched, and thus when the CLOSE request was dispatched,
	  mod_log had no session.xfer information to work with.  Now fixed.

2012-02-18 18:52  castaglia

	* RELEASE_NOTES, modules/mod_log.c:
	  Add support for a '%{note:...}' LogFormat variable, for logging
	  "notes" to a custom LogFormat.  This makes LogFormat have parity
	  with SQLLog, which also handles "notes" (something I quietly
	  snuck into mod_sql).	It is also going to be used to satisfy the
	  feature requested in Bug#3707.

2012-02-18 15:56  castaglia

	* configure:
	  Updated configure.

2012-02-18 15:54  castaglia

	* configure.in:
	  Extend the fix for Bug#3702 (i.e. checking for the -pthread
	  library link flag) to apply to the handling of Postgres as well.

2012-02-18 14:44  castaglia

	* contrib/mod_sftp_sql.c:
	  Fix up compiler warnings noted in Bug#3755.

2012-02-18 14:37  castaglia

	* contrib/mod_sftp/fxp.c:
	  Fix up a few more places where compiler warnings (noted in
	  Bug#3755) about unused variables could be addressed.

2012-02-18 14:28  castaglia

	* contrib/mod_sftp/fxp.c:
	  Pay more attention to the file_type field sent in an OPEN SFTP
	  request from SFTP clients using SFTP protocol version 4 and
	  later.  Use this field to actually set the st.st_mode bits for
	  that file type properly.  Note that this also addresses a
	  compiler warning about an unused variable noted in Bug#3755.

2012-02-18 14:12  castaglia

	* contrib/mod_sftp/channel.c:
	  Remove unused variable causing compiler warning noted in
	  Bug#3755.

2012-02-18 14:10  castaglia

	* contrib/mod_sftp/auth-password.c:
	  Log when an SSH2 client gives us a new password, so that admins
	  will know that that functionality is not supported by mod_sftp.
	  This addresses a compiler warning about an unused variable
	  reported by Bug#3755.

2012-02-18 14:07  castaglia

	* contrib/mod_rewrite.c:
	  Remove unused variable causing compiler warning noted in
	  Bug#3755.

2012-02-18 14:00  castaglia

	* contrib/mod_sql_mysql.c:
	  Fix up the coding style and clean up some compiler warnings noted
	  in Bug#3755.

2012-02-18 13:55  castaglia

	* contrib/mod_sql.c:
	  Quell a compiler warning noted in Bug#3755.

2012-02-18 13:53  castaglia

	* src/auth.c:
	  Stylistic cleanup, and fix a few compiler warnings noted in
	  Bug#3755.

2012-02-18 13:51  castaglia

	* modules/mod_auth.c:
	  Fix some stylistic nits, and clean up a few compiler warnings
	  noted in Bug#3755.

2012-02-17 14:43  castaglia

	* src/: lastlog.c:
	  Use explicit cast to time_t pointer, to avoid compiler warnings
	  on some platforms.

2012-02-17 07:32  castaglia

	* src/pool.c:
	  The previous changes to the Pool API erroneously removed the
	  memset(3) calls which zeroed out the allocated memory; these are
	  very important calls.  Oops.

2012-02-16 17:53  castaglia

	* tests/t/lib/ProFTPD/Tests/Signals/HUP.pm:
	  Add a reproduction recipe for Bug#3740.  So far, though, the
	  reported bug hasn't manifested in my regression test attempts.

2012-02-16 17:19  castaglia

	* NEWS, contrib/mod_ban.c:
	  Backport of fix for Bug#3751 to 1.3.4 branch.

2012-02-16 17:18  castaglia

	* NEWS, contrib/mod_ban.c:
	  Bug#3751 - mod_ban does not close/reopen the BanLog/BanTable file
	  descriptors on restart, causing a file descriptor leak.

2012-02-16 17:08  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_ban.pm:
	  Added regression test for Bug#3751 (mod_ban-related fd leak).

2012-02-16 15:17  castaglia

	* NEWS, src/bindings.c, src/inet.c:
	  Backport of fix for Bug#3752 to 1.3.4 branch.

2012-02-16 15:17  castaglia

	* NEWS, src/bindings.c, src/inet.c:
	  Bug#3752 - proftpd process exit status is zero for "Failed
	  binding to address, port N: Address already in use" startup
	  failure.

2012-02-16 09:02  castaglia

	* tests/api/response.c:
	  Backport of fix for Bug#3750 to 1.3.4 branch.

2012-02-16 09:01  castaglia

	* tests/api/response.c:
	  Disable a unit test which was creating an expected segfault; the
	  test code in question is a reproduction recipe rather than a
	  regression test, and so should not necessarily be run all of the
	  time (Bug#3750).

2012-02-15 16:18  castaglia

	* include/pool.h, src/pool.c:
	  Clean up some places in the Pool API which allowed signed ints
	  for sizes/counts of things.  It does not make sense to allow for
	  negative pool sizes or negative counts, so prevent it at the API
	  level, rather than having less-than-zero checks in the code.

2012-02-15 16:13  castaglia

	* src/scoreboard.c:
	  Clean up warnings in the Scoreboard API code.

2012-02-15 16:13  castaglia

	* src/table.c:
	  Include the <openssl/rand.h> header, if OpenSSL is enabled, so
	  that we get the proper RAND_* function definitions.

2012-02-15 16:03  castaglia

	* contrib/mod_sftp/fxp.c:
	  Missed part of the "unsigned char" merge.

2012-02-15 15:50  castaglia

	* contrib/mod_sftp/: auth-hostbased.c, auth-kbdint.c,
	  auth-password.c, auth-publickey.c, auth.c, auth.h, blacklist.c,
	  blacklist.h, channel.c, channel.h, cipher.c, date.c, date.h,
	  disconnect.c, fxp.c, fxp.h, kbdint.c, kex.c, keys.c, keys.h,
	  keystore.c, keystore.h, mac.c, mod_sftp.h.in, msg.c, msg.h,
	  packet.c, packet.h, rfc4716.c, scp.c, scp.h, service.c, tap.c:
	  Reworked the mod_sftp handling of buffers of data to use
	  "unsigned char" rather than just "char".  Raw data has really no
	  signedness, so its better/cleaner to treat it as unsigned.

2012-02-15 15:38  castaglia

	* contrib/mod_sftp/: kex.c:
	  Fix minor issue pointed out by valgrind, where we were not
	  tracking the length properly.

2012-02-15 15:18  castaglia

	* contrib/mod_sftp/fxp.c:
	  Forgot to update the copyright date, since this file was modified
	  in 2012.

2012-02-15 15:15  castaglia

	* NEWS, contrib/mod_sftp/fxp.c:
	  Backport of fix for Bug#3743 to 1.3.4 branch.

2012-02-15 15:14  castaglia

	* NEWS, contrib/mod_sftp/fxp.c:
	  Bug#3743 - Random stalls/segfaults seen when transferring large
	  files via SFTP.

2012-02-15 14:10  castaglia

	* contrib/mod_sftp/fxp.c:
	  Calling fxp_packet_add_cache() with null args should NOT zero out
	  the static buffer length-tracking variable.

2012-02-15 11:03  castaglia

	* tests/api/: scoreboard.c, stubs.c:
	  Fix unit tests to compile properly.

2012-02-14 16:31  castaglia

	* contrib/mod_sftp/packet.c:
	  Missing return value.

2012-02-14 10:38  castaglia

	* NEWS, src/netacl.c:
	  Backport of fix for Bug#3749 to 1.3.4 branch.

2012-02-14 10:38  castaglia

	* NEWS, src/netacl.c:
	  Bug#3749 - Compile of src/netacl.c fails on Tru64 UNIX (OSF/1)
	  due to conflict with system header.

2012-02-13 16:10  castaglia

	* contrib/mod_sftp/packet.c:
	  Comment typo.

2012-02-09 21:33  castaglia

	* tests/t/lib/ProFTPD/Tests/Config/TimeoutIdle.pm:
	  Updating the TimeoutIdle test cases to use testcase-specific
	  logging.

2012-02-09 19:18  castaglia

	* doc/modules/mod_auth.html:
	  Adding description of MaxLoginAttempts directive to mod_auth
	  docs.

2012-02-09 18:25  castaglia

	* NEWS, contrib/mod_tls.c:
	  Backport of fix for Bug#3742 to 1.3.4 branch.

2012-02-09 18:25  castaglia

	* NEWS, contrib/mod_tls.c:
	  Bug#3742 - Improper handling of self-signed certificate in
	  client-sent cert list when "TLSVerifyClient on" is used.

2012-02-09 18:14  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_tls.pm:
	  Adding regression tests for Bug#3742.

2012-02-09 18:14  castaglia

	* tests/t/etc/modules/mod_tls/: bug3742-ca.pem, bug3742-client.pem:

	  Adding some supporting certs used for testing Bug#3742.

2012-02-09 17:10  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_tls.pm:
	  Updating the main mod_tls tests to use testcase-specific logging.

2012-02-09 11:37  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_ban.pm:
	  Adding testcase for mod_ban's BanOnEvent ClientConnectRate
	  functionality.

2012-02-09 10:11  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_ban.pm:
	  Making sure that all of the existing mod_ban testcases pass.

2012-02-09 10:08  castaglia

	* modules/mod_auth.c:
	  Minor nit fix: When TimeoutLogin is exceeded, if the TimeoutLogin
	  is just a single second, then the 421 response message should say
	  "1 second" rather than "1 seconds".

2012-02-09 09:54  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_ban.pm:
	  Updating mod_ban testcases to use testcase-specific logging.

2012-02-08 22:38  castaglia

	* src/main.c:
	  We were not properly generating the 'core.preparse' event on
	  restarts, even though we would properly generate a
	  'core.postparse' event during a restart.  Add generation of the
	  'core.preparse' event during restarts, for symmetry with the
	  sequence of events during startup parsing.

2012-02-08 22:34  castaglia

	* src/parser.c:
	  The config parser is supposed to handle most things in a
	  case-insensitive fashion; it was not doing do for "<global>" (vs
	  "<Global>").

2012-02-07 19:26  castaglia

	* doc/: modules/mod_core.html, howto/Scoreboard.html:
	  Update the documentation (mod_core to add description for
	  ScoreboardFile and ScoreboardMutex, Scoreboard howto to add
	  anchor for the "what happens if I disable scoreboarding?" FAQ) in
	  light of Bug#3701.

2012-02-07 19:11  castaglia

	* NEWS, RELEASE_NOTES, src/scoreboard.c, tests/api/scoreboard.c:
	  Bug#3701 - Modify ScoreboardFile directive to support disabling
	  scoreboarding.

2012-02-06 09:54  castaglia

	* doc/modules/mod_ls.html:
	  Updated mod_ls docs.

2012-02-05 10:29  castaglia

	* NEWS, modules/mod_core.c:
	  Bug#3745 - Reject PASV command if no IPv4 address available.

2012-02-05 10:25  castaglia

	* modules/mod_core.c:
	  More minor stylistic changes.

2012-02-05 10:08  castaglia

	* modules/mod_core.c:
	  More style changes; no functional change.

2012-02-05 10:04  castaglia

	* modules/mod_core.c:
	  Clean up of some of the coding style; no functional change.

2012-02-05 09:39  castaglia

	* src/proftpd.8.in:
	  Bug#3748 - Update FILES section in proftpd(8) man page.  List the
	  /etc/ftpusers file in the FILES section.

2012-02-02 23:15  castaglia

	* doc/modules/mod_facts.html:
	  Added docs for FactsOptions directive.

2012-02-02 23:02  castaglia

	* NEWS, RELEASE_NOTES, modules/mod_facts.c:
	  Backported fix for Bug#3747 to 1.3.4 branch.

2012-02-02 23:00  castaglia

	* NEWS, RELEASE_NOTES, modules/mod_facts.c:
	  Bug#3747 - Support option for displaying symlinks via MLSD using
	  syntax preferred by FileZilla.

2012-02-02 22:56  castaglia

	* tests/t/lib/ProFTPD/Tests/Config/ShowSymlinks.pm:
	  Updating ShowSymlinks regression tests to work properly on a Mac.

2012-02-02 22:30  castaglia

	* tests/: tests.pl, t/config/factsoptions.t,
	  t/lib/ProFTPD/Tests/Config/FactsOptions.pm:
	  Adding regression tests for the new FactsOptions directive
	  (Bug#3747).

2012-02-02 20:50  castaglia

	* doc/modules/mod_facts.html:
	  Minor update to the MLSD FAQs.

2012-02-01 16:40  castaglia

	* doc/howto/ListOptions.html:
	  Update the ListOptions howto to mention the LISTOnly, NLSTOnly,
	  and NoErrorIfAbsent keywords.

2012-02-01 16:30  castaglia

	* tests/t/lib/ProFTPD/Tests/Config/ListOptions.pm:
	  Supply regression tests for the LISTOnly, NLSTOnly keywords for
	  the ListOptions directive (Bug#3746).

2012-02-01 16:29  castaglia

	* RELEASE_NOTES:
	  Update release notes with stubs about the ListOptions changes.

2012-02-01 16:28  castaglia

	* NEWS, modules/mod_ls.c:
	  Bug#3746 - Support applying ListOptions only to NLST or to LIST
	  commands.  The ListOptions directive now supports "LISTOnly" and
	  "NLSTOnly" keywords.

2012-02-01 14:04  castaglia

	* tests/t/lib/ProFTPD/Tests/Config/ListOptions.pm:
	  Adding regression tests for the new -1 ListOption added for
	  Bug#3744.

2012-02-01 14:03  castaglia

	* NEWS, modules/mod_ls.c:
	  Bug#3744 - Support ls(1) -1 option for LIST command.

2012-02-01 13:21  castaglia

	* tests/t/lib/ProFTPD/TestSuite/Child.pm:
	  There are times when the unit tests will fail, particularly when
	  dealing with data transfers, because the test code expects a
	  response of "226 Transfer complete" when the server has only sent
	  "150 Opening ..." at that point.

	  Provide a convenience assert_transfer_ok() method for checking
	  for both scenarios, in order to try to reduce the spurious test
	  failures due to this race/timing issue.

2012-01-30 16:23  castaglia

	* contrib/mod_sftp/fxp.c:
	  Some mod_sftp users are reporting issues with stalled/segfaulting
	  SFTP uploads; I've narrowed down the cause to the buffering of
	  channel data that the SFTP code does.  Adding finer-grained trace
	  logging in this code, to aid further debugging in this area.

2012-01-26 17:16  castaglia

	* tests/api/scoreboard.c:
	  Forgot to update unit tests to match Scoreboard API change.

2012-01-26 17:02  castaglia

	* include/scoreboard.h, modules/mod_auth.c, src/main.c,
	  src/scoreboard.c:
	  When proftpd starts up in "ServerType standalone" mode, it should
	  keep an fd on the ScoreboardMutex file open -- but make sure that
	  that fd is not one of the Big Three (stdin/stdout/stderr).  This
	  fd should be shared across the child processes, i.e. for proper
	  synchronization during scoreboard scrubbing.

2012-01-26 09:55  castaglia

	* include/table.h, src/auth.c, src/memcache.c, src/table.c,
	  tests/api/table.c:
	  Improve the randomization of table key hashing by moving the
	  mixing of the random seed into the hash value into the Table API
	  itself, rather than pushing it down into the key-hash functions.
	  This makes for a cleaner design, so that custom key hashing
	  functions don't need to handle the seed (or be afraid of causing
	  problems if they forgot to use the seed).

2012-01-25 08:29  castaglia

	* contrib/mod_sftp/mod_sftp.c, modules/mod_core.c, src/main.c:
	  I don't know why, but the ServerIdent configuration handler would
	  parse the Boolean parameter, but store it in the config_rec by
	  using "!bool", inverting the value.  It make for confusing
	  reading of the code which handles that config_rec.

	  Avoid this confusion in the future, and simply store the parsed
	  Boolean value in the config_rec as is.

2012-01-25 08:26  castaglia

	* tests/t/lib/ProFTPD/Tests/Config/ServerIdent.pm:
	  Update the ServerIdent test cases to use the testcase-specific
	  logging.

2012-01-25 08:16  castaglia

	* doc/modules/mod_core.html:
	  Add docs for the ServerIdent directive to the mod_core
	  documentation.

2012-01-25 08:11  castaglia

	* doc/contrib/mod_sftp.html:
	  Updating mod_sftp docs with mention of using ServerIdent.

2012-01-24 23:20  castaglia

	* include/privs.h, src/main.c, src/privs.c:
	  If proftpd is started by a nonroot user, then avoid spamming the
	  logs with "unable to setuid" ERROR level messages.

2012-01-24 23:04  castaglia

	* NEWS, lib/pr-syslog.c:
	  Backported fix for Bug#3699 to 1.3.4 branch.

2012-01-24 23:03  castaglia

	* NEWS, lib/pr-syslog.c:
	  Bug#3699 - ProFTPD crash on start up on Mac OSX Lion with NLS
	  enabled.

2012-01-24 22:48  castaglia

	* configure:
	  Updated configure.

2012-01-24 22:47  castaglia

	* NEWS, config.h.in, configure.in:
	  Backported fix for Bug#3718 to 1.3.4 branch.

2012-01-24 22:46  castaglia

	* NEWS, config.h.in, configure.in:
	  Bug#3718 - ftptop fails to build on OpenSUSE.

2012-01-24 22:27  castaglia

	* RELEASE_NOTES:
	  Update release notes, mentioning mod_sftp and the ServerIdent
	  directive.

2012-01-24 22:26  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_sftp.pm:
	  Adding tests for the ServerIdent directive and mod_sftp, for
	  Bug#3739.

2012-01-24 22:25  castaglia

	* NEWS, contrib/mod_sftp/mod_sftp.c,
	  contrib/mod_sftp/mod_sftp.h.in, contrib/mod_sftp/packet.c,
	  contrib/mod_sftp/packet.h:
	  Bug#3739 - Allow for configurable SSH version identifiers in
	  mod_sftp.

2012-01-23 11:47  castaglia

	* doc/contrib/mod_sql.html:
	  Document that SQL*WhereClauses are effectively overridden by
	  custom queries; the SQL*WhereClause will NOT be appended to a
	  custom query.

2012-01-22 17:54  castaglia

	* contrib/mod_tls.c:
	  Backport fix for Bug#3738 to 1.3.4 branch.

2012-01-22 17:53  castaglia

	* contrib/mod_tls.c:
	  Bug#3738 - Fix the handling of SSL_shutdown() return value so
	  that shutdown errors are properly logged in TLSLog.

2012-01-19 19:04  castaglia

	* contrib/dist/rpm/proftpd.spec:
	  Backporting fix for Bug#3735 to 1.3.4 branch.

2012-01-19 19:01  castaglia

	* contrib/dist/rpm/proftpd.spec:
	  Bug#3735 - RPM spec: proftpd-devel package should require gcc and
	  libtool.

2012-01-19 18:04  castaglia

	* modules/mod_dso.c:
	  Added logging (at debug level 7) of more information of the
	  module that mod_dso successfully loaded.  In particular, we log
	  the full path to the file that was loaded, and its last-modified
	  time.  This should help in situations where old/stale shared
	  modules are being inadvertently loaded.

2012-01-16 16:51  castaglia

	* NEWS, modules/mod_facts.c:
	  Bug#3734 - DirFakeUser/DirFakeGroup off with name causes SIGSEGV
	  for MLSD/MLST commands.

2012-01-16 16:40  castaglia

	* tests/t/lib/ProFTPD/Tests/Config/DirFakeUser.pm:
	  Adding regression tests for Bug#3734.

2012-01-12 21:42  castaglia

	* modules/mod_xfer.c, src/inet.c:
	  Add the calls to pr_inet_set_proto_cork() unconditionally; the
	  conditional use of TCP_CORK vs TCP_NOPUSH (depending on the
	  platform) is contained within the pr_inet_set_proto_cork()
	  function.

2012-01-08 17:33  castaglia

	* doc/contrib/mod_ban.html:
	  Add mod_ban FAQ about BanOnEvent and MaxLoginAttempts.

2012-01-06 10:09  castaglia

	* lib/: pr_fnmatch_loop.c:
	  Fix an issue with compiling with older GCC versions, which don't
	  like a declaration like "char str[]", and instead want "char
	  str[0]".

2012-01-05 09:23  castaglia

	* contrib/.cvsignore:
	  Tell CVS to ignore the generated contrib/Makefile.

2012-01-03 20:44  castaglia

	* Make.rules.in:
	  Move the $INSTALL_STRIP variable out to its own variable, so that
	  at some point in the future, it can be overridden via environment
	  variable.

2012-01-02 16:32  castaglia

	* src/table.c:
	  Make the default table hash function use the random hash "seed"
	  via XOR, rather than the simplistic addition (which wouldn't have
	  added any value at all with regard to mitigating attempts to
	  drive the table into hashing all values to the same chain/bucket
	  index).

2012-01-02 16:30  castaglia

	* src/: auth.c, memcache.c:
	  Update the key hash callbacks used elsewhere in proftpd to take
	  the additional random hash "seed" value into account.

2012-01-02 15:31  castaglia

	* src/table.c:
	  Adding some comments/notes about hashing to src/table.c, for my
	  future reference.

2012-01-02 15:21  castaglia

	* include/table.h, src/table.c, tests/api/table.c:
	  Add a pr_table_load() function for calculating the load factor of
	  a given table.

	  To decrease collision avoidance for default tables, increase the
	  default number of chains in a table from 32 to 256.  Future
	  testing using pr_table_load() will be used to better determine a
	  good default, and perhaps to work towards dynamically adjusting
	  tables (although such adjustments themselves can be abused by an
	  attacker to burn CPU cycles).

2012-01-02 15:04  castaglia

	* include/table.h, src/table.c, tests/api/table.c:
	  Fix some issues with ProFTPD'd pr_table_t handling.

	  First, the default hashing function was fixed so that it actually
	  used the different values in the given key.  Previously, it only
	  ever used the first value.

	  Second, randomize the hash output by generating a random "seed"
	  value on table creation time.  Any custom key hash callbacks need
	  to be updated to accept this seed value as one of the hashing
	  inputs.  This will help to mitigate any attacks which seek to
	  force the table API into the worst-case performance scenario,
	  where all keys are effectively hashed to the same chain, and thus
	  linear scans are done, burning CPU time.

	  Last, add a limit to the maximum number of items that a table can
	  hold.  This, too, helps to mitigate any attacks/abuses that can
	  be done on tables.  This maximum limit is 8K by default, and can
	  be modified by a call to pr_table_ctl.

2011-12-28 20:37  castaglia

	* contrib/mod_sftp/auth.c:
	  As per RFC 4252, if the USERAUTH_REQUEST contains service names
	  which are unknown/unsupported, then return an error to the client
	  and disconnect it.

2011-12-28 20:36  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_sftp.pm:
	  Added regression case for a second USERAUTH_REQUEST.

2011-12-28 20:34  castaglia

	* contrib/mod_sftp/packet.c:
	  Properly ignore an USERAUTH_REQUEST from a client which has
	  already authenticated.

2011-12-28 14:51  castaglia

	* contrib/mod_sftp/auth.c:
	  Add better errno handling during SSH authentication, so that the
	  logged messages are more accurate.

2011-12-21 16:53  castaglia

	* tests/: tests.pl, t/config/umask.t,
	  t/lib/ProFTPD/Tests/Config/Umask.pm:
	  Start working on regression tests for the Umask directive.

2011-12-20 21:17  castaglia

	* modules/mod_dso.c:
	  Minor updates to mod_dso's logging, and better handling (i.e.
	  caching) of the errno value, for better/more accurate logging.

2011-12-20 20:16  castaglia

	* include/dirtree.h, include/fsio.h, include/inet.h,
	  include/modules.h, include/netio.h, include/pool.h,
	  include/proftpd.h, include/sets.h, include/table.h, src/pool.c:
	  More changes to the headers in order to support C++ modules.
	  Mostly it involves not using a typedef'd symbol in the definition
	  of other structs; the C++ compiler is more stringent about that
	  than the C compiler.

2011-12-20 19:09  castaglia

	* NEWS, src/wtmp.c:
	  Backported fix for Bug#3728 to 1.3.4 branch.

2011-12-20 18:58  castaglia

	* NEWS, src/wtmp.c:
	  Bug#3728 - Build failure in wtmp.c on Gentoo/FreeBSD on sparc.

2011-12-20 16:14  castaglia

	* NEWS, README.LDAP, contrib/mod_ldap.c:
	  Backporting fix for Bug#3729 to 1.3.4 branch.

2011-12-20 16:13  castaglia

	* NEWS:
	  Mention that Bug#3729 was fixed.

2011-12-20 14:56  castaglia

	* src/filter.c:
	  Include the filter pattern string in the Filter trace messages.

2011-12-20 13:40  castaglia

	* tests/t/lib/ProFTPD/Tests/Config/PathDenyFilter.pm:
	  Add regression/reproduction recipe for using PathDenyFilter to
	  block uploads of any dot files.

2011-12-20 13:39  castaglia

	* doc/howto/Filters.html:
	  Add PathDenyFilter example for how to block uploads of any/all
	  dot files.

2011-12-18 17:34  castaglia

	* configure:
	  Updated configure.

2011-12-18 17:31  castaglia

	* configure.in:
	  In order to support C++ modules (Bug#3079), we need to add
	  configure-time checks for a C++ compiler.

2011-12-17 18:12  jwm

	* contrib/mod_ldap.c, README.LDAP: git 9d4234fbd69: prevent
	  segfault when no user filters are specified

2011-12-14 14:01  castaglia

	* doc/modules/mod_lang.html:
	  Add a mod_lang FAQ about the list of translations currently
	  provided for proftpd.

2011-12-14 13:45  castaglia

	* modules/mod_lang.c:
	  If mod_lang complains about the configured LangDefault, try to
	  make the emitted log message a little clearer about the reason.

2011-12-14 10:54  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_wrap2_file.pm:
	  Added regression test for Bug#3727.

2011-12-14 10:52  castaglia

	* NEWS, contrib/mod_sftp/auth.c, contrib/mod_wrap2/mod_wrap2.c:
	  Backport of fix for Bug#3727 to 1.3.4 branch.

2011-12-14 10:51  castaglia

	* NEWS, contrib/mod_sftp/auth.c, contrib/mod_wrap2/mod_wrap2.c:
	  Bug#3727 - mod_wrap2 causes unexpected LogFormat %u expansion for
	  SFTP connections.

2011-12-14 10:02  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_wrap2_file.pm:
	  Updating mod_wrap2_file regression tests to use testcase-specific
	  logging.

2011-12-13 16:57  castaglia

	* contrib/mod_copy.c:
	  Updating mod_copy to use the renamed cmd_rec.cmd_class struct
	  member.

2011-12-13 14:54  castaglia

	* src/ctrls.c:
	  If we can't bind the test Unix domain socket, then log it at
	  DEBUG3, rather than at just DEBUG.  This should make proftpd
	  start up logging a little less needlessly verbose.

2011-12-13 14:48  castaglia

	* src/fsio.c:
	  When setting the CLOEXEC flag on fds that are possibly returned
	  by FSIO handlers, be sure to ignore any "Invalid descriptor"
	  errors, since many FSIO handlers return fake fds.

2011-12-13 13:55  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_exec.pm:
	  Update mod_exec tests to use testcase-specific logging.  Added
	  Linux-specific unit test for logging the open fds in the exec'd
	  process, for auditing.

2011-12-13 13:33  castaglia

	* NEWS, contrib/mod_exec.c:
	  Backport of fix for Bug#3726 to 1.3.4 branch.

2011-12-13 13:32  castaglia

	* NEWS, contrib/mod_exec.c:
	  Bug#3726 - mod_exec does not always capture stdout/stderr output
	  from executed command.

2011-12-12 21:55  castaglia

	* tests/t/lib/ProFTPD/Tests/Commands/LIST.pm:
	  Fix broken LIST regression test which only runs with rootprivs.

2011-12-12 11:22  castaglia

	* contrib/mod_exec.c:
	  Stupid typo.

2011-12-12 11:20  castaglia

	* contrib/mod_exec.c:
	  The buflen variable MUST be a signed datatype (e.g. int), rather
	  than unsigned (e.g. size_t), in order to capture any error values
	  from read(2).

2011-12-12 11:14  castaglia

	* contrib/mod_ban.c:
	  Update mod_ban to use session.conn_class struct member.

2011-12-12 11:12  castaglia

	* contrib/mod_exec.c:
	  Updated mod_exec to use session.conn_class struct member.

2011-12-11 20:23  castaglia

	* modules/mod_ctrls.c, src/ctrls.c, src/fsio.c, src/inet.c,
	  src/log.c, src/main.c:
	  As part of preparing proftpd for a different SIGHUP/restart
	  implementation (Bug#3553), start setting the close-on-exec flag
	  on file descriptors opened by the parent/daemon process.  This is
	  a good habit to get into, anyway.

2011-12-11 16:09  castaglia

	* configure:
	  Updated configure.

2011-12-11 15:41  castaglia

	* configure.in:
	  Typo.

2011-12-11 11:51  castaglia

	* configure:
	  Updated configure.

2011-12-11 11:49  castaglia

	* NEWS, configure.in:
	  Backported fix for Bug#3682 to 1.3.4 branch.

2011-12-11 11:48  castaglia

	* NEWS, configure.in:
	  Bug#3682 - Configure does not detect libiconv under Gentoo
	  FreeBSD.

2011-12-10 19:36  castaglia

	* include/pool.h, include/proftpd.h, src/pool.c:
	  Rename 'struct pool' to 'struct pool_struc', to a) be more
	  consistent with the rest of the struct naming conventions used,
	  and b) to avoid causing problems for C++ compilers.  This is for
	  Bug#3079.

2011-12-10 18:37  castaglia

	* RELEASE_NOTES, include/modules.h, src/main.c:
	  Rename the cmdtable.class struct member to cmdtable.cmd_class, in
	  order to support C++ modules (Bug#3079).

2011-12-10 18:33  castaglia

	* RELEASE_NOTES, contrib/mod_site_misc.c, contrib/mod_sftp/auth.c,
	  contrib/mod_sftp/channel.c, contrib/mod_sftp/fxp.c,
	  contrib/mod_sftp/kex.c, contrib/mod_sftp/service.c,
	  include/dirtree.h, modules/mod_log.c, src/main.c:
	  Rename the cmd_rec.class struct member to cmd_rec.cmd_class, in
	  order to support C++ modules (Bug#3079).

2011-12-10 18:14  castaglia

	* RELEASE_NOTES, contrib/mod_ifsession.c, contrib/mod_quotatab.c,
	  contrib/mod_rewrite.c, contrib/mod_sql.c,
	  contrib/mod_sftp/display.c, include/proftpd.h,
	  modules/mod_auth.c, modules/mod_log.c, src/dirtree.c,
	  src/display.c, src/expr.c, src/main.c, tests/api/expr.c:
	  Rename the session.class struct member to session.conn_class, as
	  part of supporting C++ modules (Bug#3079).

2011-12-10 13:51  castaglia

	* doc/contrib/mod_tls.html:
	  Mention the TLSv1.1 and TLSv1.2 values for the TLSProtocol
	  directive in the mod_tls docs.

2011-12-10 13:47  castaglia

	* configure:
	  Updated configure.

2011-12-10 13:41  castaglia

	* config.h.in, configure.in:
	  As part of working toward supporting ECC in mod_tls, and in
	  mod_sftp (Bug#3573), we need to detect whether the version of
	  OpenSSL used supports ECC.

2011-12-10 13:37  castaglia

	* RELEASE_NOTES, contrib/mod_tls.c:
	  Support TLSv1.1 and TLSv1.2 protocol versions in the TLSProtocol
	  directive, assuming the version of OpenSSL used is new enough
	  (1.0.1 and later).

2011-12-10 12:28  castaglia

	* tests/t/lib/ProFTPD/Tests/Config/HideGroup.pm:
	  Add regression tests for HideGroup and the NLST and MLSD
	  commands.

2011-12-10 12:07  castaglia

	* tests/t/lib/ProFTPD/Tests/Config/HideGroup.pm:
	  Updating the HideGroup config regression tests to use
	  testcase-specific logging.

2011-12-10 11:56  castaglia

	* doc/modules/mod_core.html:
	  Adding descriptions for HideGroup, HideNoAccess, and HideUser
	  directives to the mod_core documentation.

2011-12-09 22:06  castaglia

	* tests/t/lib/ProFTPD/Tests/Config/Directory/Limits.pm:
	  Adding regression test for a <Directory> configuration posted in
	  the forums.

2011-12-09 21:51  castaglia

	* tests/t/lib/ProFTPD/Tests/Config/Directory/Limits.pm:
	  Updating <Directory>/<Limit> regression test cases to use
	  testcase-specific logging.

2011-12-09 20:28  castaglia

	* tests/t/lib/ProFTPD/TestSuite/Utils.pm:
	  Added TestSuite function for obtaining an arrayref of the shared
	  module names (if any) built for the given proftpd executable.

2011-12-09 16:14  castaglia

	* contrib/mod_sftp/fxp.c:
	  Make mod_sftp handle READDIR requests in a more
	  optimal/intelligent way.  Specifically, rather than using a
	  hardcoded limit of 30 entries in each response, mod_sftp now
	  looks at the max packet size and the amount of data used for the
	  current number of entries, trying to stuff as many entries in a
	  single response as possible.

2011-12-09 16:12  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_sftp.pm:
	  Adding regression test for SFTP READDIR requests for a "wide"
	  directory (e.g. a directory with many files at the same level).
	  This test is used for trying to optimize the number of entries
	  that mod_sftp returns in response to a READDIR request (i.e. to
	  do better than 30 entries per response).

2011-12-09 16:09  castaglia

	* contrib/mod_sftp/: channel.c, channel.h:
	  Add a sftp_channel_get_maxpacketsz(), so that code (e.g. the SFTP
	  code) can get the maximum packet size.  This can be used e.g. to
	  figure out the maximum number of entries to write into a READDIR
	  response, rather than having the naive hardcoded limit of 30
	  entries per READDIR response.

2011-12-09 16:08  castaglia

	* contrib/mod_sftp/: msg.c, msg.h:
	  The various sftp_msg_write_* functions now return the number of
	  bytes written into the given buffer.	These return values make it
	  easier for calling code to keep a total of how many bytes have
	  been written into the buffer, which in turn enables other
	  optimizations/more intelligent guessing.

2011-12-08 18:03  castaglia

	* RELEASE_NOTES:
	  Fill in a little more of the release notes, for later fleshing
	  out.

2011-12-08 18:02  castaglia

	* doc/contrib/mod_ifsession.html:
	  Add documentation for the new <IfAuthenticated> mod_ifsession
	  config section.

2011-12-08 17:58  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_ifsession.pm:
	  Updating test cases to use testcase-specific logging.  Adding
	  regression test for Bug#3629.

2011-12-08 17:58  castaglia

	* NEWS, contrib/mod_ifsession.c:
	  Bug#3629 - Support <IfAuthenticated> conditional config section.

2011-12-08 16:02  castaglia

	* doc/contrib/mod_sftp.html:
	  Document the new SHA2 SSH2 digests supported by the SFTPDigests
	  directive.

2011-12-08 15:57  castaglia

	* contrib/mod_sftp/configure:
	  Updating mod_sftp configure.

2011-12-08 15:55  castaglia

	* NEWS, contrib/mod_sftp/crypto.c:
	  Bug#3686 - Support SHA2 digests in mod_sftp.

2011-12-08 15:51  castaglia

	* contrib/mod_sftp/configure.in:
	  When the mod_sftp configure script is checking for SHA256/512
	  support in OpenSSL, it needs to check whether linking with
	  OpenSSL requires -ldl (for dynmic linking) and/or -lz (for
	  compression).  Otherwise, the autoconf test programs will fail
	  because of these linker errors (depending on how OpenSSL was
	  built), and the script won't properly detect whether SHA256/512
	  support actually exists.

2011-12-08 13:45  castaglia

	* contrib/mod_sftp/auth.c:
	  Backporting fix from trunk, making sure that %r is interpolated
	  properly for PASS commands when handling SSH2 connections.

2011-12-06 17:01  castaglia

	* src/inet.c:
	  Remove extraneous space and period.

2011-12-06 16:54  castaglia

	* src/inet.c:
	  Make the log message about other processes using the address/port
	  a little better (i.e. mention the possibility of inetd/xinetd
	  using that address/port as well).

2011-12-06 15:08  castaglia

	* contrib/mod_sftp/auth.c:
	  Make sure that the password data is properly hidden with a static
	  string for SFTP connections.

2011-12-06 15:07  castaglia

	* tests/t/lib/ProFTPD/Tests/Logging/ExtendedLog.pm:
	  Add some ExtendedLog tests ensuring that the %r LogFormat
	  variable, for PASS commands, is properly sanitized -- even for
	  SFTP connections.

2011-12-06 14:36  castaglia

	* tests/t/lib/ProFTPD/Tests/Logging/ExtendedLog.pm:
	  Updating ExtendedLog tests to use testcase-specific logging.

2011-12-06 11:45  castaglia

	* tests/t/lib/ProFTPD/Tests/Commands/: RETR.pm, STOR.pm, STOU.pm:
	  Make sure that the regression tests which purport to use active
	  transfers do actually, in fact, use the PORT command for active
	  transfers.

2011-12-06 11:40  castaglia

	* tests/: tests.pl, t/config/rootrevoke.t,
	  t/lib/ProFTPD/Tests/Config/RootRevoke.pm:
	  Start adding unit/regression tests for the RootRevoke directive.

2011-12-06 11:39  castaglia

	* modules/mod_core.c:
	  Comment typo.

2011-12-06 10:13  castaglia

	* src/inet.c:
	  Adding more verbiage to the error message logged when proftpd
	  fails to start, due to being unable to bind to the listening
	  address/port.

2011-12-05 19:34  castaglia

	* contrib/mod_tls.c, modules/mod_core.c:
	  As per RFC2389, the FEAT response MUST include any FTP commands
	  and extensions after RFC959.	We were missing EPRT and EPSV, and
	  CCC for FTPS connections, in our FEAT response.

2011-12-05 17:08  castaglia

	* src/bindings.c:
	  Make sure that the errno value is preserved properly, in order to
	  get all of the proper logging done.

2011-12-05 16:07  castaglia

	* doc/modules/mod_core.html:
	  Adding docs for the AllowFilter and DenyFilter directives to the
	  mod_core docs.

2011-12-05 11:57  castaglia

	* NEWS, contrib/mod_quotatab.c:
	  Backporting fix for Bug#3724 to 1.3.4 branch.

2011-12-05 11:57  castaglia

	* NEWS, contrib/mod_quotatab.c:
	  Bug#3724 - Unloading mod_quotatab causes segfault.

2011-12-04 16:01  castaglia

	* modules/mod_delay.c:
	  Quell a few compiler warnings about unsigned long vs size_t (see
	  on FreeBSD).

2011-12-04 14:19  castaglia

	* tests/api/str.c:
	  Added API/unit test for the newly-added pr_str_replace() function
	  (from Bug#3721).

2011-12-03 12:24  castaglia

	* tests/t/lib/ProFTPD/Tests/Config/DenyFilter.pm:
	  Added regression test for the case-insensitive flag for the
	  DenyFilter directive.

2011-12-03 12:23  castaglia

	* RELEASE_NOTES, modules/mod_core.c:
	  Support the case-insensitive filter flags for the AllowFilter and
	  DenyFilter directives, too (similar to Bug#3592).

2011-12-03 12:12  castaglia

	* tests/: tests.pl, t/config/denyfilter.t,
	  t/lib/ProFTPD/Tests/Config/DenyFilter.pm:
	  Start adding tests for the DenyFilter directive.

2011-12-03 11:43  castaglia

	* tests/t/lib/ProFTPD/Tests/Config/PathDenyFilter.pm:
	  Updating the PathDenyFilter tests to use the testcase-specific
	  logging.

2011-12-03 11:29  castaglia

	* RELEASE_NOTES, doc/contrib/mod_rewrite.html:
	  Adding documentation for the new RewriteMaxReplace directive,
	  added for Bug#3721.

2011-12-03 10:08  castaglia

	* doc/modules/mod_auth.html:
	  Adding module-specific doc description for the RootRevoke
	  directive to the mod_auth docs.

2011-12-02 17:49  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_rewrite.pm:
	  Adding regression tests for Bug#3721.

2011-12-02 17:47  castaglia

	* contrib/mod_rewrite.c:
	  With the fix for Bug#3721, the mod_rewrite module now relies on
	  the 1.3.5 codebase (i.e. the new pr_str_replace() function).

2011-12-02 17:46  castaglia

	* NEWS, contrib/mod_rewrite.c, include/str.h, src/str.c:
	  Bug#3721 - mod_rewrite does not replace characters if there are
	  more than 8 occurrences.

2011-12-01 08:38  castaglia

	* RELEASE_NOTES:
	  Minor update to the release notes, getting them ready for the
	  1.3.5 release cycle.

2011-12-01 07:22  castaglia

	* modules/mod_core.c:
	  Remove the deprecated DisplayGoAway directive (Bug#3443).

2011-11-30 16:58  castaglia

	* NEWS, modules/mod_memcache.c:
	  Backport of fix for Bug#3723 to 1.3.4 branch.

2011-11-30 16:57  castaglia

	* NEWS, modules/mod_memcache.c:
	  Bug#3723 - mod_memcache segfault on server restart.

2011-11-30 07:24  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_rewrite.pm:
	  Adding mod_rewrite regression test showing how to deal with both
	  spaces and tabs in a filename.

2011-11-29 21:30  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_rewrite.pm:
	  Updating the mod_rewrite testcase coding style to use the new
	  testcase-specific logging.

2011-11-23 10:04  castaglia

	* NEWS, contrib/mod_deflate.c, contrib/mod_exec.c,
	  contrib/mod_quotatab.c, contrib/mod_radius.c, contrib/mod_sql.c,
	  contrib/mod_tls.c, contrib/mod_sftp/mod_sftp.c,
	  contrib/mod_wrap2/mod_wrap2.c, modules/mod_ctrls.c,
	  modules/mod_memcache.c:
	  Bug#3720 - Various module logfile permissions are 0600 instead of
	  0640.

2011-11-21 14:24  castaglia

	* doc/howto/Globbing.html:
	  Update the Globbing howto to more accurately describe how the
	  PR_TUNABLE_GLOBBING_MAX_MATCHES limit operates (i.e. that it
	  restricts the number of files _checked_ by glob(3), not the
	  number of _matches_ returned by glob(3)).

2011-11-21 13:59  castaglia

	* NEWS, modules/mod_ls.c:
	  Backport of fix for Bug#3719 to 1.3.4 branch.

2011-11-21 13:58  castaglia

	* NEWS, modules/mod_ls.c:
	  Bug#3719 - LIST -R can loop endlessly if bad directory symlink
	  exists.

2011-11-21 13:49  castaglia

	* tests/t/lib/ProFTPD/Tests/Commands/LIST.pm:
	  Adding regression test for Bug#3719.

2011-11-18 19:02  castaglia

	* contrib/mod_sftp/: blacklist.c, fxp.c, keys.c, scp.c:
	  Fixing up a few more places where -Wshorten-64-to-32 warned about
	  implicit conversions.

2011-11-18 18:54  castaglia

	* contrib/mod_tls.c:
	  Use an explicit typecase to avoid a compiler warninga about
	  implicit shortening of a 64-bit datatype to a 32-bit datatype.

2011-11-18 18:49  castaglia

	* modules/mod_delay.c:
	  Fixing up mod_delay warnings about implicit shortening of 64-bit
	  values to 32-bit values, found by gcc's -Wshorten-64-to-32 flag.

2011-11-18 18:44  castaglia

	* src/proctitle.c:
	  Fix compiler warning about mixing code and declarations (hard to
	  tell, based on the nasty ifdefs in the proctitle code).

2011-11-18 18:40  castaglia

	* include/support.h, modules/mod_ls.c, src/support.c:
	  Quell a warning about implicit 64-to-32 bit conversion, turned up
	  by gcc's -Wshorten-64-to-32 flag, by switching to size_t from
	  int, when getting the max length of a filename.

2011-11-18 18:13  castaglia

	* lib/tpl.c:
	  Fixing some warnings that gcc's -Wshorten-64-to-32 flag picked
	  up.

2011-11-18 16:16  castaglia

	* contrib/mod_ldap.c:
	  Updating mod_ldap version identifier.

2011-11-18 15:03  castaglia

	* README.LDAP:
	  Updating LDAP README in the 1.3.4 branch, too.

2011-11-18 09:35  jwm

	* README.LDAP: latest mod_ldap README

2011-11-18 09:34  jwm

	* contrib/mod_ldap.c: this should have been labeled 2.9.1

2011-11-17 21:21  castaglia

	* src/str.c:
	  A variable is needed, regardless of whether strlcat(3) is present
	  or not.

2011-11-17 21:18  castaglia

	* configure:
	  Updated configure.

2011-11-17 21:06  castaglia

	* configure.in, config.h.in, lib/sstrncpy.c, src/str.c:
	  Use the strlcat(3) and strlcpy(3) functions, if available.  I'm
	  hoping that these will have been optimized for the host platform,
	  and perform better than our homegrown versions.

2011-11-17 15:40  castaglia

	* NEWS, contrib/mod_tls.c, contrib/mod_sftp/keys.c,
	  lib/pr-syslog.c, lib/pwgrent.c, modules/mod_auth_file.c,
	  modules/mod_ctrls.c, src/ctrls.c, utils/ftptop.c:
	  Backport of fix for Bug#3717 to 1.3.4 branch.

2011-11-17 15:40  castaglia

	* NEWS, contrib/mod_tls.c, contrib/mod_sftp/keys.c,
	  lib/pr-syslog.c, lib/pwgrent.c, modules/mod_auth_file.c,
	  modules/mod_ctrls.c, src/ctrls.c, utils/ftptop.c:
	  Bug#3717 - proftpd fails to run with "Abort trap" error message.

	  Replace all occurrences of strncpy(3) with our own sstrncpy(), to
	  avoid any gcc traps/issues about using that function.

2011-11-17 15:33  castaglia

	* tests/t/lib/ProFTPD/Tests/Commands/HOST.pm:
	  Might as well update these HOST tests to use testcase-specific
	  logging while I'm changing things.

2011-11-17 15:31  castaglia

	* tests/t/lib/ProFTPD/Tests/Commands/: HELP.pm, QUIT.pm, REST.pm,
	  RNFR.pm, RNTO.pm:
	  Updating the rest of the FTP command tests to use
	  testcase-specific logging.

2011-11-17 15:07  castaglia

	* tests/t/lib/ProFTPD/Tests/Commands/: ALLO.pm, FEAT.pm, MDTM.pm,
	  MODE.pm, NOOP.pm, SIZE.pm, STRU.pm:
	  Updating more tests to use testcase-specific logging.

2011-11-17 15:01  castaglia

	* tests/t/lib/ProFTPD/Tests/Commands/: CDUP.pm, DELE.pm, MKD.pm,
	  RMD.pm, SYST.pm, TYPE.pm:
	  Updating more tests to use the testcase-specific logging.

2011-11-17 14:54  castaglia

	* tests/t/lib/ProFTPD/Tests/Commands/: CWD.pm, PASS.pm, PWD.pm,
	  USER.pm:
	  Updating tests to use the testcase-specific logging.

2011-11-17 14:48  castaglia

	* tests/t/lib/ProFTPD/Tests/Commands/EPSV.pm:
	  Updating EPSV tests to use testcase-specific logging.

2011-11-17 14:46  castaglia

	* tests/t/lib/ProFTPD/Tests/Commands/PASV.pm:
	  Update PASV tests to use the testcase-specific logging.

2011-11-17 14:44  castaglia

	* tests/t/lib/ProFTPD/Tests/Logins.pm:
	  Update the login tests to use the testcase-specific logging.

2011-11-17 14:40  castaglia

	* tests/t/lib/ProFTPD/Tests/Commands/SITE/CHMOD.pm:
	  Update the SITE CHMOD test to log its fatal exception in the
	  testcase log.

2011-11-17 14:38  castaglia

	* tests/t/lib/ProFTPD/Tests/Commands/: ABOR.pm, APPE.pm, EPRT.pm,
	  LIST.pm, NLST.pm, RETR.pm, STAT.pm, STOR.pm, STOU.pm:
	  Updating the tests to log the exception in the testcase log.

2011-11-17 14:27  castaglia

	* tests/t/lib/ProFTPD/Tests/Commands/PORT.pm:
	  Finally managed to reproduce, and fix, the one PORT testcase
	  which kept failing in my continuous integration server.

2011-11-17 14:02  castaglia

	* tests/t/lib/ProFTPD/Tests/Commands/PORT.pm:
	  Update the PORT tests to pass along the fatal exception for
	  logging.

2011-11-17 14:01  castaglia

	* tests/t/lib/ProFTPD/TestSuite/Utils.pm:
	  The test_append_logfile() function now takes an optional
	  parameter for the exception which caused the testcase to fail;
	  this exception is then added to the main log file.

2011-11-17 10:36  castaglia

	* tests/t/lib/ProFTPD/Tests/Commands/STOR.pm:
	  Updated STOR tests to use testcase-specific logging.

2011-11-17 10:25  castaglia

	* tests/t/lib/ProFTPD/Tests/Commands/RETR.pm:
	  Updated RETR tests to use testcase-specific logging.

2011-11-17 10:22  castaglia

	* tests/t/lib/ProFTPD/Tests/Commands/STOU.pm:
	  Updated STOU tests to use testcase-specific logging.

2011-11-17 10:19  castaglia

	* tests/t/lib/ProFTPD/Tests/Commands/LIST.pm:
	  Update LIST tests to use testcase-specific logging.

2011-11-17 10:13  castaglia

	* tests/t/lib/ProFTPD/Tests/Commands/APPE.pm:
	  Update APPE tests to use testcase-specific logging.

2011-11-17 10:09  castaglia

	* tests/t/lib/ProFTPD/Tests/Commands/NLST.pm:
	  Update NLST tests to use testcase-specific logging.

2011-11-17 10:04  castaglia

	* tests/t/lib/ProFTPD/Tests/Commands/STAT.pm:
	  Update STAT tests to use testcase-specific logging.

2011-11-17 10:02  castaglia

	* tests/t/lib/ProFTPD/Tests/Commands/EPRT.pm:
	  Updating EPRT tests to use testcase-specific logging.

2011-11-17 09:58  castaglia

	* tests/t/lib/ProFTPD/Tests/Commands/ABOR.pm:
	  Updated ABOR tests to use testcase-specific logging.

2011-11-17 09:55  castaglia

	* tests/t/lib/ProFTPD/TestSuite/Utils.pm:
	  When appending the testcase log file to the main 'tests.log'
	  file, use the full path to the main log file, for better
	  diagnostics when there are problems writing to that file.

2011-11-17 09:53  castaglia

	* tests/t/lib/ProFTPD/Tests/Commands/MLSD.pm:
	  Updating MLSD tests to use testcase-specific logging.

2011-11-17 09:48  castaglia

	* tests/t/lib/ProFTPD/Tests/Commands/MLST.pm:
	  Updating MLST tests to use testcase-specific logging.

2011-11-17 09:43  castaglia

	* tests/t/lib/ProFTPD/Tests/Commands/MFMT.pm:
	  Updated MFMT tests to use the new testcase-specific logging.

2011-11-17 09:39  castaglia

	* tests/t/lib/ProFTPD/Tests/Commands/MFF.pm:
	  Updating the MFF tests to use the testcase-specific logging.

2011-11-17 09:37  castaglia

	* tests/t/lib/ProFTPD/Tests/Commands/SITE/CHMOD.pm:
	  Updating SITE CHMOD test to use the new testcase-specific
	  logging.

2011-11-17 09:32  castaglia

	* tests/t/lib/ProFTPD/Tests/Commands/PORT.pm:
	  After appending the testcase-specific log to the main
	  'tests.log', be sure to unlink the testcase-specific log file.

2011-11-16 17:56  castaglia

	* tests/Makefile.in:
	  Forgot to update the tests/Makefile to use the renamed tests.pl
	  command-line option.

2011-11-16 17:49  castaglia

	* tests/t/lib/ProFTPD/Tests/Commands/PORT.pm:
	  Updating the PORT testcases to using the new per-testcase logging
	  functions, in an effort to track down why one of these testcases
	  keeps failing in my continuous integration build.

2011-11-16 17:47  castaglia

	* tests/t/lib/ProFTPD/TestSuite/Utils.pm:
	  Adding some functions to generate per-testcase log file names,
	  and to append the contents of those logs, when the testcase
	  files, to the main 'tests.log' file.	This should help preserve
	  the log files for failed testcases, even when the following
	  testcases succeed; currently those subsequent testcases will
	  delete the 'tests.log'.

2011-11-16 15:50  castaglia

	* NEWS, modules/mod_facts.c:
	  Backporting fix for Bug#3715 to 1.3.4 branch.

2011-11-16 15:49  castaglia

	* NEWS, modules/mod_facts.c:
	  Bug#3715 - MLSD/MLST fail when "DirFakeUser off" or "DirFakeGroup
	  off" used.

2011-11-16 15:48  castaglia

	* contrib/mod_load/.cvsignore:
	  More auto-generated files to be ignored by CVS.

2011-11-16 15:41  castaglia

	* tests/t/lib/ProFTPD/Tests/Config/: DirFakeGroup.pm,
	  DirFakeUser.pm:
	  Adding regression tests for Bug#3715.

2011-11-16 15:30  castaglia

	* modules/mod_ls.c:
	  Clean up the coding style in a couple of places.  Also replace
	  strcmp(3) with strncmp(3) in a couple of places where a string
	  constant was being used for comparison.

2011-11-16 15:22  castaglia

	* tests/tests.pl:
	  Change tests.pl to use --file-pattern instead of just --pattern,
	  in order to make room for a --test-pattern.  This --test-pattern
	  (which doesn't exist yet) will be used to provide a similar regex
	  matching pattern for testcase names (as opposed to file names).

2011-11-16 15:15  castaglia

	* tests/t/lib/ProFTPD/Tests/Commands/MLST.pm:
	  Updating MLST test cases to hopefully pass better on my Mac OSX
	  machine.

2011-11-16 14:42  castaglia

	* tests/t/lib/ProFTPD/Tests/Utils/ftpwho.pm:
	  Adding a regression test for Bug#3714.

2011-11-16 14:30  castaglia

	* utils/ftpwho.c:
	  Quell cppcheck warning about a memory leak.

2011-11-16 13:59  castaglia

	* Makefile.in, tests/Makefile.in:
	  Provide a wider range of 'check' targets, so that various parts
	  of the testsuite can be run from the top-level Makefile.  This is
	  useful for the continuous integration server config I am working
	  on.

2011-11-16 13:55  castaglia

	* tests/tests.pl:
	  Adding support for a --pattern comand-line option to the
	  testsuite script, for specifing a filename pattern.  All testcase
	  files whose names match the given pattern will be run.  This
	  allows us to run only certain files as needed (e.g. commands,
	  config, modules, etc).

2011-11-16 13:35  castaglia

	* tests/t/lib/ProFTPD/Tests/Commands/NLST.pm:
	  Minor updates to the NLST unit tests.

2011-11-16 13:34  castaglia

	* modules/mod_ls.c:
	  Fix the handling of filenames with non-printable characters, when
	  the -B list option is provided/used by the client.

2011-11-16 12:00  castaglia

	* NEWS, src/cmd.c, src/main.c:
	  Backport of fix for Bug#3714 to 1.3.4 branch.

2011-11-16 12:00  castaglia

	* NEWS, src/cmd.c, src/main.c:
	  Bug#3714 - ftpwho/ftptop are not showing command arguments (e.g.
	  downloaded file name).

2011-11-15 17:24  castaglia

	* tests/t/lib/ProFTPD/Tests/Commands/PORT.pm:
	  Making some of the PORT tests a little more resilient.

2011-11-15 17:19  castaglia

	* tests/t/lib/ProFTPD/Tests/Commands/DELE.pm:
	  Update DELE unit tests to run better on MacOSX.

2011-11-15 17:13  castaglia

	* tests/t/lib/ProFTPD/Tests/Commands/RMD.pm:
	  Updating RMD tests to hopefully pass better on my MacOSX machine.

2011-11-15 17:11  castaglia

	* tests/t/lib/ProFTPD/Tests/Commands/MKD.pm:
	  Updating MKD tests to hopefully pass better on my MacOSX machine.

2011-11-15 17:00  castaglia

	* tests/t/lib/ProFTPD/Tests/Commands/PWD.pm:
	  Fixing the PWD tests so that they work properly on MacOSX.

2011-11-15 14:20  castaglia

	* NEWS, src/log.c:
	  Bug#3646 - Debug logging to stderr should include timestamps and
	  PID.

2011-11-15 13:10  castaglia

	* doc/contrib/mod_quotatab.html:
	  Adding in missing "Context" descriptions for some of the
	  mod_quotatab directives.

2011-11-15 11:12  castaglia

	* contrib/.cvsignore:
	  Ignore the generated Makefile.

2011-11-15 08:13  castaglia

	* doc/modules/mod_core.html:
	  Missing <br> tag.

2011-11-15 08:12  castaglia

	* doc/modules/mod_core.html:
	  Missing closing </code> tags.

2011-11-14 14:13  castaglia

	* src/inet.c:
	  Use the IPV6_TCLASS value for IPv6 connections for setting the
	  Type-Of-Service (TOS) bits, where available.

2011-11-13 18:53  castaglia

	* tests/api/response.c:
	  Fix the Bug#3711 test case to work properly on Mac OSX 10.5; the
	  test fails due to SIGBUS rather than SIGSEGV in this case.

2011-11-11 15:14  castaglia

	* NEWS, contrib/mod_tls.c:
	  Bug#3713 - mod_tls cannot be compiled using Openssl 0.9.6.

2011-11-11 10:19  castaglia

	* contrib/dist/rpm/proftpd.spec:
	  Try to fix the broken .spec file (broken because rpmbuild doesn't
	  understand basic Unix config file formats, apparently).

2011-11-11 10:18  castaglia

	* contrib/dist/rpm/proftpd.spec:
	  Updated .spec file.  Have I mentioned how much I dislike rpmbuild
	  and .spec file "idiosyncrasies"?

2011-11-11 10:00  castaglia

	* include/version.h:
	  Updating version for CVS.

2011-11-11 09:59  castaglia

	* RELEASE_NOTES:
	  Adding the CVE identifier for Bug#3711 to the release notes, for
	  future reference.

2011-11-11 09:27  castaglia

	* ChangeLog:
	  Updating ChangeLog.

2011-11-11 09:24  castaglia

	* RELEASE_NOTES, contrib/dist/rpm/proftpd.spec, include/version.h,
	  NEWS:
	  Preparing to release 1.3.4a.

2011-11-10 15:51  castaglia

	* RELEASE_NOTES:
	  Updating release notes.

2011-11-10 15:51  castaglia

	* NEWS:
	  Bug#3712 - mod_wrap2/mod_load build errors: missing config.h.
	  (Patches committed earlier today.)

2011-11-10 09:41  castaglia

	* include/version.h:
	  Updated trunk version in CVS.

2011-11-10 09:13  castaglia

	* contrib/: mod_load/Makefile.in, mod_wrap2/Makefile.in:
	  Fixing the Makefiles for mod_load and mod_wrap2.

2011-11-10 09:12  castaglia

	* contrib/: mod_load/Makefile.in, mod_wrap2/Makefile.in:
	  Fixing the Makefiles for mod_load and mod_wrap2; I broke them
	  when trying to fix the conditional contrib module library issue.

2011-11-10 08:43  castaglia

	* contrib/dist/rpm/: proftpd.spec:
	  Trying to fix the release_cand_version macro in the .spec file.

2011-11-10 08:10  castaglia

	* contrib/dist/rpm/xinetd:
	  Fixed comment in xinetd config file.

2011-11-10 08:08  castaglia

	* contrib/dist/rpm/xinetd:
	  Fixed comment in xinetd.

2011-11-09 14:39  castaglia

	* contrib/dist/rpm/proftpd.spec, include/version.h:
	  Updating for 1.3.3g release.

2011-11-09 14:37  castaglia

	* ChangeLog:
	  Updated ChangeLog.

2011-11-09 14:35  castaglia

	* contrib/dist/rpm/proftpd.spec, include/version.h:
	  Updating for 1.3.4 release.

2011-11-09 09:47  castaglia

	* NEWS:
	  Updating NEWS, getting ready for release.

2011-11-09 09:47  castaglia

	* NEWS, RELEASE_NOTES:
	  Updating NEWS, release notes, getting ready for release.

2011-11-09 09:40  castaglia

	* RELEASE_NOTES:
	  Minor formatting consistency fix.

2011-11-09 09:40  castaglia

	* RELEASE_NOTES:
	  Updated release notes.

2011-11-09 09:36  castaglia

	* RELEASE_NOTES:
	  Updating release notes.

2011-11-09 09:34  castaglia

	* NEWS, src/main.c:
	  Backport of fix for Bug#3711 to 1.3.3 branch.

2011-11-09 09:32  castaglia

	* NEWS, src/main.c:
	  Bug#3711 - Response pool use-after-free memory corruption error.

2011-11-08 11:03  castaglia

	* tests/api/response.c:
	  Adding more unit tests for the Response API, including a
	  demonstration of Bug#3711.

2011-11-08 10:20  castaglia

	* contrib/dist/rpm/xinetd:
	  Updating the xinetd config file for the RPM package, as per
	  Bug#3640.

2011-11-07 14:42  castaglia

	* RELEASE_NOTES:
	  Updated release notes to mention the RPM/.spec changes.

2011-11-07 14:41  castaglia

	* contrib/dist/rpm/: basic-pam.conf, proftpd.spec:
	  More updates for Bug#3640, reworking the proftpd.spec file and
	  related config files.

2011-11-07 14:25  castaglia

	* NEWS, contrib/dist/rpm/proftpd-tmpfs.conf,
	  contrib/dist/rpm/proftpd.init.d,
	  contrib/dist/rpm/proftpd.logrotate, contrib/dist/rpm/proftpd.pam,
	  contrib/dist/rpm/proftpd.service:
	  Bug#3640 - rpmbuild on CentOS5.5 (64bit): "File not found by
	  glob".

	  This involves a fairly large reworking of the .spec file, and
	  adding new files expected by the .spec file.

2011-11-06 14:25  castaglia

	* contrib/mod_load/configure:
	  Updated mod_load configure.

2011-11-06 14:19  castaglia

	* .cvsignore:
	  Ignore the auto-generated module-libs.txt file.

2011-11-06 14:16  castaglia

	* contrib/mod_load/: Makefile.in, configure.in, mod_load.c,
	  mod_load.c.in:
	  Updating the mod_load configure/Makefiles to use the
	  $(MODULE_LIBS_FILE) mechanism.

2011-11-06 13:58  castaglia

	* contrib/mod_wrap2/configure:
	  Updated mod_wrap2 configure.

2011-11-06 13:56  castaglia

	* contrib/mod_wrap2/: Makefile.in, configure.in, mod_wrap2.c,
	  mod_wrap2.h.in:
	  Updating the mod_wrap2 build files to use the new
	  $(MODULE_LIBS_FILE), rather than modifying the generated
	  mod_wrap2.h file.

2011-11-06 13:37  castaglia

	* Make.rules.in, Makefile.in:
	  Modifying the build system/scripts to support a
	  $(MODULE_LIBS_FILE) file, which will contain a list of libraries
	  that modules will want to add to the linker list, when linking
	  the full proftpd executable AND when the modules in question are
	  being built as static modules.  Shared modules are built as .la
	  files, which contain their own linkage lists.

	  Consider the case where a module like mod_load (or mod_wrap2)
	  might want to conditionally link against a library, depending on
	  whether the host requires that library or depending on the
	  configure options given when building proftpd.  The libraries
	  needed by the module won't be known by the top-level main
	  Makefile -- hence the need for this new $(MODULE_LIBS_FILE) file.
	   The top-level Makefile knows to read from this file for
	  additional libraries; the module configure scripts/Makefiles can
	  append the libraries they need to the $(MODULE_LIBS_FILE) file.

	  I'll be updating the mod_wrap2 configure/Makefile files to use
	  this mechanism shortly.

2011-11-05 16:01  castaglia

	* modules/mod_ls.c:
	  Adding a little more trace logging, and some
	  --enable-devel=timing instrumenting of the code, trying to track
	  down a reported CPU spike.

2011-11-03 10:12  castaglia

	* config.h.in:
	  Since the AC_FUNC_SETPGRP macro has been removed from the
	  configure.in file, we should always assume the POSIX setpgrp(2)
	  signature.

2011-11-01 07:04  castaglia

	* RELEASE_NOTES:
	  Updated release notes.

2011-10-31 23:16  castaglia

	* configure:
	  Updated configure.

2011-10-31 23:13  castaglia

	* configure.in, m4/proftpd.m4:
	  Start tweaking the configure script to work better in
	  cross-compiling situations.

2011-10-31 11:39  castaglia

	* tests/Makefile.in:
	  Make sure to build the response unit tests, and include them in
	  the api-tests binary.

2011-10-31 11:38  castaglia

	* tests/api/: response.c, stubs.c, tests.c, tests.h:
	  Start working on API-level regression tests for the Response API.

2011-10-24 16:06  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_tls.pm:
	  Fixing some of the broken mod_tls regression tests so that they
	  pass properly again.

2011-10-24 15:59  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_tls.pm:
	  Updating the mod_tls tests to reflect changes to the
	  Net:FTPSSL-0.19 version of the dependent Perl module.

2011-10-23 19:31  castaglia

	* tests/: tests.pl, t/config/listoptions.t,
	  t/lib/ProFTPD/Tests/Config/ListOptions.pm:
	  Start working on regression tests for the ListOptions directive,
	  spurred by some questions about it in the online forums.

2011-10-18 07:52  castaglia

	* doc/contrib/mod_sftp.html:
	  Mention that mod_sftp does not honor the ListOptions directive.

2011-10-17 16:43  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_rewrite.pm:
	  Adding mod_rewrite regression test for rewriting backslashes to
	  slashes.

2011-10-17 11:25  castaglia

	* doc/howto/Rewrite.html:
	  Adding new mod_rewrite example, for converting backslashes to
	  slashes.

2011-10-13 09:23  castaglia

	* contrib/mod_sftp/Makefile.in:
	  Remove redundant object file from `ar' command list; the
	  mod_sftp.o object is already mentioned in the $(MODULE_OBJS) list
	  of object files.

2011-10-12 10:17  castaglia

	* doc/contrib/mod_sftp.html:
	  Updated SFTPOptions documentation to mention new
	  IgnoreSFTPSetTimes option (Bug#3706).

2011-10-12 10:15  castaglia

	* NEWS, contrib/mod_sftp/fxp.c, contrib/mod_sftp/mod_sftp.c,
	  contrib/mod_sftp/mod_sftp.h.in,
	  tests/t/lib/ProFTPD/Tests/Modules/mod_sftp.pm:
	  Bug#3706 - Support SFTPOption for ignoring requests to modify
	  timestamps.

2011-10-10 14:08  castaglia

	* NEWS, RELEASE_NOTES, contrib/mod_tls.c:
	  Backport of fix for Bug#3704 to 1.3.3 branch.

2011-10-10 14:05  castaglia

	* NEWS, RELEASE_NOTES:
	  Fuller description in NEWS for Bug#3704, and mention the new
	  TLSOption in the release notes.

2011-10-10 14:02  castaglia

	* doc/contrib/mod_tls.html:
	  Documenting the new NoEmptyFragments TLSOption.

2011-10-10 13:56  castaglia

	* NEWS, contrib/mod_tls.c:
	  Bug#3704 - Enable OpenSSL countermeasure against SSLv3/TLSv1
	  BEAST attacks.

2011-10-06 09:00  castaglia

	* configure:
	  Updated configure for Bug#3192.

2011-10-06 08:56  castaglia

	* NEWS, config.h.in, configure.in, contrib/mod_sql_postgres.c:
	  Bug#3192 - PQescapeStringConn() needs a better check.

2011-10-06 08:33  castaglia

	* configure:
	  Updated configure for Bug#3669.

2011-10-06 08:27  castaglia

	* NEWS, config.h.in, configure.in, contrib/mod_sql_mysql.c:
	  Bug#3669 - mod_sql_mysql.so: undefined symbol:
	  make_scrambled_password with MySQL 5.5 on Fedora.

2011-10-05 18:05  castaglia

	* NEWS, src/timers.c:
	  Backport of fix for Bug#3702.  For the 1.3.3 branch, a different
	  fix is used, since the necessary configure code is not present in
	  this branch.

2011-10-05 18:04  castaglia

	* configure:
	  Updated configure for Bug#3702.

2011-10-05 17:59  castaglia

	* NEWS, configure.in:
	  Bug#3702 - ProFTPD with mod_sql_mysql dies of "Alarm clock" on
	  FreeBSD.

2011-10-04 13:59  castaglia

	* src/: main.c, support.c, timers.c:
	  Add checking of the return values for calling signal(2),
	  sigaction(2), and siginterrupt(2), and logging of any errors.

2011-10-03 22:27  castaglia

	* contrib/mod_sql.c,
	  tests/t/lib/ProFTPD/Tests/Modules/mod_sql_sqlite.pm:
	  Further fix to Bug#3692: make sure that if the processing of the
	  SQLLog directive (marked with "IGNORE_ERRORS") needs to open a
	  database connection, and the database info is bad (e.g. bad
	  database name), this bad database open is also ignored, rather
	  than causing the session to be disconnected.

2011-09-29 07:17  castaglia

	* contrib/mod_sftp/date.c:
	  Bug#3650 - Update the FSF address.

2011-09-26 20:57  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_sftp.pm:
	  Minor update to unit test, trying to avoid ugly regex error on
	  Mac OSX (due to its temporary file naming scheme).

2011-09-26 09:41  castaglia

	* ChangeLog:
	  Updating ChangeLog.

2011-09-26 09:40  castaglia

	* NEWS, RELEASE_NOTES, contrib/dist/rpm/proftpd.spec,
	  include/version.h:
	  Updated files for release of 1.3.3f.

2011-09-26 08:53  castaglia

	* include/version.h:
	  Updated version for CVS status.

2011-09-26 08:15  castaglia

	* contrib/dist/rpm/proftpd.spec, include/version.h:
	  Update the versions for RC3.

2011-09-26 08:14  castaglia

	* NEWS:
	  Update NEWS with the release date.

2011-09-26 08:08  castaglia

	* ChangeLog:
	  Updated ChangeLog.

2011-09-26 08:05  castaglia

	* RELEASE_NOTES:
	  Updated release notes.

2011-09-26 08:00  castaglia

	* modules/mod_log.c:
	  Slightly better fix for Bug#3696, which doesn't require the whole
	  command dispatch mechanism for getting the ExtendedLog entry
	  written.

2011-09-24 19:50  castaglia

	* tests/t/lib/ProFTPD/Tests/Logging/ExtendedLog.pm:
	  Add unit test for Bug#3696 (ExtendedLog written in cases of
	  TimeoutStalled) for SFTP transfers as well.

2011-09-24 14:56  castaglia

	* contrib/mod_sftp/scp.c:
	  Modify the handling of SCP downloads to allow for PRE_CMD
	  handlers to rewrite the file name (e.g. via mod_rewrite).

2011-09-24 12:54  castaglia

	* modules/mod_xfer.c:
	  If ever the RETR PRE_CMD handler in mod_xfer says "no, I won't
	  download this file because it's not a regular file", set the
	  errno to EISDIR.  This specific errno value can then be handled
	  properly, e.g. by the SCP download code.

2011-09-24 12:52  castaglia

	* src/main.c:
	  More tricks to preserve the errno value through the command
	  dispatch mechanism.

2011-09-24 12:12  castaglia

	* modules/mod_log.c:
	  Guard against a possibly-null session.curr_cmd_rec pointer, when
	  handling the 'core.timeout-stalled' event in mod_log.

2011-09-24 10:33  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_sftp/rewrite.pm:
	  Fixing broken unit tests.

2011-09-23 23:44  castaglia

	* contrib/mod_exec.c:
	  Use strncmp(3) in more places, give the compiler some hints when
	  we will be ignoring the return values, and fix the byte count for
	  writes when using the useStdin ExecOption.

2011-09-23 23:38  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_sftp/exec.pm:
	  Leave a long explanation to my future self about failures of a
	  particular unit test, and why it can happen (e.g. due to module
	  load ordering).

2011-09-23 22:59  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_sql_sqlite.pm:
	  Fix broken mod_sql_sqlite unit tests.

2011-09-23 22:42  castaglia

	* tests/t/lib/ProFTPD/Tests/Logging/ExtendedLog.pm:
	  Relax some of the heuristics, allowing some of the unit tests to
	  pass more regularly.

2011-09-23 22:33  castaglia

	* contrib/mod_rewrite.c:
	  Fix a regression in the RewriteHome feature, where it wasn't
	  working at all.

2011-09-23 22:33  castaglia

	* tests/t/lib/ProFTPD/Tests/Config/RewriteHome.pm:
	  Minor style updates; no functional change.

2011-09-23 22:18  castaglia

	* tests/t/lib/ProFTPD/Tests/Config/MaxStoreFileSize.pm:
	  Expect to handle a "File too large" error response as well in
	  these unit tests.

2011-09-23 22:16  castaglia

	* tests/t/lib/ProFTPD/Tests/Config/DisplayChdir.pm:
	  Fix broken unit test.

2011-09-23 22:14  castaglia

	* tests/t/lib/ProFTPD/Tests/Commands/PORT.pm:
	  Add a different expected error message, fixing the unit test on a
	  Linux system.

2011-09-23 22:09  castaglia

	* tests/t/lib/ProFTPD/Tests/Commands/HELP.pm:
	  Fix the HELP unit test to work properly, even if mod_tls is in
	  the build.

2011-09-23 22:05  castaglia

	* tests/t/lib/ProFTPD/Tests/Commands/FEAT.pm:
	  Update the FEAT unit test to better handle when other modules,
	  e.g.	mod_site_misc and mod_copy, are in the build.

2011-09-23 18:19  castaglia

	* tests/tests.pl:
	  Don't run the mod_sftp_sql unit tests unless that module, too, is
	  loaded.

2011-09-23 18:13  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_rewrite.pm:
	  More places to catch data connection timeouts.

2011-09-23 18:07  castaglia

	* tests/t/lib/ProFTPD/Tests/Logging/ExtendedLog.pm:
	  More places to catch data connection timeouts.

2011-09-23 18:01  castaglia

	* tests/t/lib/ProFTPD/Tests/Config/: TimeoutNoTransfer.pm,
	  FTPAccess/RETR.pm:
	  More places to catch data connection timeouts.

2011-09-23 17:56  castaglia

	* tests/t/lib/ProFTPD/Tests/Config/: MaxRetrieveFileSize.pm,
	  MaxStoreFileSize.pm:
	  More places to catch data connection timeouts.

2011-09-23 17:46  castaglia

	* tests/t/lib/ProFTPD/Tests/Config/HiddenStores.pm:
	  More places to catch data connection timeouts.

2011-09-23 17:42  castaglia

	* tests/t/lib/ProFTPD/Tests/Config/CommandBufferSize.pm:
	  More places to catch data connection timeouts.

2011-09-23 17:38  castaglia

	* tests/t/lib/ProFTPD/Tests/Commands/: LIST.pm, MLSD.pm, NLST.pm,
	  RETR.pm, STOR.pm:
	  Hardening the testsuite caused by spurious data connection
	  timeouts; this makes the tests still fail when it happens, but
	  the output is more intelligible.

2011-09-23 16:28  castaglia

	* tests/t/lib/ProFTPD/Tests/: Commands/APPE.pm, Commands/LIST.pm,
	  Config/ShowSymlinks.pm, Modules/mod_ban.pm, Modules/mod_sftp.pm,
	  Modules/mod_sql_sqlite.pm:
	  Trying to fix/quell Perl warnings emitted while running the
	  testsuite.

2011-09-23 09:54  castaglia

	* tests/api/scoreboard.c:
	  Fixing pr_scoreboard_scrub() unit test so that it passes
	  properly.

2011-09-21 08:30  castaglia

	* NEWS, modules/mod_core.c,
	  tests/t/lib/ProFTPD/Tests/Commands/RNFR.pm:
	  Bug#3698 - <Limit WRITE> does not prevent deletion of a
	  file/directory via renaming.

2011-09-21 07:50  castaglia

	* NEWS, src/netio.c:
	  Backport of fix for Bug#3697 to 1.3.3 branch.

2011-09-21 07:49  castaglia

	* tests/t/lib/ProFTPD/Tests/Telnet.pm:
	  Adding regression test for Bug#3697.

2011-09-21 07:48  castaglia

	* NEWS, src/netio.c:
	  Bug#3697 - Filenames with embedded IAC do not get processed
	  correctly.

2011-09-20 22:40  castaglia

	* tests/t/lib/ProFTPD/Tests/Logging/ExtendedLog.pm:
	  Regression test for Bug#3696.

2011-09-20 22:40  castaglia

	* NEWS, include/proftpd.h, modules/mod_log.c, src/main.c:
	  Bug#3696 - ExtendedLog not getting written on timeouts.

2011-09-20 22:03  castaglia

	* NEWS, include/inet.h, modules/mod_core.c, src/bindings.c,
	  src/inet.c:
	  Bug#3693 - Clients are disconnected if proftpd cannot listen on
	  port for passive data transfer.

2011-09-09 11:13  castaglia

	* contrib/mod_sftp/mac.c:
	  Use the newer HMAC_Init_ex() when available in the OpenSSL
	  version used (e.g. to make use of any ENGINEs configured), as
	  well as checking the return values of HMAC_Init_ex(),
	  HMAC_Update(), and HMAC_Final() (again, when supported by the
	  OpenSSL version used).

2011-09-09 10:59  castaglia

	* doc/contrib/mod_sftp.html:
	  Update mod_sftp doc to mention Axway clients as having the
	  channel window sizing issues, just like WS_FTP.

2011-09-06 14:14  castaglia

	* NEWS, contrib/mod_sql.c,
	  tests/t/lib/ProFTPD/Tests/Modules/mod_sql_sqlite.pm:
	  Bug#3692 - SQLLog IGNORE_ERRORS parameter does not work.

2011-09-06 10:21  castaglia

	* src/memcache.c:
	  Pedantically fix more compiler warnings.

2011-09-05 13:07  castaglia

	* doc/contrib/mod_sql.html:
	  Fix HTML markup.

2011-09-05 12:26  castaglia

	* contrib/mod_tls_memcache.c:
	  Address a few compiler warnings.

2011-09-05 12:20  castaglia

	* contrib/mod_tls.c:
	  Fix typo causing compiler warninga about "statement with no
	  effect".

2011-09-05 12:19  castaglia

	* src/trace.c:
	  Fix compiler error when compiling with --disable-trace; the
	  pr_trace_vsmg() function was not implemented in that case.

2011-09-02 10:55  castaglia

	* contrib/: README, mod_quotatab_ldap.ldif,
	  mod_quotatab_ldap.schema:
	  Bug#3678 - Include LDAP schema for mod_quotatab_ldap.

2011-09-02 10:23  castaglia

	* doc/contrib/mod_exec.html:
	  Adding mod_exec FAQ.

2011-08-19 09:51  castaglia

	* modules/mod_core.c:
	  Reducing the log level used for the log message about setting the
	  DefaultAddress, so that e.g. heavily loaded proftpd servers using
	  "ServerType inetd" aren't spamming syslog with this message.

2011-08-16 09:13  castaglia

	* src/trace.c:
	  Quell compiler warning on some systems by using an explicit
	  typecast.

2011-08-16 09:13  castaglia

	* contrib/mod_radius.c:
	  Fix the compilation of mod_radius on FreeBSD, which was broken by
	  the patch for Bug#3679, which added support for the
	  NAS-IPv6-Address attribute.  Turns out that the s6_addr32 macro
	  is not available on all systems (e.g.  FreeBSD); hopefully the
	  s6_addr macro is more widely supported.

2011-08-13 12:28  castaglia

	* modules/mod_core.c:
	  Replace the unnecessary (and unchecked) malloc(3) calls -- used
	  when handling the CDPath directive -- with palloc(), which
	  handles out of memory conditions automatically (and is more
	  consistent with the proftpd coding style).

2011-08-13 12:24  castaglia

	* NEWS, src/response.c:
	  Bug#3685 - NULL pointer dereference after an idle timeout.

2011-08-12 10:46  castaglia

	* configure:
	  Updated configure.

2011-08-12 10:41  castaglia

	* NEWS, configure.in:
	  Bug#3681 - Non POSIX test constructions in autoconf script.

2011-08-07 18:50  castaglia

	* contrib/mod_tls.c:
	  Reduce the OpenSSL memory usage for SSL connections (if
	  OpenSSL-1.0.0a or later are used).

2011-08-05 15:49  castaglia

	* doc/contrib/mod_sftp.html:
	  Update the SFTPOptions IgnoreSFTPUploadPerms description to
	  mention directory creation, as per Bug#3680.

2011-08-05 15:48  castaglia

	* NEWS, contrib/mod_sftp/fxp.c,
	  tests/t/lib/ProFTPD/Tests/Modules/mod_sftp.pm:
	  Bug#3680 - SFTP MKDIR does not respect the IgnoreSFTPUploadPerms
	  option.

2011-08-05 10:21  castaglia

	* contrib/mod_radius.c:
	  Better implementation of the NAS-IPv6-Address functionality for
	  Bug#3679.

2011-08-04 15:34  castaglia

	* doc/contrib/mod_radius.html:
	  Mention that mod_radius might use NAS-IPv6-Address in the
	  mod_radius docs.

2011-08-04 15:32  castaglia

	* NEWS, contrib/mod_radius.c:
	  Bug#3679 - Support NAS-IPv6-Address RADIUS attribute.

2011-08-04 14:15  castaglia

	* NEWS, contrib/mod_sftp/auth-hostbased.c,
	  contrib/mod_sftp/auth-kbdint.c, contrib/mod_sftp/auth-password.c,
	  contrib/mod_sftp/auth-publickey.c, contrib/mod_sftp/auth.c,
	  contrib/mod_sftp/auth.h:
	  Bug#3676 - RADIUS-based logins don't work using mod_sftp.

2011-08-03 14:45  castaglia

	* doc/contrib/mod_radius.html:
	  Update the RadiusNASIdentifier docs to mention that it will use
	  "ssh2" for SFTP/SCP sessions.

2011-08-03 14:43  castaglia

	* contrib/mod_radius.c:
	  When setting the NAS-Identifier attribute in the RADIUS request,
	  be sure to dynamically get the protocol, so that we use "ftp" for
	  FTP sessions and "ssh2" for SFTP sessions.

2011-08-02 15:09  castaglia

	* src/scoreboard.c:
	  Fix compiler warning about shadowed variable.

2011-08-02 12:16  castaglia

	* configure:
	  Updated configure.

2011-08-02 12:12  castaglia

	* NEWS, configure.in:
	  Bug#3675 - Automatically disable sendfile support for AIX
	  systems.

2011-08-02 11:24  castaglia

	* contrib/mod_sftp/mod_sftp.c:
	  Fix the compilation of mod_sftp.c (Bug#3677).

2011-08-02 10:10  castaglia

	* src/regexp.c:
	  Remove unused variable.

2011-08-01 11:44  castaglia

	* src/main.c:
	  Defend against possible null cmd_rec argument in
	  pr_cmd_dispatch_phase().

2011-07-31 15:07  castaglia

	* NEWS, modules/mod_ctrls.c:
	  Bug#3674 - After running "proftpd -t" command, ftpdctl commands
	  no longer work.

2011-07-26 14:14  castaglia

	* modules/mod_core.c:
	  Try to make the error logging better, for the case where a client
	  requests a rename of a directory across filesystem mount points.

2011-07-10 11:06  castaglia

	* doc/contrib/mod_tls.html:
	  Updated mod_tls AllowClientRenegotiations TLSOption description
	  to mention CVE-2011-1437.

2011-07-10 11:03  castaglia

	* NEWS, contrib/mod_tls.c:
	  Bug#3671 - TLSOption AllowClientRenegotiations to be
	  unconditionally required for client-initiated renegotiations.

2011-07-10 09:43  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_sftp/wrap2.pm:
	  Adding regression tests for Bug#3670.

2011-07-10 09:42  castaglia

	* NEWS, contrib/mod_sftp/mod_sftp.c:
	  Bug#3670 - WrapDenyMsg not displayed when using mod_wrap2 +
	  mod_sftp.

2011-07-09 10:57  castaglia

	* tests/: tests.pl, t/lib/ProFTPD/Tests/Modules/mod_sftp.pm,
	  t/lib/ProFTPD/Tests/Modules/mod_sftp/wrap2.pm,
	  t/modules/mod_sftp/wrap2.t:
	  Breaking out the mod_sftp+mod_wrap2 unit tests into their own
	  separate file of test cases.

2011-07-09 10:44  castaglia

	* contrib/mod_sftp/: auth-publickey.c, kex.c:
	  Adding comments for my future reference, for when I start adding
	  X509 support to mod_sftp.

2011-07-06 10:14  castaglia

	* doc/modules/mod_facts.html:
	  Adding MLSD/MLST FAQ from forums.

2011-07-02 16:09  castaglia

	* NEWS, src/scoreboard.c:
	  Bug#3668 - File descriptor leak during scoreboard scrubbing.

2011-07-01 11:34  castaglia

	* doc/modules/mod_core.html:
	  Add description of the GroupOwner directive, updated for
	  Bug#3665, to the mod_core HTML docs.

2011-07-01 11:03  castaglia

	* NEWS, src/dirtree.c:
	  Bug#3665 - GID of new files are inherited from parent directory
	  on FreeBSD.

	  The GroupOwner directive is enhanced to use "~" as "GID of
	  logged-in user", to work around the FreeBSD-specific behavior.

2011-06-30 05:20  jwm

	* NEWS: mention the mod_ldap configuration directive overhaul

2011-06-21 11:01  castaglia

	* NEWS, src/scoreboard.c:
	  Bug#3667 - Scoreboard scrubbing can block daemon process for long
	  periods of time.

2011-06-17 16:28  castaglia

	* doc/contrib/mod_sftp.html:
	  Minor updates to the mod_sftp docs for SFTPCiphers, SFTPDigests,
	  and SFTPOptions.

2011-06-17 15:55  castaglia

	* contrib/mod_sftp/kex.c:
	  Add trace logging of the SSH2 session algorithms.  This
	  duplicates info already logged in the SFTPLog, but if you're
	  *only* getting a TraceLog, it helps to have the session
	  algorithms logged there.

2011-06-17 10:53  castaglia

	* tests/t/lib/ProFTPD/Tests/Commands/LIST.pm:
	  Added regression test for "LIST -R", prompted by a forums post
	  saying that ncftp shows an issue with proftpd-1.3.3e's handling
	  of LIST -R.  Couldn't reproduce the reported symptoms with this
	  test case, though.

2011-06-14 15:25  castaglia

	* NEWS, contrib/mod_sftp/fxp.c, contrib/mod_sftp/scp.c:
	  Bug#3664 - mod_sftp does not update process title.

2011-06-09 19:57  castaglia

	* contrib/mod_deflate.c:
	  Add finer-grained trace logging of compressed data transfers.
	  Modify the read() callback slightly to be more efficient (one
	  less branch/block to think through when debugging).

2011-06-09 18:32  castaglia

	* src/scoreboard.c:
	  If we can't open the ScoreboardFile during scrubbing, make sure
	  we log the proper error reason for it.

2011-06-05 18:59  castaglia

	* tests/t/lib/ProFTPD/Tests/Config/HideNoAccess.pm:
	  Add HideNoAccess regression test, trying to reproduce an issue
	  described on forums.proftpd.org.

2011-06-05 16:18  castaglia

	* modules/mod_delay.c:
	  Remove now-unnecessary blank line in 'ftpdctl delay info'
	  response.

2011-06-05 16:17  castaglia

	* modules/mod_delay.c:
	  First, fix the calculation of the row indices; mod_delay was
	  inadvertently trampling on the values in the wrong rows,
	  especially for vhosts.

	  Second, make the output from 'ftpdctl delay info' a little
	  prettier.

2011-06-05 15:45  castaglia

	* src/ctrls.c:
	  Cache errno value for better trace messages.	Fix truncation of
	  Unix domain socket path such that it doesn't trash the call stack
	  (e.g. on Mac OSX) due to bad assumptions about the
	  structure/fields of a struct sockaddr_un.

2011-06-05 10:15  castaglia

	* NEWS, modules/mod_delay.c:
	  Bug#3663 - TimeoutLogin cannot interrupt mod_delay as it should.

2011-06-03 16:15  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_deflate.pm:
	  Add mod_deflate regression test showing read/compress of chunks
	  of upload data.

2011-06-03 09:53  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_deflate.pm:
	  Fix mod_deflate regression tests broken by the addition of the
	  ScoreboardMutex.

2011-05-26 20:13  castaglia

	* doc/modules/mod_core.html:
	  Add docs for the PassivePorts directive to the bundled HTML
	  mod_core doc.

2011-05-26 20:03  castaglia

	* doc/howto/Scoreboard.html:
	  Mention the types of data tracked in the ScoreboardFile for a
	  data transfer, and link to the utilities docs.  This should cover
	  Bug#2625.

2011-05-26 17:38  castaglia

	* src/fsio.c:
	  More caching/setting of errno properly, and fixing a minor memory
	  leak.

2011-05-26 16:41  castaglia

	* modules/mod_core.c:
	  Properly cache/set the errno value before returning PR_ERROR.

2011-05-26 16:15  castaglia

	* tests/: tests.pl,
	  t/lib/ProFTPD/Tests/Modules/mod_quotatab/site_misc.pm,
	  t/modules/mod_quotatab/site_misc.t:
	  Adding regression tests for Bug#3660.

2011-05-26 16:14  castaglia

	* NEWS, contrib/mod_quotatab.c, contrib/mod_site_misc.c:
	  Bug#3660 - SITE MKDIR/RMDIR should update quota tallies properly.

2011-05-26 16:08  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_quotatab_sql.pm:
	  Update the mod_quotatab tests to be a little more resilient
	  during full runs of the testsuite.

2011-05-26 16:08  castaglia

	* contrib/mod_quotatab_sql.c:
	  Remove the checking for underflowing the files used values in
	  mod_quotatab_sql.  The mod_quotatab module already makes such
	  checks.  Plus, the checks at this layer prevent the decrementing
	  of the files used value to zero.

2011-05-26 14:48  castaglia

	* contrib/mod_sql.c:
	  Fix some strncasecmp(3) cases in mod_sql, and convert other
	  strcasecmp(3) to strncasecmp(3).

2011-05-26 14:46  castaglia

	* contrib/mod_copy.c:
	  Allocate the cmd->arg string out of the cmd->pool, NOT out of the
	  cmd->tmp_pool, as the latter pool is cleared after every dispatch
	  phase and the former pool is not.

2011-05-26 11:47  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_quotatab/copy.pm:
	  Forgot to check in the regression tests for the recent work on
	  Bug#3641.

2011-05-25 16:56  castaglia

	* contrib/mod_copy.c:
	  Make mod_copy interact with mod_quotatab such that a recursively
	  copied directory will update the quota tallies properly
	  (Bug#3641).

2011-05-25 16:54  castaglia

	* contrib/mod_quotatab.c:
	  Fix up some minor nits in mod_quotatab, found while working on
	  Bug#3641.

2011-05-25 16:51  castaglia

	* modules/mod_xfer.c:
	  Set errno before returning PR_ERROR.

2011-05-25 09:50  castaglia

	* NEWS, contrib/mod_ifsession.c:
	  Bug#3659 - Segmentation fault if there is regex <IfUser> section
	  in a <VirtualHost> section.

2011-05-24 18:15  castaglia

	* contrib/mod_sftp/fxp.c:
	  The copy-file functionality in mod_sftp needs to interact with
	  e.g.	mod_copy and mod_quotatab properly, which requires that
	  mod_sftp generate a SITE COPY cmd_rec, not a COPY cmd_rec.

2011-05-24 14:38  castaglia

	* contrib/install-sh:
	  Adding install-sh script for contrib/ area.

2011-05-24 14:00  castaglia

	* contrib/mod_sftp/mod_sftp.h.in:
	  The newly added date(1) support in mod_sftp needs to be
	  explicitly enabled via the Protocols directive, rather than being
	  enabled by default.

	  This should preserve the principle of least surprise.  And since
	  this date(1) support is for testing anyway, there's (currently)
	  no reason it should be enabled by default.

2011-05-24 13:55  castaglia

	* contrib/mod_sftp/: Makefile.in, auth.c, channel.c, channel.h,
	  date.c, date.h, mod_sftp.c, mod_sftp.h.in:
	  Adding support for builtin date(1) command, for speed tests
	  related to authentication (versus file transfers via SFTP/SCP).

2011-05-24 10:06  castaglia

	* contrib/mod_sftp/scp.c:
	  Remove redundant setting of the POSIXLY_CORRECT environment
	  variable.

2011-05-23 17:06  castaglia

	* doc/contrib/mod_ctrls_admin.html:
	  Documenting the -n 'ftpdctl kick' option, added for Bug#3555.

2011-05-23 17:04  castaglia

	* NEWS, contrib/mod_ctrls_admin.c:
	  Bug#3555 - Support optional maximum number of clients to be
	  disconnected via 'ftpdctl kick'.

2011-05-23 16:23  castaglia

	* contrib/mod_ban.c, contrib/mod_tls.c, contrib/mod_sftp/scp.c,
	  include/support.h, src/support.c:
	  Refactor all of the getopt(3) resetting code into a single
	  pr_getopt_reset() function than then be used by the interested
	  parties (e.g. mod_ban, mod_sftp, mod_tls).

2011-05-23 14:32  castaglia

	* contrib/mod_wrap2/configure:
	  Updated mod_wrap2 configure.

2011-05-23 14:29  castaglia

	* configure.in, contrib/mod_wrap2/configure.in:
	  Updating FSF address, per Bug#3650.

2011-05-23 14:25  castaglia

	* contrib/ftpasswd, contrib/ftpmail, contrib/ftpquota, src/prxs.in:

	  Updated FSF address, per Bug#3650.

2011-05-23 14:22  castaglia

	* src/auth.c, src/bindings.c, src/child.c, src/class.c, src/cmd.c,
	  src/ctrls.c, src/data.c, src/dirtree.c, src/display.c,
	  src/encode.c, src/env.c, src/event.c, src/expr.c, src/feat.c,
	  src/filter.c, src/fsio.c, src/ftpdctl.c, src/help.c, src/inet.c,
	  src/lastlog.c, src/log.c, src/main.c, src/memcache.c,
	  src/mkhome.c, src/modules.c, src/netacl.c, src/netaddr.c,
	  src/netio.c, src/parser.c, src/pidfile.c, src/pool.c,
	  src/privs.c, src/proctitle.c, src/regexp.c, src/response.c,
	  src/scoreboard.c, src/session.c, src/sets.c, src/stash.c,
	  src/str.c, src/support.c, src/table.c, src/throttle.c,
	  src/timers.c, src/trace.c, src/var.c, src/version.c, src/wtmp.c,
	  src/xferlog.c, COPYING, doc/license.txt:
	  Updating FSF address, per Bug#3650.

2011-05-23 14:11  castaglia

	* modules/: mod_auth.c, mod_auth_file.c, mod_auth_pam.c,
	  mod_auth_unix.c, mod_cap.c, mod_core.c, mod_ctrls.c, mod_delay.c,
	  mod_dso.c, mod_facl.c, mod_facts.c, mod_ident.c, mod_lang.c,
	  mod_log.c, mod_ls.c, mod_memcache.c, mod_site.c, mod_xfer.c:
	  Updated FSF address, per Bug#3650.

2011-05-23 14:08  castaglia

	* doc/mod_sample.c, lib/getopt.c, lib/getopt1.c,
	  lib/glibc-gai_strerror.c, lib/glibc-glob.c, lib/glibc-mkstemp.c,
	  lib/pr_fnmatch.c, lib/pr_fnmatch_loop.c, lib/pwgrent.c,
	  lib/sstrncpy.c, lib/strsep.c, lib/vsnprintf.c:
	  Updated FSF address, per Bug#3650.

2011-05-23 14:03  castaglia

	* contrib/mod_sftp/: auth-hostbased.c, auth-kbdint.c,
	  auth-password.c, auth-publickey.c, auth.c, channel.c, cipher.c,
	  compress.c, crypto.c, disconnect.c, display.c, fxp.c, interop.c,
	  kbdint.c, kex.c, keys.c, keystore.c, mac.c, misc.c, mod_sftp.c,
	  msg.c, packet.c, rfc4716.c, scp.c, service.c, session.c, tap.c,
	  utf8.c:
	  Updating FSF address, per Bug#3650.

2011-05-23 13:56  castaglia

	* contrib/: mod_ban.c, mod_copy.c, mod_ctrls_admin.c,
	  mod_deflate.c, mod_dynmasq.c, mod_exec.c, mod_ifsession.c,
	  mod_ifversion.c, mod_ldap.c, mod_qos.c, mod_quotatab.c,
	  mod_quotatab_file.c, mod_quotatab_ldap.c, mod_quotatab_radius.c,
	  mod_quotatab_sql.c, mod_radius.c, mod_ratio.c, mod_readme.c,
	  mod_rewrite.c, mod_sftp_pam.c, mod_sftp_sql.c, mod_shaper.c,
	  mod_site_misc.c, mod_sql.c, mod_sql_mysql.c, mod_sql_odbc.c,
	  mod_sql_passwd.c, mod_sql_postgres.c, mod_sql_sqlite.c,
	  mod_tls_memcache.c, mod_tls_shmcache.c, mod_unique_id.c,
	  mod_wrap.c, mod_wrap2_file.c, mod_wrap2_sql.c,
	  mod_load/mod_load.c.in, mod_wrap2/mod_wrap2.c:
	  Updating FSF address, per Bug#3650.

2011-05-23 13:50  castaglia

	* tests/api/: array.c, class.c, cmd.c, env.c, event.c, expr.c,
	  feat.c, modules.c, netacl.c, netaddr.c, pool.c, regexp.c,
	  scoreboard.c, sets.c, stash.c, str.c, stubs.c, table.c, tests.c,
	  timers.c, var.c, version.c:
	  Updating FSF address, per Bug#3650.

2011-05-23 13:44  castaglia

	* contrib/mod_quotatab.h, contrib/mod_sql.h, contrib/mod_tls.h,
	  contrib/mod_sftp/mod_sftp.h.in, contrib/mod_wrap2/mod_wrap2.h.in,
	  lib/getopt.h, tests/api/tests.h, utils/ftpcount.c,
	  utils/ftpscrub.c, utils/ftpshut.c, utils/ftptop.c,
	  utils/ftpwho.c, utils/misc.c, utils/scoreboard.c:
	  Updating FSF address, per Bug#3650.

2011-05-23 13:40  castaglia

	* contrib/mod_sftp/: auth.h, channel.h, cipher.h, compress.h,
	  crypto.h, disconnect.h, display.h, fxp.h, interop.h, kbdint.h,
	  kex.h, keys.h, keystore.h, mac.h, misc.h, msg.h, packet.h,
	  rfc4716.h, scp.h, service.h, session.h, ssh2.h, tap.h, utf8.h:
	  Updating FSF address, per Bug#3650.

2011-05-23 13:35  castaglia

	* include/auth.h, include/bindings.h, include/child.h,
	  include/class.h, include/cmd.h, include/compat.h, include/conf.h,
	  include/ctrls.h, include/data.h, include/default_paths.h,
	  include/dirtree.h, include/display.h, include/encode.h,
	  include/env.h, include/event.h, include/expr.h, include/feat.h,
	  include/filter.h, include/fsio.h, include/ftp.h,
	  include/glibc-glob.h, include/help.h, include/inet.h,
	  include/libsupp.h, include/log.h, include/memcache.h,
	  include/mkhome.h, include/mod_ctrls.h, include/modules.h,
	  include/netacl.h, include/netaddr.h, include/netio.h,
	  include/options.h, include/parser.h, include/pidfile.h,
	  include/pool.h, include/pr-syslog.h, include/privs.h,
	  include/proctitle.h, include/proftpd.h, include/regexp.h,
	  include/response.h, include/scoreboard.h, include/session.h,
	  include/sets.h, include/stash.h, include/str.h,
	  include/support.h, include/table.h, include/throttle.h,
	  include/timers.h, include/trace.h, include/var.h,
	  include/xferlog.h, utils/utils.h:
	  Updating the FSF address, per Bug#3650.

2011-05-23 13:25  castaglia

	* COPYING:
	  Updating FSF address, per Bug#3650.

2011-05-20 15:00  castaglia

	* contrib/mod_tls.c:
	  Don't allow client certs if they point to an OCSP responder whose
	  response says that the OCSP responder doesn't know about the
	  client cert.

2011-05-20 14:55  castaglia

	* contrib/mod_tls.c:
	  Clarify the certificate revocation callback code a little, and
	  add some comments on edge cases to handle better.

2011-05-20 11:16  castaglia

	* contrib/mod_tls.c:
	  Fixed cases of strncmp(3) to use strncmp(3), and strcasecmp(3) to
	  be strncasecmp(3), as the 'n' variants are more efficient (saves
	  on a strlen(3) call internally).

	  Reworked the OCSP verification code so that it works properly.

2011-05-20 11:14  castaglia

	* tests/t/: etc/modules/mod_tls/NOTES,
	  lib/ProFTPD/Tests/Modules/mod_tls.pm:
	  Adding regression tests for the TLSVerifyOrder directive, for
	  both 'crl' and 'ocsp' (separately).

	  Updates NOTES to mention how to generate certs with OCSP
	  attributes, running OpenSSL's ocsp(1) as responder (and client),
	  issues found, etc.

2011-05-20 11:02  castaglia

	* tests/t/etc/modules/mod_tls/: ocsp-ca.pem, ocsp-client.pem,
	  ocsp-server.pem, ocsp-https-ca.pem, ocsp-https-client.pem,
	  ocsp-https-server.pem:
	  Adding certs/files for OCSP verification tests.

2011-05-19 15:56  castaglia

	* NEWS, contrib/mod_tls.c:
	  Backport of fix for Bug#3658.

2011-05-19 15:56  castaglia

	* NEWS, contrib/mod_tls.c:
	  Bug#3658 - TLSVerifyOrder directive is broken.

2011-05-19 11:26  castaglia

	* doc/howto/Testing.html:
	  Mention the brittleness of the 127.0.0.1/localhost-related tests
	  in the Testing howto, and mention how they are "expected
	  failures".

2011-05-18 13:35  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_tls.pm:
	  Update the mod_tls CRL regression test to use the
	  newly-generated/updated CRL test files.

2011-05-18 13:23  castaglia

	* tests/t/etc/modules/mod_tls/NOTES:
	  Updated mod_tls notes with how to generate CRL regression test
	  certs (I really mean it this time!).

2011-05-18 13:22  castaglia

	* tests/t/etc/modules/mod_tls/: crl-ca-revoked.pem, crl-ca.pem,
	  crl-client-cert.pem, crl-server-cert.pem:
	  Added new CA, server/client certs, and CRL PEM files for the CRL
	  revocation regression test.

	  Updated the NOTES file with instructions on how to generate the
	  above files.

2011-05-18 10:29  castaglia

	* tests/t/etc/modules/mod_quotatab_file/: NOTES, ftpquota.limittab,
	  ftpquota.tallytab:
	  Remove the broken file tables for the group quota test.  Add
	  notes for how the file tables were generated, for future
	  reference.

2011-05-18 10:24  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_quotatab_file.pm:
	  Update the group quota regression test to use the fixed table
	  files.

2011-05-18 10:22  castaglia

	* tests/t/etc/modules/mod_quotatab_file/: ftpquota-group-limit.tab,
	  ftpquota-group-tally.tab:
	  Fixing the group quota file-based tables for the
	  mod_quotatab_file regression test.

2011-05-18 10:15  castaglia

	* tests/t/etc/modules/mod_quotatab_file/: ftpquota-all-limit.tab,
	  ftpquota-all-tally.tab:
	  Adding the limit/tally file tables for the ALL regression test.

2011-05-18 10:13  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_quotatab_file.pm:
	  Adding regression test involving file-based quota tables and an
	  ALL quota (from the forums).

2011-05-18 08:18  castaglia

	* configure:
	  Updated configure.

2011-05-18 08:13  castaglia

	* configure.in:
	  Fix --disable-strip logic.

2011-05-17 22:46  castaglia

	* doc/contrib/mod_wrap2.html:
	  Fix typos in the mod_wrap2 docs.

2011-05-17 22:23  castaglia

	* contrib/mod_sftp/packet.c:
	  Refactor the ssh2_sftp_packet_read() function, moving some of the
	  special-case handling of SSH messages like DEBUG, IGNORE,
	  UNIMPLEMENTED et al into the ssh2_sftp_packet_handle() function,
	  where all of the other SSH message types are handled.  Now all of
	  the message types are handled in the same function, in the same
	  way.

2011-05-17 10:25  castaglia

	* NEWS, modules/mod_xfer.c:
	  Bug#3656 - Prefer "File too big" error message for
	  MaxStoreFilesize.

2011-05-16 10:42  castaglia

	* modules/mod_xfer.c:
	  Another typo.

2011-05-16 09:12  castaglia

	* modules/mod_xfer.c:
	  Typo.

2011-05-15 16:04  castaglia

	* contrib/mod_sftp/packet.c:
	  Leaving notes for myself about the use of TCP_CORK/TCP_NOPUSH
	  when sending SSH messages.

2011-05-15 16:03  castaglia

	* include/inet.h, modules/mod_xfer.c, src/inet.c:
	  Refactor pr_inet_set_proto_opts(), breaking out the
	  TCP_CORK/TCP_NOPUSH functionality into a new
	  pr_inet_set_proto_cork() function.  This was done to test using
	  TCP_CORK/TCP_NOPUSH in mod_sftp.

2011-05-15 15:54  castaglia

	* contrib/mod_sftp/: packet.c, packet.h, tap.c:
	  Refactor mod_sftp's packet functions a little, removing the
	  circular calling between sftp_ssh2_packet_write() and
	  sftp_tap_send_packet(). This allows us to remove the ugly hack in
	  the TAP code.

	  Also included the number of bytes written out by writev(2), so
	  that we can get a better idea of the sizes of the messages being
	  written to the network.  This helps when looking at things like
	  MSS, delayed ACKs, Nagle, etc.

2011-05-13 12:00  castaglia

	* contrib/mod_sftp/mod_sftp.c:
	  Provide better error message for SFTPClientMatch values
	  configured to be zero.

2011-05-13 08:56  castaglia

	* NEWS, src/main.c:
	  Bug#3653 - Segfault with "DefaultServer off" and no matching
	  server for incoming IP address.

2011-05-13 08:34  castaglia

	* configure:
	  Updated configure.

2011-05-13 08:29  castaglia

	* configure.in:
	  Renaming --enable-symbols configure option, added for Bug#3651,
	  to be --disable-strip (which is what OpenSSH uses).

2011-05-12 21:40  castaglia

	* doc/contrib/mod_sftp.html:
	  Typo.

2011-05-12 20:38  castaglia

	* contrib/mod_sftp/keys.c:
	  Fix typo in comment.

2011-05-11 09:09  castaglia

	* doc/howto/TLS.html:
	  Added TLS FAQ/example config for requring FTPS for remote clients
	  but allowing just FTP for local clients.

2011-05-10 19:14  castaglia

	* contrib/mod_wrap.c:
	  Backport of the additional fixes for Bug#3652.

2011-05-10 19:14  castaglia

	* contrib/mod_wrap.c:
	  Additional fixes for Bug#3652.

2011-05-10 17:38  castaglia

	* contrib/mod_sftp/fxp.c:
	  Add proper dispatching through PRE_CMD phase handlers for the
	  FSETSTAT SFTP request, including the path of the file being
	  changed (not the filehandle).

2011-05-09 13:37  castaglia

	* NEWS, contrib/mod_wrap.c:
	  Backport of fix for Bug#3652 to 1.3.3 branch.

2011-05-09 13:36  castaglia

	* NEWS, contrib/mod_wrap.c:
	  Bug#3652 - TCPAccessSyslogLevel directive broken by Bug#3317.

2011-05-08 12:27  castaglia

	* configure:
	  Updated configure.

2011-05-08 12:25  castaglia

	* configure.in:
	  Backport of addition of --enable-symbols configure option to
	  1.3.3 branch, for Bug#3651.

2011-05-08 12:24  castaglia

	* contrib/: mod_load/Makefile.in, mod_sftp/Makefile.in,
	  mod_wrap2/Makefile.in:
	  Backport of changes for Bug#3651 to 1.3.3 branch.

2011-05-08 11:03  castaglia

	* configure:
	  Updated configure.

2011-05-08 10:47  castaglia

	* configure.in:
	  Adding --enable-symbols configure option, to generate proftpd
	  code which is not stripped of code symbols at install time
	  (Bug#3651).

2011-05-07 18:18  castaglia

	* contrib/: mod_load/Makefile.in, mod_sftp/Makefile.in,
	  mod_wrap2/Makefile.in:
	  Minor cleanups of paths, removing some double-slash occurrences
	  (pointed out in Bug#3651).

2011-05-05 15:55  castaglia

	* modules/mod_facts.c:
	  Update mod_facts to use the new defines for the MFF and MFMT
	  commands.

2011-05-05 15:54  castaglia

	* include/cmd.h, include/ftp.h, src/cmd.c:
	  Include defines ands IDs for the MFF and MFMT commands.  Add
	  define (not ID yet) for the HOST command.

2011-05-05 15:34  castaglia

	* modules/mod_ls.c:
	  Remove now-unused variable declaration.

2011-05-04 14:45  castaglia

	* contrib/mod_sftp/fxp.c:
	  Fix issues with mod_sftp's handling of the RMDIR and REMOVE
	  requests with regard to PRE_CMD handlers.

2011-05-02 17:18  castaglia

	* modules/mod_core.c:
	  If the system defines the SOMAXCONN limit, then make sure that a
	  configured TCPBacklog value does not exceed that limit.

2011-05-02 11:07  castaglia

	* contrib/: mod_quotatab_sql.c, mod_sql_passwd.c:
	  More idiomatic check for DECLINED/null results.

2011-05-01 09:41  jwm

	* Makefile.in: - execute the clean target in tests/, too - remove
	  some Makefiles on distclean that were sneaking their way into
	  release tarballs

2011-04-30 21:32  castaglia

	* contrib/mod_ban.c, contrib/mod_deflate.c,
	  contrib/mod_quotatab_sql.c, contrib/mod_rewrite.c,
	  contrib/mod_sql.c, contrib/mod_sql_passwd.c, contrib/mod_tls.c,
	  contrib/mod_sftp/auth.c, contrib/mod_sftp/channel.c,
	  contrib/mod_sftp/cipher.c, contrib/mod_sftp/kex.c,
	  contrib/mod_sftp/packet.c, contrib/mod_sftp/rfc4716.c,
	  contrib/mod_sftp/scp.c, contrib/mod_sftp/utf8.c, lib/pr-syslog.c,
	  modules/mod_auth.c, modules/mod_core.c, modules/mod_facts.c,
	  modules/mod_ls.c, modules/mod_xfer.c, src/auth.c, src/ctrls.c,
	  src/encode.c, src/help.c, src/inet.c, src/main.c, src/netaddr.c,
	  src/scoreboard.c, src/stash.c, src/table.c, utils/ftpcount.c,
	  utils/ftptop.c, utils/ftpwho.c:
	  Fix up various small issues found by Apple's clang static source
	  code analysis tool.

2011-04-30 16:04  castaglia

	* lib/tpl.c:
	  Fixing nits in libtpl found by Apple's clang static source code
	  analysis tool.

2011-04-30 15:46  castaglia

	* modules/mod_delay.c:
	  Fix nit found by Apple's clang static source code analysis tool.

2011-04-30 15:42  castaglia

	* src/pool.c:
	  Adding comment describing why the logic in null_alloc() is as
	  intended, for future reference.

2011-04-30 15:29  castaglia

	* modules/mod_facts.c:
	  Fix up minor nits pointed out by Apple'c clang static code
	  analysis tool.

2011-04-29 15:47  castaglia

	* modules/mod_auth.c:
	  Paranoidly guard against possible NULL pointer dereference (found
	  by Klocwork static source code analysis).

2011-04-29 15:32  castaglia

	* NEWS, modules/mod_xfer.c:
	  Bug#3649 - MaxStoreFileSize can be bypassed using REST/APPE.

